package Math::BigInt;use 5.006001;use strict;use warnings;use Carp qw<carp croak>;our$VERSION='1.999816';require Exporter;our@ISA=qw(Exporter);our@EXPORT_OK=qw(objectify bgcd blcm);my$class="Math::BigInt";use overload '+'=>sub {$_[0]-> copy()-> badd($_[1])},'-'=>sub {my$c=$_[0]-> copy;$_[2]? $c -> bneg()-> badd($_[1]): $c -> bsub($_[1])},'*'=>sub {$_[0]-> copy()-> bmul($_[1])},'/'=>sub {$_[2]? ref($_[0])-> new($_[1])-> bdiv($_[0]): $_[0]-> copy -> bdiv($_[1])},'%'=>sub {$_[2]? ref($_[0])-> new($_[1])-> bmod($_[0]): $_[0]-> copy -> bmod($_[1])},'**'=>sub {$_[2]? ref($_[0])-> new($_[1])-> bpow($_[0]): $_[0]-> copy -> bpow($_[1])},'<<'=>sub {$_[2]? ref($_[0])-> new($_[1])-> blsft($_[0]): $_[0]-> copy -> blsft($_[1])},'>>'=>sub {$_[2]? ref($_[0])-> new($_[1])-> brsft($_[0]): $_[0]-> copy -> brsft($_[1])},'+='=>sub {$_[0]->badd($_[1])},'-='=>sub {$_[0]->bsub($_[1])},'*='=>sub {$_[0]->bmul($_[1])},'/='=>sub {scalar $_[0]->bdiv($_[1])},'%='=>sub {$_[0]->bmod($_[1])},'**='=>sub {$_[0]->bpow($_[1])},'<<='=>sub {$_[0]->blsft($_[1])},'>>='=>sub {$_[0]->brsft($_[1])},'<'=>sub {$_[2]? ref($_[0])-> new($_[1])-> blt($_[0]): $_[0]-> blt($_[1])},'<='=>sub {$_[2]? ref($_[0])-> new($_[1])-> ble($_[0]): $_[0]-> ble($_[1])},'>'=>sub {$_[2]? ref($_[0])-> new($_[1])-> bgt($_[0]): $_[0]-> bgt($_[1])},'>='=>sub {$_[2]? ref($_[0])-> new($_[1])-> bge($_[0]): $_[0]-> bge($_[1])},'=='=>sub {$_[0]-> beq($_[1])},'!='=>sub {$_[0]-> bne($_[1])},'<=>'=>sub {my$cmp=$_[0]-> bcmp($_[1]);defined($cmp)&& $_[2]? -$cmp : $cmp},'cmp'=>sub {$_[2]? "$_[1]" cmp $_[0]-> bstr(): $_[0]-> bstr()cmp "$_[1]"},'&'=>sub {$_[2]? ref($_[0])-> new($_[1])-> band($_[0]): $_[0]-> copy -> band($_[1])},'&='=>sub {$_[0]-> band($_[1])},'|'=>sub {$_[2]? ref($_[0])-> new($_[1])-> bior($_[0]): $_[0]-> copy -> bior($_[1])},'|='=>sub {$_[0]-> bior($_[1])},'^'=>sub {$_[2]? ref($_[0])-> new($_[1])-> bxor($_[0]): $_[0]-> copy -> bxor($_[1])},'^='=>sub {$_[0]-> bxor($_[1])},'neg'=>sub {$_[0]-> copy()-> bneg()},'~'=>sub {$_[0]-> copy()-> bnot()},'++'=>sub {$_[0]-> binc()},'--'=>sub {$_[0]-> bdec()},'atan2'=>sub {$_[2]? ref($_[0])-> new($_[1])-> batan2($_[0]): $_[0]-> copy()-> batan2($_[1])},'cos'=>sub {$_[0]-> copy -> bcos()},'sin'=>sub {$_[0]-> copy -> bsin()},'exp'=>sub {$_[0]-> copy()-> bexp($_[1])},'abs'=>sub {$_[0]-> copy()-> babs()},'log'=>sub {$_[0]-> copy()-> blog()},'sqrt'=>sub {$_[0]-> copy()-> bsqrt()},'int'=>sub {$_[0]-> copy()-> bint()},'bool'=>sub {$_[0]-> is_zero()? '' : 1},'""'=>sub {$_[0]-> bstr()},'0+'=>sub {$_[0]-> numify()},'='=>sub {$_[0]->copy()},;our$round_mode='even';our$accuracy=undef;our$precision=undef;our$div_scale=40;our$upgrade=undef;our$downgrade=undef;our$_trap_nan=0;our$_trap_inf=0;my$nan='NaN';my$LIB='Math::BigInt::Calc';my$IMPORT=0;my%WARN;my%CALLBACKS;my$EMU_LIB='Math/BigInt/CalcEmu.pm';our$rnd_mode='even';sub TIESCALAR {my ($class)=@_;bless \$round_mode,$class}sub FETCH {return$round_mode}sub STORE {$rnd_mode=$_[0]->round_mode($_[1])}BEGIN {tie$rnd_mode,'Math::BigInt';*as_int=\&as_number;*is_pos=\&is_positive;*is_neg=\&is_negative}sub round_mode {no strict 'refs';my$self=shift;my$class=ref($self)|| $self || __PACKAGE__;if (defined $_[0]){my$m=shift;if ($m !~ /^(even|odd|\+inf|\-inf|zero|trunc|common)$/){croak("Unknown round mode '$m'")}return ${"${class}::round_mode"}=$m}${"${class}::round_mode"}}sub upgrade {no strict 'refs';my$self=shift;my$class=ref($self)|| $self || __PACKAGE__;if (@_ > 0){return ${"${class}::upgrade"}=$_[0]}${"${class}::upgrade"}}sub downgrade {no strict 'refs';my$self=shift;my$class=ref($self)|| $self || __PACKAGE__;if (@_ > 0){return ${"${class}::downgrade"}=$_[0]}${"${class}::downgrade"}}sub div_scale {no strict 'refs';my$self=shift;my$class=ref($self)|| $self || __PACKAGE__;if (defined $_[0]){if ($_[0]< 0){croak('div_scale must be greater than zero')}${"${class}::div_scale"}=$_[0]}${"${class}::div_scale"}}sub accuracy {my$x=shift;my$class=ref($x)|| $x || __PACKAGE__;no strict 'refs';if (@_ > 0){my$a=shift;if (defined$a){$a=$a->numify()if ref($a)&& $a->can('numify');if (!$a || $a <= 0){croak('Argument to accuracy must be greater than zero')}if (int($a)!=$a){croak('Argument to accuracy must be an integer')}}if (ref($x)){$x->bround($a)if$a;$x->{_a}=$a;delete$x->{_p};$a=${"${class}::accuracy"}unless defined$a}else {${"${class}::accuracy"}=$a;${"${class}::precision"}=undef}return$a}return$x->{_a}if ref($x)&& (defined$x->{_a}|| defined$x->{_p});return ${"${class}::accuracy"}}sub precision {my$x=shift;my$class=ref($x)|| $x || __PACKAGE__;no strict 'refs';if (@_ > 0){my$p=shift;if (defined$p){$p=$p->numify()if ref($p)&& $p->can('numify');if ($p!=int$p){croak('Argument to precision must be an integer')}}if (ref($x)){$x->bfround($p)if$p;$x->{_p}=$p;delete$x->{_a};$p=${"${class}::precision"}unless defined$p}else {${"${class}::precision"}=$p;${"${class}::accuracy"}=undef}return$p}return$x->{_p}if ref($x)&& (defined$x->{_a}|| defined$x->{_p});return ${"${class}::precision"}}sub config {my$class=shift || __PACKAGE__;no strict 'refs';if (@_ > 1 || (@_==1 && (ref($_[0])eq 'HASH'))){my$args=$_[0];if (ref($args)ne 'HASH'){$args={@_ }}my$set_args={};for my$key (qw/accuracy precision round_mode div_scale upgrade downgrade trap_inf trap_nan/){$set_args->{$key}=$args->{$key}if exists$args->{$key};delete$args->{$key}}if (keys %$args > 0){croak("Illegal key(s) '",join("', '",keys %$args),"' passed to $class\->config()")}for my$key (keys %$set_args){if ($key =~ /^trap_(inf|nan)\z/){${"${class}::_trap_$1"}=($set_args->{"trap_$1"}? 1 : 0);next}$class->$key($set_args->{$key})}}my$cfg={lib=>$LIB,lib_version=>${"${LIB}::VERSION"},class=>$class,trap_nan=>${"${class}::_trap_nan"},trap_inf=>${"${class}::_trap_inf"},version=>${"${class}::VERSION"},};for my$key (qw/accuracy precision round_mode div_scale upgrade downgrade/){$cfg->{$key}=${"${class}::$key"}}if (@_==1 && (ref($_[0])ne 'HASH')){return$cfg->{$_[0]}}$cfg}sub _scale_a {my ($x,$scale,$mode)=@_;$scale=$x->{_a}unless defined$scale;no strict 'refs';my$class=ref($x);$scale=${$class .'::accuracy'}unless defined$scale;$mode=${$class .'::round_mode'}unless defined$mode;if (defined$scale){$scale=$scale->can('numify')? $scale->numify(): "$scale" if ref($scale);$scale=int($scale)}($scale,$mode)}sub _scale_p {my ($x,$scale,$mode)=@_;$scale=$x->{_p}unless defined$scale;no strict 'refs';my$class=ref($x);$scale=${$class .'::precision'}unless defined$scale;$mode=${$class .'::round_mode'}unless defined$mode;if (defined$scale){$scale=$scale->can('numify')? $scale->numify(): "$scale" if ref($scale);$scale=int($scale)}($scale,$mode)}sub new {my$self=shift;my$selfref=ref$self;my$class=$selfref || $self;return$self->bzero()unless @_;my ($wanted,$a,$p,$r)=@_;$self=$selfref ? $self -> copy(): bless {},$class;unless (defined$wanted){return$self->bzero($a,$p,$r)}if (ref($wanted)&& $wanted->isa($class)){my$copy=$class -> copy($wanted);if ($selfref){%$self=%$copy}else {$self=$copy}return$self}$class->import()if$IMPORT==0;if (!ref($wanted)&& $wanted =~ / ^
                     ([+-]?)            # optional sign
                     ([1-9][0-9]*)      # non-zero significand
                     (\.0*)?            # ... with optional zero fraction
                     ([Ee][+-]?0+)?     # optional zero exponent
                     \z
                   /x){my$sgn=$1;my$abs=$2;$self->{sign}=$sgn || '+';$self->{value}=$LIB->_new($abs);no strict 'refs';if (defined($a)|| defined($p)|| defined(${"${class}::precision"})|| defined(${"${class}::accuracy"})){$self->round($a,$p,$r)unless @_ >= 3 &&!defined$a &&!defined$p}return$self}if ($wanted =~ /^\s*([+-]?)inf(inity)?\s*\z/i){my$sgn=$1 || '+';$self->{sign}=$sgn .'inf';return$class->binf($sgn)}if ($wanted =~ /^\s*([+-]?)nan\s*\z/i){$self=$class -> bnan();$self->round($a,$p,$r)unless @_ >= 3 &&!defined$a &&!defined$p;return$self}if ($wanted =~ /^\s*[+-]?0[Xx]/){$self=$class -> from_hex($wanted);$self->round($a,$p,$r)unless @_ >= 3 &&!defined$a &&!defined$p;return$self}if ($wanted =~ /^\s*[+-]?0[Bb]/){$self=$class -> from_bin($wanted);$self->round($a,$p,$r)unless @_ >= 3 &&!defined$a &&!defined$p;return$self}my ($mis,$miv,$mfv,$es,$ev)=_split($wanted);if (!ref$mis){if ($_trap_nan){croak("$wanted is not a number in $class")}$self->{value}=$LIB->_zero();$self->{sign}=$nan;return$self}if (!ref$miv){$self->{value}=$mis->{value};$self->{sign}=$mis->{sign};return$self}$self->{sign}=$$mis;$self->{value}=$LIB->_zero();my$e=int("$$es$$ev");if ($e > 0){my$diff=$e - CORE::length($$mfv);if ($diff < 0){if ($_trap_nan){croak("$wanted not an integer in $class")}return$upgrade->new($wanted,$a,$p,$r)if defined$upgrade;$self->{sign}=$nan}else {$$miv=$$miv .($$mfv .'0' x $diff)}}else {if ($$mfv ne ''){if ($_trap_nan){croak("$wanted not an integer in $class")}return$upgrade->new($wanted,$a,$p,$r)if defined$upgrade;$self->{sign}=$nan}elsif ($e < 0){my$frac=substr($$miv,$e);substr($$miv,$e)="";if ($frac =~ /[^0]/){if ($_trap_nan){croak("$wanted not an integer in $class")}return$upgrade->new($wanted,$a,$p,$r)if defined$upgrade;$self->{sign}=$nan}}}unless ($self->{sign}eq $nan){$self->{sign}='+' if $$miv eq '0';$self->{value}=$LIB->_new($$miv)if$self->{sign}=~ /^[+-]$/}$self->round($a,$p,$r)unless @_ >= 3 &&!defined$a &&!defined$p;$self}sub from_hex {my$self=shift;my$selfref=ref$self;my$class=$selfref || $self;return if$selfref && $self->modify('from_hex');my$str=shift;$self=$class -> bzero()unless$selfref;if ($str =~ s/
                     ^
                     \s*
                     ( [+-]? )
                     (0?x)?
                     (
                         [0-9a-fA-F]*
                         ( _ [0-9a-fA-F]+ )*
                     )
                     \s*
                     $
                 //x){my$sign=$1;my$chrs=$3;$chrs =~ tr/_//d;$chrs='0' unless CORE::length$chrs;$self->{value}=$LIB->_from_hex('0x' .$chrs);$self->{sign}=$sign eq '-' &&!$LIB->_is_zero($self->{value})? '-' : '+';return$self}return$self->bnan()}sub from_oct {my$self=shift;my$selfref=ref$self;my$class=$selfref || $self;return if$selfref && $self->modify('from_oct');my$str=shift;$self=$class -> bzero()unless$selfref;if ($str =~ s/
                     ^
                     \s*
                     ( [+-]? )
                     (
                         [0-7]*
                         ( _ [0-7]+ )*
                     )
                     \s*
                     $
                 //x){my$sign=$1;my$chrs=$2;$chrs =~ tr/_//d;$chrs='0' unless CORE::length$chrs;$self->{value}=$LIB->_from_oct('0' .$chrs);$self->{sign}=$sign eq '-' &&!$LIB->_is_zero($self->{value})? '-' : '+';return$self}return$self->bnan()}sub from_bin {my$self=shift;my$selfref=ref$self;my$class=$selfref || $self;return if$selfref && $self->modify('from_bin');my$str=shift;$self=$class -> bzero()unless$selfref;if ($str =~ s/
                     ^
                     \s*
                     ( [+-]? )
                     (0?b)?
                     (
                         [01]*
                         ( _ [01]+ )*
                     )
                     \s*
                     $
                 //x){my$sign=$1;my$chrs=$3;$chrs =~ tr/_//d;$chrs='0' unless CORE::length$chrs;$self->{value}=$LIB->_from_bin('0b' .$chrs);$self->{sign}=$sign eq '-' &&!$LIB->_is_zero($self->{value})? '-' : '+';return$self}return$self->bnan()}sub from_bytes {my$self=shift;my$selfref=ref$self;my$class=$selfref || $self;return if$selfref && $self->modify('from_bytes');croak("from_bytes() requires a newer version of the $LIB library.")unless$LIB->can('_from_bytes');my$str=shift;$self=$class -> bzero()unless$selfref;$self -> {sign}='+';$self -> {value}=$LIB -> _from_bytes($str);return$self}sub from_base {my$self=shift;my$selfref=ref$self;my$class=$selfref || $self;return if$selfref && $self->modify('from_base');my$str=shift;my$base=shift;$base=$class->new($base)unless ref($base);croak("the base must be a finite integer >= 2")if$base < 2 ||!$base -> is_int();$self=$class -> bzero()unless$selfref;if (!@_){return$self -> from_bin($str)if$base==2;return$self -> from_oct($str)if$base==8;return$self -> from_hex($str)if$base==16;if ($base==10){my$tmp=$class -> new($str);$self -> {value}=$tmp -> {value};$self -> {sign}='+'}}croak("from_base() requires a newer version of the $LIB library.")unless$LIB->can('_from_base');$self -> {sign}='+';$self -> {value}=$LIB->_from_base($str,$base -> {value},@_ ? shift(): ());return$self}sub bzero {if (@_==0){unshift @_,__PACKAGE__}my$self=shift;my$selfref=ref$self;my$class=$selfref || $self;$self->import()if$IMPORT==0;return if$selfref && $self->modify('bzero');$self=bless {},$class unless$selfref;$self->{sign}='+';$self->{value}=$LIB->_zero();if (@_){croak "can't specify both accuracy and precision" if @_ >= 2 && defined $_[0]&& defined $_[1];$self->{_a}=$_[0];$self->{_p}=$_[1]}else {unless($selfref){$self->{_a}=$class -> accuracy();$self->{_p}=$class -> precision()}}return$self}sub bone {if (@_==0 || (defined($_[0])&& ($_[0]eq '+' || $_[0]eq '-'))){unshift @_,__PACKAGE__}my$self=shift;my$selfref=ref$self;my$class=$selfref || $self;$self->import()if$IMPORT==0;return if$selfref && $self->modify('bone');my$sign='+';if (@_){$sign=shift;$sign=$sign =~ /^\s*-/ ? "-" : "+"}$self=bless {},$class unless$selfref;$self->{sign}=$sign;$self->{value}=$LIB->_one();if (@_){croak "can't specify both accuracy and precision" if @_ >= 2 && defined $_[0]&& defined $_[1];$self->{_a}=$_[0];$self->{_p}=$_[1]}else {unless($selfref){$self->{_a}=$class -> accuracy();$self->{_p}=$class -> precision()}}return$self}sub binf {if (@_==0 || (defined($_[0])&&!ref($_[0])&& $_[0]=~ /^\s*[+-](inf(inity)?)?\s*$/)){unshift @_,__PACKAGE__}my$self=shift;my$selfref=ref$self;my$class=$selfref || $self;{no strict 'refs';if (${"${class}::_trap_inf"}){croak("Tried to create +-inf in $class->binf()")}}$self->import()if$IMPORT==0;return if$selfref && $self->modify('binf');my$sign=shift;$sign=defined$sign && $sign =~ /^\s*-/ ? "-" : "+";$self=bless {},$class unless$selfref;$self -> {sign}=$sign .'inf';$self -> {value}=$LIB -> _zero();if (@_){croak "can't specify both accuracy and precision" if @_ >= 2 && defined $_[0]&& defined $_[1];$self->{_a}=$_[0];$self->{_p}=$_[1]}else {unless($selfref){$self->{_a}=$class -> accuracy();$self->{_p}=$class -> precision()}}return$self}sub bnan {if (@_==0){unshift @_,__PACKAGE__}my$self=shift;my$selfref=ref($self);my$class=$selfref || $self;{no strict 'refs';if (${"${class}::_trap_nan"}){croak("Tried to create NaN in $class->bnan()")}}$self->import()if$IMPORT==0;return if$selfref && $self->modify('bnan');$self=bless {},$class unless$selfref;$self -> {sign}=$nan;$self -> {value}=$LIB -> _zero();return$self}sub bpi {my ($self,$n)=@_;if (@_==1){$n=$self;$self=$class}$self=ref($self)if ref($self);return$upgrade->new($n)if defined$upgrade;$self->new(3)}sub copy {my$self=shift;my$selfref=ref$self;my$class=$selfref || $self;$self=shift()unless$selfref;my$copy=bless {},$class;$copy->{sign}=$self->{sign};$copy->{value}=$LIB->_copy($self->{value});$copy->{_a}=$self->{_a}if exists$self->{_a};$copy->{_p}=$self->{_p}if exists$self->{_p};return$copy}sub as_number {$_[0]->copy()}sub is_zero {my ($class,$x)=ref($_[0])? (undef,$_[0]): objectify(1,@_);return 0 if$x->{sign}!~ /^\+$/;$LIB->_is_zero($x->{value})}sub is_one {my ($class,$x,$sign)=ref($_[0])? (undef,@_): objectify(1,@_);$sign='+' if!defined$sign || $sign ne '-';return 0 if$x->{sign}ne $sign;$LIB->_is_one($x->{value})}sub is_finite {my$x=shift;return$x->{sign}eq '+' || $x->{sign}eq '-'}sub is_inf {my ($class,$x,$sign)=ref($_[0])? (undef,@_): objectify(1,@_);if (defined$sign){$sign='[+-]inf' if$sign eq '';$sign="[$1]inf" if$sign =~ /^([+-])(inf)?$/;return$x->{sign}=~ /^$sign$/ ? 1 : 0}$x->{sign}=~ /^[+-]inf$/ ? 1 : 0}sub is_nan {my ($class,$x)=ref($_[0])? (undef,$_[0]): objectify(1,@_);$x->{sign}eq $nan ? 1 : 0}sub is_positive {my ($class,$x)=ref($_[0])? (undef,$_[0]): objectify(1,@_);return 1 if$x->{sign}eq '+inf';($x->{sign}eq '+' &&!$x->is_zero())? 1 : 0}sub is_negative {my ($class,$x)=ref($_[0])? (undef,$_[0]): objectify(1,@_);$x->{sign}=~ /^-/ ? 1 : 0}sub is_odd {my ($class,$x)=ref($_[0])? (undef,$_[0]): objectify(1,@_);return 0 if$x->{sign}!~ /^[+-]$/;$LIB->_is_odd($x->{value})}sub is_even {my ($class,$x)=ref($_[0])? (undef,$_[0]): objectify(1,@_);return 0 if$x->{sign}!~ /^[+-]$/;$LIB->_is_even($x->{value})}sub is_int {my ($class,$x)=ref($_[0])? (undef,$_[0]): objectify(1,@_);$x->{sign}=~ /^[+-]$/ ? 1 : 0}sub bcmp {my ($class,$x,$y)=ref($_[0])&& ref($_[0])eq ref($_[1])? (ref($_[0]),@_): objectify(2,@_);return$upgrade->bcmp($x,$y)if defined$upgrade && ((!$x->isa($class))|| (!$y->isa($class)));if (($x->{sign}!~ /^[+-]$/)|| ($y->{sign}!~ /^[+-]$/)){return undef if (($x->{sign}eq $nan)|| ($y->{sign}eq $nan));return 0 if$x->{sign}eq $y->{sign}&& $x->{sign}=~ /^[+-]inf$/;return +1 if$x->{sign}eq '+inf';return -1 if$x->{sign}eq '-inf';return -1 if$y->{sign}eq '+inf';return +1}return 1 if$x->{sign}eq '+' && $y->{sign}eq '-';return -1 if$x->{sign}eq '-' && $y->{sign}eq '+';if ($x->{sign}eq '+'){return$LIB->_acmp($x->{value},$y->{value})}$LIB->_acmp($y->{value},$x->{value})}sub bacmp {my ($class,$x,$y)=ref($_[0])&& ref($_[0])eq ref($_[1])? (ref($_[0]),@_): objectify(2,@_);return$upgrade->bacmp($x,$y)if defined$upgrade && ((!$x->isa($class))|| (!$y->isa($class)));if (($x->{sign}!~ /^[+-]$/)|| ($y->{sign}!~ /^[+-]$/)){return undef if (($x->{sign}eq $nan)|| ($y->{sign}eq $nan));return 0 if$x->{sign}=~ /^[+-]inf$/ && $y->{sign}=~ /^[+-]inf$/;return 1 if$x->{sign}=~ /^[+-]inf$/ && $y->{sign}!~ /^[+-]inf$/;return -1}$LIB->_acmp($x->{value},$y->{value})}sub beq {my$self=shift;my$selfref=ref$self;croak 'beq() is an instance method, not a class method' unless$selfref;croak 'Wrong number of arguments for beq()' unless @_==1;my$cmp=$self -> bcmp(shift);return defined($cmp)&&!$cmp}sub bne {my$self=shift;my$selfref=ref$self;croak 'bne() is an instance method, not a class method' unless$selfref;croak 'Wrong number of arguments for bne()' unless @_==1;my$cmp=$self -> bcmp(shift);return defined($cmp)&&!$cmp ? '' : 1}sub blt {my$self=shift;my$selfref=ref$self;croak 'blt() is an instance method, not a class method' unless$selfref;croak 'Wrong number of arguments for blt()' unless @_==1;my$cmp=$self -> bcmp(shift);return defined($cmp)&& $cmp < 0}sub ble {my$self=shift;my$selfref=ref$self;croak 'ble() is an instance method, not a class method' unless$selfref;croak 'Wrong number of arguments for ble()' unless @_==1;my$cmp=$self -> bcmp(shift);return defined($cmp)&& $cmp <= 0}sub bgt {my$self=shift;my$selfref=ref$self;croak 'bgt() is an instance method, not a class method' unless$selfref;croak 'Wrong number of arguments for bgt()' unless @_==1;my$cmp=$self -> bcmp(shift);return defined($cmp)&& $cmp > 0}sub bge {my$self=shift;my$selfref=ref$self;croak 'bge() is an instance method, not a class method' unless$selfref;croak 'Wrong number of arguments for bge()' unless @_==1;my$cmp=$self -> bcmp(shift);return defined($cmp)&& $cmp >= 0}sub bneg {my ($class,$x)=ref($_[0])? (undef,$_[0]): objectify(1,@_);return$x if$x->modify('bneg');$x->{sign}=~ tr/+-/-+/ unless ($x->{sign}eq '+' && $LIB->_is_zero($x->{value}));$x}sub babs {my ($class,$x)=ref($_[0])? (undef,$_[0]): objectify(1,@_);return$x if$x->modify('babs');$x->{sign}=~ s/^-/+/;$x}sub bsgn {my$self=shift;return$self if$self->modify('bsgn');return$self -> bone("+")if$self -> is_pos();return$self -> bone("-")if$self -> is_neg();return$self}sub bnorm {my ($class,$x)=ref($_[0])? (undef,$_[0]): objectify(1,@_);$x}sub binc {my ($class,$x,$a,$p,$r)=ref($_[0])? (ref($_[0]),@_): objectify(1,@_);return$x if$x->modify('binc');if ($x->{sign}eq '+'){$x->{value}=$LIB->_inc($x->{value});return$x->round($a,$p,$r)}elsif ($x->{sign}eq '-'){$x->{value}=$LIB->_dec($x->{value});$x->{sign}='+' if$LIB->_is_zero($x->{value});return$x->round($a,$p,$r)}$x->badd($class->bone(),$a,$p,$r)}sub bdec {my ($class,$x,@r)=ref($_[0])? (ref($_[0]),@_): objectify(1,@_);return$x if$x->modify('bdec');if ($x->{sign}eq '-'){$x->{value}=$LIB->_inc($x->{value})}else {return$x->badd($class->bone('-'),@r)unless$x->{sign}eq '+';if ($LIB->_is_zero($x->{value})){$x->{value}=$LIB->_one();$x->{sign}='-'}else {$x->{value}=$LIB->_dec($x->{value})}}$x->round(@r)}sub badd {my ($class,$x,$y,@r)=(ref($_[0]),@_);if ((!ref($_[0]))|| (ref($_[0])ne ref($_[1]))){($class,$x,$y,@r)=objectify(2,@_)}return$x if$x->modify('badd');return$upgrade->badd($upgrade->new($x),$upgrade->new($y),@r)if defined$upgrade && ((!$x->isa($class))|| (!$y->isa($class)));$r[3]=$y;if ($x->{sign}!~ /^[+-]$/ || $y->{sign}!~ /^[+-]$/){return$x->bnan()if (($x->{sign}eq $nan)|| ($y->{sign}eq $nan));if (($x->{sign}=~ /^[+-]inf$/)&& ($y->{sign}=~ /^[+-]inf$/)){return$x if$x->{sign}eq $y->{sign};return$x->bnan()}$x->{sign}=$y->{sign},return$x if$y->{sign}=~ /^[+-]inf$/;return$x}my ($sx,$sy)=($x->{sign},$y->{sign});if ($sx eq $sy){$x->{value}=$LIB->_add($x->{value},$y->{value})}else {my$a=$LIB->_acmp ($y->{value},$x->{value});if ($a > 0){$x->{value}=$LIB->_sub($y->{value},$x->{value},1);$x->{sign}=$sy}elsif ($a==0){$x->{value}=$LIB->_zero();$x->{sign}='+'}else {$x->{value}=$LIB->_sub($x->{value},$y->{value})}}$x->round(@r)}sub bsub {my ($class,$x,$y,@r)=(ref($_[0]),@_);if ((!ref($_[0]))|| (ref($_[0])ne ref($_[1]))){($class,$x,$y,@r)=objectify(2,@_)}return$x if$x -> modify('bsub');return$upgrade -> new($x)-> bsub($upgrade -> new($y),@r)if defined$upgrade && (!$x -> isa($class)||!$y -> isa($class));return$x -> round(@r)if$y -> is_zero();my$xsign=$x -> {sign};$y -> {sign}=~ tr/+-/-+/;if ($xsign ne $x -> {sign}){return$x -> bzero(@r)if$xsign =~ /^[+-]$/;return$x -> bnan()}$x -> badd($y,@r);$y -> {sign}=~ tr/+-/-+/;$x}sub bmul {my ($class,$x,$y,@r)=(ref($_[0]),@_);if ((!ref($_[0]))|| (ref($_[0])ne ref($_[1]))){($class,$x,$y,@r)=objectify(2,@_)}return$x if$x->modify('bmul');return$x->bnan()if (($x->{sign}eq $nan)|| ($y->{sign}eq $nan));if (($x->{sign}=~ /^[+-]inf$/)|| ($y->{sign}=~ /^[+-]inf$/)){return$x->bnan()if$x->is_zero()|| $y->is_zero();return$x->binf()if ($x->{sign}=~ /^\+/ && $y->{sign}=~ /^\+/);return$x->binf()if ($x->{sign}=~ /^-/ && $y->{sign}=~ /^-/);return$x->binf('-')}return$upgrade->bmul($x,$upgrade->new($y),@r)if defined$upgrade &&!$y->isa($class);$r[3]=$y;$x->{sign}=$x->{sign}eq $y->{sign}? '+' : '-';$x->{value}=$LIB->_mul($x->{value},$y->{value});$x->{sign}='+' if$LIB->_is_zero($x->{value});$x->round(@r)}sub bmuladd {my ($class,$x,$y,$z,@r)=objectify(3,@_);return$x if$x->modify('bmuladd');return$x->bnan()if (($x->{sign}eq $nan)|| ($y->{sign}eq $nan)|| ($z->{sign}eq $nan));if (($x->{sign}=~ /^[+-]inf$/)|| ($y->{sign}=~ /^[+-]inf$/)){return$x->bnan()if$x->is_zero()|| $y->is_zero();return$x->binf()if ($x->{sign}=~ /^\+/ && $y->{sign}=~ /^\+/);return$x->binf()if ($x->{sign}=~ /^-/ && $y->{sign}=~ /^-/);return$x->binf('-')}if (($z->{sign}=~ /^[+-]inf$/)){$x->{sign}=$z->{sign},return$x if$z->{sign}=~ /^[+-]inf$/}return$upgrade->bmuladd($x,$upgrade->new($y),$upgrade->new($z),@r)if defined$upgrade && (!$y->isa($class)||!$z->isa($class)||!$x->isa($class));$r[3]=$z;$x->{sign}=$x->{sign}eq $y->{sign}? '+' : '-';$x->{value}=$LIB->_mul($x->{value},$y->{value});$x->{sign}='+' if$LIB->_is_zero($x->{value});my ($sx,$sz)=($x->{sign},$z->{sign});if ($sx eq $sz){$x->{value}=$LIB->_add($x->{value},$z->{value})}else {my$a=$LIB->_acmp ($z->{value},$x->{value});if ($a > 0){$x->{value}=$LIB->_sub($z->{value},$x->{value},1);$x->{sign}=$sz}elsif ($a==0){$x->{value}=$LIB->_zero();$x->{sign}='+'}else {$x->{value}=$LIB->_sub($x->{value},$z->{value})}}$x->round(@r)}sub bdiv {my ($class,$x,$y,@r)=(ref($_[0]),@_);if ((!ref($_[0]))|| (ref($_[0])ne ref($_[1]))){($class,$x,$y,@r)=objectify(2,@_)}return$x if$x -> modify('bdiv');my$wantarray=wantarray;if ($x -> is_nan()|| $y -> is_nan()){return$wantarray ? ($x -> bnan(),$class -> bnan()): $x -> bnan()}if ($y -> is_zero()){my$rem;if ($wantarray){$rem=$x -> copy()}if ($x -> is_zero()){$x -> bnan()}else {$x -> binf($x -> {sign})}return$wantarray ? ($x,$rem): $x}if ($x -> is_inf()){my$rem;$rem=$class -> bnan()if$wantarray;if ($y -> is_inf()){$x -> bnan()}else {my$sign=$x -> bcmp(0)==$y -> bcmp(0)? '+' : '-';$x -> binf($sign)}return$wantarray ? ($x,$rem): $x}if ($y -> is_inf()){my$rem;if ($x -> is_zero()|| $x -> bcmp(0)==$y -> bcmp(0)){$rem=$x -> copy()if$wantarray;$x -> bzero()}else {$rem=$class -> binf($y -> {sign})if$wantarray;$x -> bone('-')}return$wantarray ? ($x,$rem): $x}return$upgrade -> bdiv($upgrade -> new($x),$upgrade -> new($y),@r)if defined$upgrade;$r[3]=$y;my$rem=$class -> bzero();my$xsign=$x -> {sign};my$ysign=$y -> {sign};$y -> {sign}=~ tr/+-/-+/;my$same=$xsign ne $x -> {sign};$y -> {sign}=$ysign;if ($same){$x -> bone()}else {($x -> {value},$rem -> {value})=$LIB -> _div($x -> {value},$y -> {value});if ($LIB -> _is_zero($rem -> {value})){if ($xsign eq $ysign || $LIB -> _is_zero($x -> {value})){$x -> {sign}='+'}else {$x -> {sign}='-'}}else {if ($xsign eq $ysign){$x -> {sign}='+'}else {if ($xsign eq '+'){$x -> badd(1)}else {$x -> bsub(1)}$x -> {sign}='-'}}}$x -> round(@r);if ($wantarray){unless ($LIB -> _is_zero($rem -> {value})){if ($xsign ne $ysign){$rem=$y -> copy()-> babs()-> bsub($rem)}$rem -> {sign}=$ysign}$rem -> {_a}=$x -> {_a};$rem -> {_p}=$x -> {_p};$rem -> round(@r);return ($x,$rem)}return$x}sub btdiv {my ($class,$x,$y,@r)=(ref($_[0]),@_);if ((!ref($_[0]))|| (ref($_[0])ne ref($_[1]))){($class,$x,$y,@r)=objectify(2,@_)}return$x if$x -> modify('btdiv');my$wantarray=wantarray;if ($x -> is_nan()|| $y -> is_nan()){return$wantarray ? ($x -> bnan(),$class -> bnan()): $x -> bnan()}if ($y -> is_zero()){my$rem;if ($wantarray){$rem=$x -> copy()}if ($x -> is_zero()){$x -> bnan()}else {$x -> binf($x -> {sign})}return$wantarray ? ($x,$rem): $x}if ($x -> is_inf()){my$rem;$rem=$class -> bnan()if$wantarray;if ($y -> is_inf()){$x -> bnan()}else {my$sign=$x -> bcmp(0)==$y -> bcmp(0)? '+' : '-';$x -> binf($sign)}return$wantarray ? ($x,$rem): $x}if ($y -> is_inf()){my$rem;$rem=$x -> copy()if$wantarray;$x -> bzero();return$wantarray ? ($x,$rem): $x}return$upgrade -> btdiv($upgrade -> new($x),$upgrade -> new($y),@r)if defined$upgrade;$r[3]=$y;my$rem=$class -> bzero();my$xsign=$x -> {sign};my$ysign=$y -> {sign};$y -> {sign}=~ tr/+-/-+/;my$same=$xsign ne $x -> {sign};$y -> {sign}=$ysign;if ($same){$x -> bone()}else {($x -> {value},$rem -> {value})=$LIB -> _div($x -> {value},$y -> {value});$x -> {sign}=$xsign eq $ysign ? '+' : '-';$x -> {sign}='+' if$LIB -> _is_zero($x -> {value});$x -> round(@r)}if (wantarray){$rem -> {sign}=$xsign;$rem -> {sign}='+' if$LIB -> _is_zero($rem -> {value});$rem -> {_a}=$x -> {_a};$rem -> {_p}=$x -> {_p};$rem -> round(@r);return ($x,$rem)}return$x}sub bmod {my ($class,$x,$y,@r)=(ref($_[0]),@_);if ((!ref($_[0]))|| (ref($_[0])ne ref($_[1]))){($class,$x,$y,@r)=objectify(2,@_)}return$x if$x -> modify('bmod');$r[3]=$y;if ($x -> is_nan()|| $y -> is_nan()){return$x -> bnan()}if ($y -> is_zero()){return$x}if ($x -> is_inf()){return$x -> bnan()}if ($y -> is_inf()){if ($x -> is_zero()|| $x -> bcmp(0)==$y -> bcmp(0)){return$x}else {return$x -> binf($y -> sign())}}$x -> {value}=$LIB -> _mod($x -> {value},$y -> {value});if ($LIB -> _is_zero($x -> {value})){$x -> {sign}='+'}else {$x -> {value}=$LIB -> _sub($y -> {value},$x -> {value},1)if ($x -> {sign}ne $y -> {sign});$x -> {sign}=$y -> {sign}}$x -> round(@r)}sub btmod {my ($class,$x,$y,@r)=(ref($_[0]),@_);if ((!ref($_[0]))|| (ref($_[0])ne ref($_[1]))){($class,$x,$y,@r)=objectify(2,@_)}return$x if$x -> modify('btmod');if ($x -> is_nan()|| $y -> is_nan()){return$x -> bnan()}if ($y -> is_zero()){return$x}if ($x -> is_inf()){return$x -> bnan()}if ($y -> is_inf()){return$x}return$upgrade -> btmod($upgrade -> new($x),$upgrade -> new($y),@r)if defined$upgrade;$r[3]=$y;my$xsign=$x -> {sign};$x -> {value}=$LIB -> _mod($x -> {value},$y -> {value});$x -> {sign}=$xsign;$x -> {sign}='+' if$LIB -> _is_zero($x -> {value});$x -> round(@r);return$x}sub bmodinv {my ($class,$x,$y,@r)=(undef,@_);if ((!ref($_[0]))|| (ref($_[0])ne ref($_[1]))){($class,$x,$y,@r)=objectify(2,@_)}return$x if$x->modify('bmodinv');return$x->bnan()if ($y->{sign}!~ /^[+-]$/ || $x->{sign}!~ /^[+-]$/);return$x->bnan()if$y->is_zero();return$x->bzero()if ($y->is_one()|| $y->is_one('-'));$x->bmod($y);return$x->bnan()if$x->is_zero();($x->{value},$x->{sign})=$LIB->_modinv($x->{value},$y->{value});return$x->bnan()if!defined$x->{value};$x->{sign}='+' unless defined$x->{sign};$x -> bneg()if$y->{sign}eq '-';$x -> bmod($y)if$x->{sign}ne $y->{sign};return$x}sub bmodpow {my ($class,$num,$exp,$mod,@r)=objectify(3,@_);return$num if$num->modify('bmodpow');$num->bmodinv($mod)if ($exp->{sign}eq '-');return$num->bnan()if ($num->{sign}=~ /NaN|inf/ || $exp->{sign}=~ /NaN|inf/ || $mod->{sign}=~ /NaN|inf/);if ($mod -> is_zero()){if ($num -> is_zero()){return$class -> bnan()}else {return$num -> copy()}}my$value=$LIB->_modpow($num->{value},$exp->{value},$mod->{value});my$sign='+';unless ($LIB->_is_zero($value)){if ($num->{sign}eq '-' && $exp->is_odd()){if ($mod->{sign}eq '-'){$sign='-'}else {my$mod=$LIB->_copy($mod->{value});$value=$LIB->_sub($mod,$value);$sign='+'}}else {if ($mod->{sign}eq '-'){my$mod=$LIB->_copy($mod->{value});$value=$LIB->_sub($mod,$value);$sign='-'}}}$num->{value}=$value;$num->{sign}=$sign;return$num}sub bpow {my ($class,$x,$y,@r)=(ref($_[0]),@_);if ((!ref($_[0]))|| (ref($_[0])ne ref($_[1]))){($class,$x,$y,@r)=objectify(2,@_)}return$x if$x->modify('bpow');return$x->bnan()if$x->is_nan()|| $y->is_nan();if ($x->is_inf("-")){return$x->bzero()if$y->is_negative();return$x->bnan()if$y->is_zero();return$x if$y->is_odd();return$x->bneg()}elsif ($x->is_inf("+")){return$x->bzero()if$y->is_negative();return$x->bnan()if$y->is_zero();return$x}elsif ($y->is_inf("-")){return$x->bnan()if$x -> is_one("-");return$x->binf("+")if$x -> is_zero();return$x->bone()if$x -> is_one("+");return$x->bzero()}elsif ($y->is_inf("+")){return$x->bnan()if$x -> is_one("-");return$x->bzero()if$x -> is_zero();return$x->bone()if$x -> is_one("+");return$x->binf("+")}return$upgrade->bpow($upgrade->new($x),$y,@r)if defined$upgrade && (!$y->isa($class)|| $y->{sign}eq '-');$r[3]=$y;my$new_sign='+';$new_sign=$y->is_odd()? '-' : '+' if ($x->{sign}ne '+');return$x->binf()if$y->{sign}eq '-' && $x->{sign}eq '+' && $LIB->_is_zero($x->{value});return$x->bnan()if$y->{sign}eq '-' &&!$LIB->_is_one($x->{value});$x->{value}=$LIB->_pow($x->{value},$y->{value});$x->{sign}=$new_sign;$x->{sign}='+' if$LIB->_is_zero($y->{value});$x->round(@r)}sub blog {my ($class,$x,$base,@r);if (!ref($_[0])&& $_[0]=~ /^[A-Za-z]|::/){($class,$x,$base,@r)=defined $_[2]? objectify(2,@_): objectify(1,@_)}else {($class,$x,$base,@r)=defined $_[1]? objectify(2,@_): objectify(1,@_)}return$x if$x->modify('blog');return$x -> bnan()if$x -> is_nan();if (defined$base){$base=$class -> new($base)unless ref$base;if ($base -> is_nan()|| $base -> is_one()){return$x -> bnan()}elsif ($base -> is_inf()|| $base -> is_zero()){return$x -> bnan()if$x -> is_inf()|| $x -> is_zero();return$x -> bzero()}elsif ($base -> is_negative()){return$x -> bzero()if$x -> is_one();return$x -> bone()if$x==$base;return$x -> bnan()}return$x -> bone()if$x==$base}return$x -> binf('+')if$x -> is_inf();return$x -> bnan()if$x -> is_neg();return$x -> bzero()if$x -> is_one();return$x -> binf('-')if$x -> is_zero();return$upgrade -> blog($upgrade -> new($x),$base,@r)if defined$upgrade;if (!defined$base){require Math::BigFloat;my$u=Math::BigFloat->blog(Math::BigFloat->new($x))->as_int();$x->{value}=$u->{value};$x->{sign}=$u->{sign};return$x}my ($rc,$exact)=$LIB->_log_int($x->{value},$base->{value});return$x->bnan()unless defined$rc;$x->{value}=$rc;$x->round(@r)}sub bexp {my ($class,$x,@r)=ref($_[0])? (ref($_[0]),@_): objectify(1,@_);return$x if$x->modify('bexp');return$x->bnan()if$x->{sign}eq 'NaN';return$x->bone()if$x->is_zero();return$x if$x->{sign}eq '+inf';return$x->bzero()if$x->{sign}eq '-inf';my$u;{require Math::BigFloat unless defined$upgrade;local$upgrade='Math::BigFloat' unless defined$upgrade;$u=$upgrade->bexp($upgrade->new($x),@r)}if (defined$upgrade){$x=$u}else {$u=$u->as_int();$x->{value}=$u->{value};$x->round(@r)}}sub bnok {my ($self,$n,$k,@r)=(ref($_[0]),@_);if ((!ref($_[0]))|| (ref($_[0])ne ref($_[1]))){($self,$n,$k,@r)=objectify(2,@_)}return$n if$n->modify('bnok');return$n->bnan()if$n->{sign}eq 'NaN' || $k->{sign}eq 'NaN';if ($n -> is_inf()){if ($k -> is_inf()){return$n -> bnan()}elsif ($k -> is_neg()){return$n -> bzero()}elsif ($k -> is_zero()){return$n -> bone()}else {if ($n -> is_inf("+")){return$n -> binf("+")}else {my$sign=$k -> is_even()? "+" : "-";return$n -> binf($sign)}}}elsif ($k -> is_inf()){return$n -> bnan()}my$sign=1;if ($n >= 0){if ($k < 0 || $k > $n){return$n -> bzero()}}else {if ($k >= 0){$sign=(-1)** $k;$n -> bneg()-> badd($k)-> bdec()}elsif ($k <= $n){$sign=(-1)** ($n - $k);my$x0=$n -> copy();$n -> bone()-> badd($k)-> bneg();$k=$k -> copy();$k -> bneg()-> badd($x0)}else {return$n -> bzero()}}$n->{value}=$LIB->_nok($n->{value},$k->{value});$n -> bneg()if$sign==-1;$n->round(@r)}sub bsin {my ($class,$x,@r)=ref($_[0])? (undef,@_): objectify(1,@_);return$x if$x->modify('bsin');return$x->bnan()if$x->{sign}!~ /^[+-]\z/;return$upgrade->new($x)->bsin(@r)if defined$upgrade;require Math::BigFloat;my$t=Math::BigFloat->new($x)->bsin(@r)->as_int();$x->bone()if$t->is_one();$x->bzero()if$t->is_zero();$x->round(@r)}sub bcos {my ($class,$x,@r)=ref($_[0])? (undef,@_): objectify(1,@_);return$x if$x->modify('bcos');return$x->bnan()if$x->{sign}!~ /^[+-]\z/;return$upgrade->new($x)->bcos(@r)if defined$upgrade;require Math::BigFloat;my$t=Math::BigFloat->new($x)->bcos(@r)->as_int();$x->bone()if$t->is_one();$x->bzero()if$t->is_zero();$x->round(@r)}sub batan {my ($class,$x,@r)=ref($_[0])? (undef,@_): objectify(1,@_);return$x if$x->modify('batan');return$x->bnan()if$x->{sign}!~ /^[+-]\z/;return$upgrade->new($x)->batan(@r)if defined$upgrade;my$t=Math::BigFloat->new($x)->batan(@r);$x->{value}=$LIB->_new($x->as_int()->bstr());$x->round(@r)}sub batan2 {my ($class,$y,$x,@r)=(ref($_[0]),@_);if ((!ref($_[0]))|| (ref($_[0])ne ref($_[1]))){($class,$y,$x,@r)=objectify(2,@_)}return$y if$y->modify('batan2');return$y->bnan()if ($y->{sign}eq $nan)|| ($x->{sign}eq $nan);if ($x->is_inf()|| $y->is_inf()){return$upgrade->new($y)->batan2($upgrade->new($x),@r)if defined$upgrade;if ($y->is_inf()){if ($x->{sign}eq '-inf'){$y->bone(substr($y->{sign},0,1));$y->bmul($class->new(2))}elsif ($x->{sign}eq '+inf'){$y->bzero()}else {$y->bone(substr($y->{sign},0,1))}}else {if ($x->{sign}eq '+inf'){$y->bzero()}else {$y->bone(substr($y->{sign},0,1));$y->bmul($class->new(3))}}return$y}return$upgrade->new($y)->batan2($upgrade->new($x),@r)if defined$upgrade;require Math::BigFloat;my$r=Math::BigFloat->new($y)->batan2(Math::BigFloat->new($x),@r)->as_int();$x->{value}=$r->{value};$x->{sign}=$r->{sign};$x}sub bsqrt {my ($class,$x,@r)=ref($_[0])? (undef,@_): objectify(1,@_);return$x if$x->modify('bsqrt');return$x->bnan()if$x->{sign}!~ /^\+/;return$x if$x->{sign}eq '+inf';return$upgrade->bsqrt($x,@r)if defined$upgrade;$x->{value}=$LIB->_sqrt($x->{value});$x->round(@r)}sub broot {my ($class,$x,$y,@r)=(ref($_[0]),@_);$y=$class->new(2)unless defined$y;if ((!ref($x))|| (ref($x)ne ref($y))){($class,$x,$y,@r)=objectify(2,$class || $class,@_)}return$x if$x->modify('broot');return$x->bnan()if$x->{sign}!~ /^\+/ || $y->is_zero()|| $y->{sign}!~ /^\+$/;return$x->round(@r)if$x->is_zero()|| $x->is_one()|| $x->is_inf()|| $y->is_one();return$upgrade->new($x)->broot($upgrade->new($y),@r)if defined$upgrade;$x->{value}=$LIB->_root($x->{value},$y->{value});$x->round(@r)}sub bfac {my ($class,$x,@r)=ref($_[0])? (undef,@_): objectify(1,@_);return$x if$x->modify('bfac')|| $x->{sign}eq '+inf';return$x->bnan()if$x->{sign}ne '+';$x->{value}=$LIB->_fac($x->{value});$x->round(@r)}sub bdfac {my ($class,$x,@r)=ref($_[0])? (undef,@_): objectify(1,@_);return$x if$x->modify('bdfac')|| $x->{sign}eq '+inf';return$x->bnan()if$x->{sign}ne '+';croak("bdfac() requires a newer version of the $LIB library.")unless$LIB->can('_dfac');$x->{value}=$LIB->_dfac($x->{value});$x->round(@r)}sub bfib {my ($class,$x,@r)=objectify(1,@_);croak("bfib() requires a newer version of the $LIB library.")unless$LIB->can('_fib');return$x if$x->modify('bfib');if (wantarray){return ()if$x -> is_nan();croak("bfib() can't return an infinitely long list of numbers")if$x -> is_inf();my@values=$LIB->_fib($x->{value});for (my$i=0 ;$i < $#values ;++ $i){my$fib=$class -> bzero();$fib -> {value}=$values[$i];$values[$i]=$fib}$x -> {value}=$values[-1];$values[-1]=$x;if ($x -> is_neg()){for (my$i=2 ;$i <= $#values ;$i += 2){$values[$i]{sign}='-'}}@values=map {$_ -> round(@r)}@values;return@values}else {return$x if$x->modify('bdfac')|| $x -> is_inf('+');return$x->bnan()if$x -> is_nan()|| $x -> is_inf('-');$x->{sign}=$x -> is_neg()&& $x -> is_even()? '-' : '+';$x->{value}=$LIB->_fib($x->{value});return$x->round(@r)}}sub blucas {my ($class,$x,@r)=objectify(1,@_);croak("blucas() requires a newer version of the $LIB library.")unless$LIB->can('_lucas');return$x if$x->modify('blucas');if (wantarray){return ()if$x -> is_nan();croak("blucas() can't return an infinitely long list of numbers")if$x -> is_inf();my@values=$LIB->_lucas($x->{value});for (my$i=0 ;$i < $#values ;++ $i){my$lucas=$class -> bzero();$lucas -> {value}=$values[$i];$values[$i]=$lucas}$x -> {value}=$values[-1];$values[-1]=$x;if ($x -> is_neg()){for (my$i=2 ;$i <= $#values ;$i += 2){$values[$i]{sign}='-'}}@values=map {$_ -> round(@r)}@values;return@values}else {return$x if$x -> is_inf('+');return$x->bnan()if$x -> is_nan()|| $x -> is_inf('-');$x->{sign}=$x -> is_neg()&& $x -> is_even()? '-' : '+';$x->{value}=$LIB->_lucas($x->{value});return$x->round(@r)}}sub blsft {my ($class,$x,$y,$b,@r)=(ref($_[0]),@_);if ((!ref($_[0]))|| (ref($_[0])ne ref($_[1]))){($class,$x,$y,$b,@r)=objectify(2,@_)}return$x if$x -> modify('blsft');return$x -> bnan()if ($x -> {sign}!~ /^[+-]$/ || $y -> {sign}!~ /^[+-]$/);return$x -> round(@r)if$y -> is_zero();$b=2 if!defined$b;return$x -> bnan()if$b <= 0 || $y -> {sign}eq '-';$x -> {value}=$LIB -> _lsft($x -> {value},$y -> {value},$b);$x -> round(@r)}sub brsft {my ($class,$x,$y,$b,@r)=(ref($_[0]),@_);if ((!ref($_[0]))|| (ref($_[0])ne ref($_[1]))){($class,$x,$y,$b,@r)=objectify(2,@_)}return$x if$x -> modify('brsft');return$x -> bnan()if ($x -> {sign}!~ /^[+-]$/ || $y -> {sign}!~ /^[+-]$/);return$x -> round(@r)if$y -> is_zero();return$x -> bzero(@r)if$x -> is_zero();$b=2 if!defined$b;return$x -> bnan()if$b <= 0 || $y -> {sign}eq '-';if (($x -> {sign}eq '-')&& ($b==2)){return$x -> round(@r)if$x -> is_one('-');if (!$y -> is_one()){$x -> binc();my$bin=$x -> as_bin();$bin =~ s/^-0b//;$bin =~ tr/10/01/;if ($y >= CORE::length($bin)){$bin='0'}else {$bin =~ s/.{$y}$//;$bin='1' .$bin;$bin =~ tr/10/01/}my$res=$class -> new('0b' .$bin);$res -> binc();$x -> {value}=$res -> {value};return$x -> round(@r)}$x -> bdec()}$x -> {value}=$LIB -> _rsft($x -> {value},$y -> {value},$b);$x -> round(@r)}sub band {my ($class,$x,$y,@r)=(ref($_[0]),@_);if ((!ref($_[0]))|| (ref($_[0])ne ref($_[1]))){($class,$x,$y,@r)=objectify(2,@_)}return$x if$x->modify('band');$r[3]=$y;return$x->bnan()if ($x->{sign}!~ /^[+-]$/ || $y->{sign}!~ /^[+-]$/);if ($x->{sign}eq '+' && $y->{sign}eq '+'){$x->{value}=$LIB->_and($x->{value},$y->{value})}else {($x->{value},$x->{sign})=$LIB->_sand($x->{value},$x->{sign},$y->{value},$y->{sign})}return$x->round(@r)}sub bior {my ($class,$x,$y,@r)=(ref($_[0]),@_);if ((!ref($_[0]))|| (ref($_[0])ne ref($_[1]))){($class,$x,$y,@r)=objectify(2,@_)}return$x if$x->modify('bior');$r[3]=$y;return$x->bnan()if ($x->{sign}!~ /^[+-]$/ || $y->{sign}!~ /^[+-]$/);if ($x->{sign}eq '+' && $y->{sign}eq '+'){$x->{value}=$LIB->_or($x->{value},$y->{value})}else {($x->{value},$x->{sign})=$LIB->_sor($x->{value},$x->{sign},$y->{value},$y->{sign})}return$x->round(@r)}sub bxor {my ($class,$x,$y,@r)=(ref($_[0]),@_);if ((!ref($_[0]))|| (ref($_[0])ne ref($_[1]))){($class,$x,$y,@r)=objectify(2,@_)}return$x if$x->modify('bxor');$r[3]=$y;return$x->bnan()if ($x->{sign}!~ /^[+-]$/ || $y->{sign}!~ /^[+-]$/);if ($x->{sign}eq '+' && $y->{sign}eq '+'){$x->{value}=$LIB->_xor($x->{value},$y->{value})}else {($x->{value},$x->{sign})=$LIB->_sxor($x->{value},$x->{sign},$y->{value},$y->{sign})}return$x->round(@r)}sub bnot {my ($class,$x)=ref($_[0])? (undef,@_): objectify(1,@_);return$x if$x->modify('bnot');$x->binc()->bneg()}sub round {my ($self,$a,$p,$r,@args)=@_;my$class=ref($self);no strict 'refs';if (!defined$a){for ($self,@args){$a=$_->{_a}if (defined $_->{_a})&& (!defined$a || $_->{_a}< $a)}}if (!defined$p){for ($self,@args){$p=$_->{_p}if (defined $_->{_p})&& (!defined$p || $_->{_p}> $p)}}unless (defined$a || defined$p){$a=${"$class\::accuracy"};$p=${"$class\::precision"}}$a=undef if defined$a && $a==0;return$self unless defined$a || defined$p;return$self->bnan()if defined$a && defined$p;$r=${"$class\::round_mode"}unless defined$r;if ($r !~ /^(even|odd|[+-]inf|zero|trunc|common)$/){croak("Unknown round mode '$r'")}if (defined$a){$self->bround(int($a),$r)if!defined$self->{_a}|| $self->{_a}>= $a}else {$self->bfround(int($p),$r)if!defined$self->{_p}|| $self->{_p}<= $p}$self}sub bround {my$x=shift;$x=$class->new($x)unless ref$x;my ($scale,$mode)=$x->_scale_a(@_);return$x if!defined$scale || $x->modify('bround');if ($x->is_zero()|| $scale==0){$x->{_a}=$scale if!defined$x->{_a}|| $x->{_a}> $scale;return$x}return$x if$x->{sign}!~ /^[+-]$/;my$len=$x->length();$scale=$scale->numify()if ref ($scale);if (($scale < 0 && $scale < -$len-1)|| ($scale >= $len)){$x->{_a}=$scale if!defined$x->{_a}|| $x->{_a}> $scale;return$x}my ($pad,$digit_round,$digit_after);$pad=$len - $scale;$pad=abs($scale-1)if$scale < 0;my$xs=$LIB->_str($x->{value});my$pl=-$pad-1;$digit_round='0';$digit_round=substr($xs,$pl,1)if$pad <= $len;$pl++;$pl ++ if$pad >= $len;$digit_after='0';$digit_after=substr($xs,$pl,1)if$pad > 0;my$round_up=1;$round_up -- if ($mode eq 'trunc')|| ($digit_after =~ /[01234]/)|| ($digit_after eq '5')&& ($x->_scan_for_nonzero($pad,$xs,$len)==0)&& (($mode eq 'even')&& ($digit_round =~ /[24680]/)|| ($mode eq 'odd')&& ($digit_round =~ /[13579]/)|| ($mode eq '+inf')&& ($x->{sign}eq '-')|| ($mode eq '-inf')&& ($x->{sign}eq '+')|| ($mode eq 'zero'));my$put_back=0;if (($pad > 0)&& ($pad <= $len)){substr($xs,-$pad,$pad)='0' x $pad;$put_back=1}elsif ($pad > $len){$x->bzero()}if ($round_up){$put_back=1;$pad=$len,$xs='0' x $pad if$scale < 0;my$c=0;$pad ++;while ($pad <= $len){$c=substr($xs,-$pad,1)+ 1;$c='0' if$c eq '10';substr($xs,-$pad,1)=$c;$pad++;last if$c!=0}$xs='1'.$xs if$c==0}$x->{value}=$LIB->_new($xs)if$put_back==1;$x->{_a}=$scale if$scale >= 0;if ($scale < 0){$x->{_a}=$len+$scale;$x->{_a}=0 if$scale < -$len}$x}sub bfround {my$x=shift;my$class=ref($x)|| $x;$x=$class->new($x)unless ref$x;my ($scale,$mode)=$x->_scale_p(@_);return$x if!defined$scale || $x->modify('bfround');$x->bround($x->length()-$scale,$mode)if$scale > 0;delete$x->{_a};$x->{_p}=$scale;$x}sub fround {my$x=shift;$x=$class->new($x)unless ref$x;$x->bround(@_)}sub bfloor {my ($class,$x,@r)=ref($_[0])? (undef,@_): objectify(1,@_);$x->round(@r)}sub bceil {my ($class,$x,@r)=ref($_[0])? (undef,@_): objectify(1,@_);$x->round(@r)}sub bint {my ($class,$x,@r)=ref($_[0])? (undef,@_): objectify(1,@_);$x->round(@r)}sub bgcd {my ($class,@args)=objectify(0,@_);my$x=shift@args;$x=ref($x)&& $x -> isa($class)? $x -> copy(): $class -> new($x);return$class->bnan()if$x->{sign}!~ /^[+-]$/;while (@args){my$y=shift@args;$y=$class->new($y)unless ref($y)&& $y -> isa($class);return$class->bnan()if$y->{sign}!~ /^[+-]$/;$x->{value}=$LIB->_gcd($x->{value},$y->{value});last if$LIB->_is_one($x->{value})}return$x -> babs()}sub blcm {my ($class,@args)=objectify(0,@_);my$x=shift@args;$x=ref($x)&& $x -> isa($class)? $x -> copy(): $class -> new($x);return$class->bnan()if$x->{sign}!~ /^[+-]$/;while (@args){my$y=shift@args;$y=$class -> new($y)unless ref($y)&& $y -> isa($class);return$x->bnan()if$y->{sign}!~ /^[+-]$/;$x -> {value}=$LIB->_lcm($x -> {value},$y -> {value})}return$x -> babs()}sub sign {my ($class,$x)=ref($_[0])? (undef,$_[0]): objectify(1,@_);$x->{sign}}sub digit {my ($class,$x,$n)=ref($_[0])? (undef,@_): objectify(1,@_);$n=$n->numify()if ref($n);$LIB->_digit($x->{value},$n || 0)}sub length {my ($class,$x)=ref($_[0])? (undef,$_[0]): objectify(1,@_);my$e=$LIB->_len($x->{value});wantarray ? ($e,0): $e}sub exponent {my ($class,$x)=ref($_[0])? (ref($_[0]),$_[0]): objectify(1,@_);if ($x->{sign}!~ /^[+-]$/){my$s=$x->{sign};$s =~ s/^[+-]//;return$class->new($s)}return$class->bzero()if$x->is_zero();$class->new($LIB->_zeros($x->{value}))}sub mantissa {my ($class,$x)=ref($_[0])? (ref($_[0]),$_[0]): objectify(1,@_);if ($x->{sign}!~ /^[+-]$/){return$class->new($x->{sign})}my$m=$x->copy();delete$m->{_p};delete$m->{_a};my$zeros=$LIB->_zeros($m->{value});$m->brsft($zeros,10)if$zeros!=0;$m}sub parts {my ($class,$x)=ref($_[0])? (undef,$_[0]): objectify(1,@_);($x->mantissa(),$x->exponent())}sub sparts {my$self=shift;my$class=ref$self;croak("sparts() is an instance method, not a class method")unless$class;if ($self -> is_nan()){my$mant=$self -> copy();return$mant unless wantarray;my$expo=$class -> bnan();return ($mant,$expo)}if ($self -> is_inf()){my$mant=$self -> copy();return$mant unless wantarray;my$expo=$class -> binf('+');return ($mant,$expo)}my$mant=$self -> copy();my$nzeros=$LIB -> _zeros($mant -> {value});$mant -> brsft($nzeros,10)if$nzeros!=0;return$mant unless wantarray;my$expo=$class -> new($nzeros);return ($mant,$expo)}sub nparts {my$self=shift;my$class=ref$self;croak("nparts() is an instance method, not a class method")unless$class;if ($self -> is_nan()){my$mant=$self -> copy();return$mant unless wantarray;my$expo=$class -> bnan();return ($mant,$expo)}if ($self -> is_inf()){my$mant=$self -> copy();return$mant unless wantarray;my$expo=$class -> binf('+');return ($mant,$expo)}my ($mant,$expo)=$self -> sparts();if ($mant -> bcmp(0)){my ($ndigtot,$ndigfrac)=$mant -> length();my$expo10adj=$ndigtot - $ndigfrac - 1;if ($expo10adj!=0){return$upgrade -> new($self)-> nparts()if$upgrade;$mant -> bnan();return$mant unless wantarray;$expo -> badd($expo10adj);return ($mant,$expo)}}return$mant unless wantarray;return ($mant,$expo)}sub eparts {my$self=shift;my$class=ref$self;croak("eparts() is an instance method, not a class method")unless$class;return$self -> sparts()if$self -> is_nan()|| $self -> is_inf();my ($mant,$expo)=$self -> sparts();if ($mant -> bcmp(0)){my$ndigmant=$mant -> length();$expo -> badd($ndigmant);my$c=$expo -> copy()-> bdec()-> bmod(3)-> binc();$expo -> bsub($c);if ($ndigmant > $c){return$upgrade -> new($self)-> eparts()if$upgrade;$mant -> bnan();return$mant unless wantarray;return ($mant,$expo)}$mant -> blsft($c - $ndigmant,10)}return$mant unless wantarray;return ($mant,$expo)}sub dparts {my$self=shift;my$class=ref$self;croak("dparts() is an instance method, not a class method")unless$class;my$int=$self -> copy();return$int unless wantarray;my$frc=$class -> bzero();return ($int,$frc)}sub bstr {my ($class,$x)=ref($_[0])? (undef,$_[0]): objectify(1,@_);if ($x->{sign}ne '+' && $x->{sign}ne '-'){return$x->{sign}unless$x->{sign}eq '+inf';return 'inf'}my$str=$LIB->_str($x->{value});return$x->{sign}eq '-' ? "-$str" : $str}sub bsstr {my ($class,$x)=ref($_[0])? (undef,$_[0]): objectify(1,@_);if ($x->{sign}ne '+' && $x->{sign}ne '-'){return$x->{sign}unless$x->{sign}eq '+inf';return 'inf'}my ($m,$e)=$x -> parts();my$str=$LIB->_str($m->{value}).'e+' .$LIB->_str($e->{value});return$x->{sign}eq '-' ? "-$str" : $str}sub bnstr {my$x=shift;if ($x->{sign}ne '+' && $x->{sign}ne '-'){return$x->{sign}unless$x->{sign}eq '+inf';return 'inf'}return$x -> bstr()if$x -> is_nan()|| $x -> is_inf();my ($mant,$expo)=$x -> parts();my$fracpos=$mant -> length()- 1;if ($fracpos==0){my$str=$LIB->_str($mant->{value})."e+" .$LIB->_str($expo->{value});return$x->{sign}eq '-' ? "-$str" : $str}$expo += $fracpos;my$mantstr=$LIB->_str($mant -> {value});substr($mantstr,-$fracpos,0)='.';my$str=$mantstr .'e+' .$LIB->_str($expo -> {value});return$x->{sign}eq '-' ? "-$str" : $str}sub bestr {my$x=shift;if ($x->{sign}ne '+' && $x->{sign}ne '-'){return$x->{sign}unless$x->{sign}eq '+inf';return 'inf'}my ($mant,$expo)=$x -> parts();my$sign=$mant -> sign();$mant -> babs();my$mantstr=$LIB->_str($mant -> {value});my$mantlen=CORE::length($mantstr);my$dotidx=1;$expo += $mantlen - 1;my$c=$expo -> copy()-> bmod(3);$expo -= $c;$dotidx += $c;if ($mantlen < $dotidx){$mantstr .= "0" x ($dotidx - $mantlen)}elsif ($mantlen > $dotidx){substr($mantstr,$dotidx,0)="."}my$str=$mantstr .'e+' .$LIB->_str($expo -> {value});return$sign eq "-" ? "-$str" : $str}sub bdstr {my$x=shift;if ($x->{sign}ne '+' && $x->{sign}ne '-'){return$x->{sign}unless$x->{sign}eq '+inf';return 'inf'}my$str=$LIB->_str($x->{value});return$x->{sign}eq '-' ? "-$str" : $str}sub to_hex {my$x=shift;$x=$class->new($x)if!ref($x);return$x->bstr()if$x->{sign}!~ /^[+-]$/;my$hex=$LIB->_to_hex($x->{value});return$x->{sign}eq '-' ? "-$hex" : $hex}sub to_oct {my$x=shift;$x=$class->new($x)if!ref($x);return$x->bstr()if$x->{sign}!~ /^[+-]$/;my$oct=$LIB->_to_oct($x->{value});return$x->{sign}eq '-' ? "-$oct" : $oct}sub to_bin {my$x=shift;$x=$class->new($x)if!ref($x);return$x->bstr()if$x->{sign}!~ /^[+-]$/;my$bin=$LIB->_to_bin($x->{value});return$x->{sign}eq '-' ? "-$bin" : $bin}sub to_bytes {my$x=shift;$x=$class->new($x)if!ref($x);croak("to_bytes() requires a finite, non-negative integer")if$x -> is_neg()||!$x -> is_int();croak("to_bytes() requires a newer version of the $LIB library.")unless$LIB->can('_to_bytes');return$LIB->_to_bytes($x->{value})}sub to_base {my$x=shift;$x=$class->new($x)if!ref($x);croak("the value to convert must be a finite, non-negative integer")if$x -> is_neg()||!$x -> is_int();my$base=shift;$base=$class->new($base)unless ref($base);croak("the base must be a finite integer >= 2")if$base < 2 ||!$base -> is_int();if (!@_){return$x -> to_bin()if$base==2;return$x -> to_oct()if$base==8;return uc$x -> to_hex()if$base==16;return$x -> bstr()if$base==10}croak("to_base() requires a newer version of the $LIB library.")unless$LIB->can('_to_base');return$LIB->_to_base($x->{value},$base -> {value},@_ ? shift(): ())}sub as_hex {my$x=shift;$x=$class->new($x)if!ref($x);return$x->bstr()if$x->{sign}!~ /^[+-]$/;my$hex=$LIB->_as_hex($x->{value});return$x->{sign}eq '-' ? "-$hex" : $hex}sub as_oct {my$x=shift;$x=$class->new($x)if!ref($x);return$x->bstr()if$x->{sign}!~ /^[+-]$/;my$oct=$LIB->_as_oct($x->{value});return$x->{sign}eq '-' ? "-$oct" : $oct}sub as_bin {my$x=shift;$x=$class->new($x)if!ref($x);return$x->bstr()if$x->{sign}!~ /^[+-]$/;my$bin=$LIB->_as_bin($x->{value});return$x->{sign}eq '-' ? "-$bin" : $bin}*as_bytes=\&to_bytes;sub numify {my$x=shift;$x=$class->new($x)unless ref$x;if ($x -> is_nan()){require Math::Complex;my$inf=Math::Complex::Inf();return$inf - $inf}if ($x -> is_inf()){require Math::Complex;my$inf=Math::Complex::Inf();return$x -> is_negative()? -$inf : $inf}my$num=0 + $LIB->_num($x->{value});return$x->{sign}eq '-' ? -$num : $num}sub objectify {return (ref($_[1]),$_[1])if @_==2 && ($_[0]|| 0)==1 && ref($_[1]);unless (wantarray){croak("${class}::objectify() needs list context")}my$count=shift;my@a=@_;my$class;if (ref($a[0])){$class=ref($a[0])}elsif ($a[0]=~ /^[A-Z].*::/){$class=shift@a}else {$class=__PACKAGE__}$count ||= @a;unshift@a,$class;no strict 'refs';my$up=${"$a[0]::upgrade"};my$down;if (defined ${"$a[0]::downgrade"}){$down=${"$a[0]::downgrade"};${"$a[0]::downgrade"}=undef}for my$i (1 .. $count){my$ref=ref$a[$i];unless ($ref){$a[$i]=$a[0]-> new($a[$i]);next}next if$ref -> isa($a[0]);if (defined$up && $ref -> isa($up)){next}my$recheck=0;if ($a[0]-> isa('Math::BigInt')){if ($a[$i]-> can('as_int')){$a[$i]=$a[$i]-> as_int();$recheck=1}elsif ($a[$i]-> can('as_number')){$a[$i]=$a[$i]-> as_number();$recheck=1}}elsif ($a[0]-> isa('Math::BigFloat')){if ($a[$i]-> can('as_float')){$a[$i]=$a[$i]-> as_float();$recheck=$1}}if ($recheck){$ref=ref($a[$i]);unless ($ref){$a[$i]=$a[0]-> new($a[$i]);next}next if$ref -> isa($a[0])}$a[$i]=$a[0]-> new($a[$i])}${"$a[0]::downgrade"}=$down;return@a}sub import {my$class=shift;$IMPORT++;my@a;my$l=scalar @_;my$warn_or_die=0;for (my$i=0;$i < $l ;$i++){if ($_[$i]eq ':constant'){overload::constant integer=>sub {$class->new(shift)},binary=>sub {$class->new(shift)}}elsif ($_[$i]eq 'upgrade'){$upgrade=$_[$i+1];$i++}elsif ($_[$i]=~ /^(lib|try|only)\z/){$LIB=$_[$i+1]|| '';$warn_or_die=1 if $_[$i]eq 'lib';$warn_or_die=2 if $_[$i]eq 'only';$i++}else {push@a,$_[$i]}}if (@a > 0){$class->SUPER::import(@a);$class->export_to_level(1,$class,@a)}my@c=split /\s*,\s*/,$LIB;for (@c){$_ =~ tr/a-zA-Z0-9://cd}push@c,\'Calc' if$warn_or_die < 2;$LIB='';for my$l (@c){my$lib=$l;$lib=$$l if ref($l);next if ($lib || '')eq '';$lib='Math::BigInt::'.$lib if$lib !~ /^Math::BigInt/i;$lib =~ s/\.pm$//;if ($] < 5.006){my@parts=split /::/,$lib;my$file=pop@parts;$file .= '.pm';require File::Spec;$file=File::Spec->catfile (@parts,$file);eval {require "$file";$lib->import(@c)}}else {eval "use $lib qw/@c/;"}if ($@ eq ''){my$ok=1;if ($lib->can('api_version')&& $lib->api_version()>= 1.0){$ok=0;for my$method (qw/one two ten str num add mul div sub dec inc acmp len digit is_one is_zero is_even is_odd is_two is_ten zeros new copy check from_hex from_oct from_bin as_hex as_bin as_oct rsft lsft xor and or mod sqrt root fac pow modinv modpow log_int gcd/){if (!$lib->can("_$method")){if (($WARN{$lib}|| 0)< 2){carp("$lib is missing method '_$method'");$WARN{$lib}=1}$ok++;last}}}if ($ok==0){$LIB=$lib;if ($warn_or_die > 0 && ref($l)){my$msg="Math::BigInt: couldn't load specified" ." math lib(s), fallback to $lib";carp($msg)if$warn_or_die==1;croak($msg)if$warn_or_die==2}last}else {if (($WARN{$lib}|| 0)< 2){my$ver=eval "\$$lib\::VERSION" || 'unknown';carp("Cannot load outdated $lib v$ver, please upgrade");$WARN{$lib}=2}}}}if ($LIB eq ''){if ($warn_or_die==2){croak("Couldn't load specified math lib(s)" ." and fallback disallowed")}else {croak("Couldn't load any math lib(s), not even fallback to Calc.pm")}}for my$class (keys%CALLBACKS){&{$CALLBACKS{$class}}($LIB)}}sub _register_callback {my ($class,$callback)=@_;if (ref($callback)ne 'CODE'){croak("$callback is not a coderef")}$CALLBACKS{$class}=$callback}sub _split_dec_string {my$str=shift;if ($str =~ s/
                     ^

                     # leading whitespace
                     ( \s* )

                     # optional sign
                     ( [+-]? )

                     # significand
                     (
                         \d+ (?: _ \d+ )*
                         (?:
                             \.
                             (?: \d+ (?: _ \d+ )* )?
                         )?
                     |
                         \.
                         \d+ (?: _ \d+ )*
                     )

                     # optional exponent
                     (?:
                         [Ee]
                         ( [+-]? )
                         ( \d+ (?: _ \d+ )* )
                     )?

                     # trailing stuff
                     ( \D .*? )?

                     \z
                 //x){my$leading=$1;my$significand_sgn=$2 || '+';my$significand_abs=$3;my$exponent_sgn=$4 || '+';my$exponent_abs=$5 || '0';my$trailing=$6;$significand_abs =~ tr/_//d;$exponent_abs =~ tr/_//d;$significand_abs =~ s/^0+(.)/$1/;$exponent_abs =~ s/^0+(.)/$1/;my$idx=index$significand_abs,'.';if ($idx > -1){$significand_abs =~ s/0+\z//;substr($significand_abs,$idx,1)='';my$exponent=$exponent_sgn .$exponent_abs;$exponent .= $idx - CORE::length($significand_abs);$exponent_abs=abs$exponent;$exponent_sgn=$exponent < 0 ? '-' : '+'}return($leading,$significand_sgn,$significand_abs,$exponent_sgn,$exponent_abs,$trailing)}return undef}sub _split {my$x=shift;$x =~ s/^\s*([-]?)0*([0-9])/$1$2/g;$x =~ s/^\s+//;$x =~ s/\s+$//g;if ($x =~ /^[+-]?[0-9]+\z/){$x =~ s/^([+-])0*([0-9])/$2/;my$sign=$1 || '+';return (\$sign,\$x,\'',\'',\0)}return if$x !~ /^[+-]?(\.?[0-9]|0b[0-1]|0x[0-9a-fA-F])/;return Math::BigInt->from_hex($x)if$x =~ /^[+-]?0x/;return Math::BigInt->from_bin($x)if$x =~ /^[+-]?0b/;$x =~ s/([0-9])_([0-9])/$1$2/g;$x =~ s/([0-9])_([0-9])/$1$2/g;my ($m,$e,$last)=split /[Ee]/,$x;return if defined$last;$e='0' if!defined$e || $e eq "";my ($es,$ev,$mis,$miv,$mfv);if ($e =~ /^([+-]?)0*([0-9]+)$/){$es=$1;$ev=$2;return if$m eq '.' || $m eq '';my ($mi,$mf,$lastf)=split /\./,$m;return if defined$lastf;$mi='0' if!defined$mi;$mi .= '0' if$mi =~ /^[\-\+]?$/;$mf='0' if!defined$mf || $mf eq '';if ($mi =~ /^([+-]?)0*([0-9]+)$/){$mis=$1 || '+';$miv=$2;return unless ($mf =~ /^([0-9]*?)0*$/);$mfv=$1;$ev=0 if$miv eq '0' && $mfv eq '';return (\$mis,\$miv,\$mfv,\$es,\$ev)}}return}sub _trailing_zeros {my$x=shift;$x=$class->new($x)unless ref$x;return 0 if$x->{sign}!~ /^[+-]$/;$LIB->_zeros($x->{value})}sub _scan_for_nonzero {my ($x,$pad,$xs,$len)=@_;return 0 if$len==1;my$follow=$pad - 1;return 0 if$follow > $len || $follow < 1;substr ($xs,-$follow)=~ /[^0]/ ? 1 : 0}sub _find_round_parameters {my ($self,$a,$p,$r,@args)=@_;my$class=ref($self);no strict 'refs';$a=$a->can('numify')? $a->numify(): "$a" if defined$a && ref($a);$p=$p->can('numify')? $p->numify(): "$p" if defined$p && ref($p);if (!defined$a){for ($self,@args){$a=$_->{_a}if (defined $_->{_a})&& (!defined$a || $_->{_a}< $a)}}if (!defined$p){for ($self,@args){$p=$_->{_p}if (defined $_->{_p})&& (!defined$p || $_->{_p}> $p)}}$a=${"$class\::accuracy"}unless defined$a;$p=${"$class\::precision"}unless defined$p;$a=undef if defined$a && $a==0;return ($self)unless defined$a || defined$p;return ($self->bnan())if defined$a && defined$p;$r=${"$class\::round_mode"}unless defined$r;if ($r !~ /^(even|odd|[+-]inf|zero|trunc|common)$/){croak("Unknown round mode '$r'")}$a=int($a)if defined$a;$p=int($p)if defined$p;($self,$a,$p,$r)}sub modify () {0}1;