package Pod::Checker;use strict;use warnings;our$VERSION='1.73';use Carp qw(croak);use Exporter 'import';use base qw/Pod::Simple::Methody/;our@EXPORT=qw(&podchecker);sub podchecker {my ($infile,$outfile,%options)=@_;local $_;$infile ||= \*STDIN;$outfile ||= \*STDERR;my$checker=Pod::Checker->new(%options);$checker->parse_from_file($infile,$outfile);return$checker->num_errors()}sub new {my$new=shift->SUPER::new(@_);$new->{'output_fh'}||= *STDERR{IO};my%opts=@_;$new->{'-warnings'}=defined$opts{'-warnings'}? $opts{'-warnings'}: 1;$new->{'-quiet'}=$opts{'-quiet'}|| 0;$new->{'_NUM_ERRORS'}=0;$new->{'_NUM_WARNINGS'}=0;$new->{'_thispara'}='';$new->{'_line'}=0;$new->{'_head_num'}=0;$new->{'_cmds_since_head'}=0;$new->{'_nodes'}=[];$new->{'_fcode_stack'}=[];$new->{'_fcode_pos'}=[];$new->{'_begin_stack'}=[];$new->{'_links'}=[];$new->{'_internal_links'}=[];$new->{'_index'}=[];$new->accept_targets('*');$new->cut_handler(\&handle_pod_and_cut);$new->pod_handler(\&handle_pod_and_cut);$new->whiteline_handler(\&handle_whiteline);$new->parse_empty_lists(1);return$new}sub poderror {my$self=shift;my%opts=(ref $_[0])? %{shift()}: ();chomp(my$msg=($opts{'-msg'}|| '')."@_");my$line=(exists$opts{'-line'})? " at line $opts{'-line'}" : '';my$file=' in file ' .((exists$opts{'-file'})? $opts{'-file'}: ((defined$self->source_filename)? $self->source_filename : "???"));unless (exists$opts{'-severity'}){$opts{'-severity'}=$1 if ($msg =~ s/^\**\s*([A-Z]{3,}):\s+//)}my$severity=(exists$opts{'-severity'})? "*** $opts{-severity}: " : '';++($self->{'_NUM_ERRORS'})if(!%opts || ($opts{-severity}&& $opts{'-severity'}eq 'ERROR'));++($self->{'_NUM_WARNINGS'})if(!%opts || ($opts{-severity}&& $opts{'-severity'}eq 'WARNING'));unless($self->{'-quiet'}){my$out_fh=$self->{'output_fh'}|| \*STDERR;print$out_fh ($severity,$msg,$line,$file,"\n")if($self->{'-warnings'}||!%opts || $opts{'-severity'}ne 'WARNING')}}sub num_errors {return (@_ > 1)? ($_[0]->{'_NUM_ERRORS'}=$_[1]): $_[0]->{'_NUM_ERRORS'}}sub num_warnings {return (@_ > 1)? ($_[0]->{'_NUM_WARNINGS'}=$_[1]): $_[0]->{'_NUM_WARNINGS'}}sub name {return (@_ > 1 && $_[1])? ($_[0]->{'_pod_name'}=$_[1]): $_[0]->{'_pod_name'}}sub node {my ($self,$text)=@_;if(defined$text){$text =~ s/\s+$//s;$text =~ s/\s+/ /gs;push(@{$self->{'_nodes'}},$text);$self->{'_unique_nodes'}->{$text}++ if($text !~ /^\s*$/s);return$text}@{$self->{'_nodes'}}}sub idx {my ($self,$text)=@_;if(defined$text){$text =~ s/\s+$//s;$text =~ s/\s+/ /gs;push(@{$self->{'_index'}},$text);$self->{'_unique_nodes'}->{$text}++ if($text !~ /^\s*$/s);return$text}@{$self->{'_index'}}}sub hyperlink {my$self=shift;push(@{$self->{'_links'}},$_[0]);return $_[0]}sub hyperlinks {@{shift->{'_links'}}}sub whine {my ($self,$line,$complaint)=@_;my$severity='ERROR';if (0){$severity='WARNING' if $complaint =~ /^Expected '=item .+?'$/ || $complaint =~ /^You can't have =items \(as at line .+?\) unless the first thing after the =over is an =item$/ || $complaint =~ /^You have '=item .+?' instead of the expected '=item .+?'$/}$self->poderror({-line=>$line,-severity=>$severity,-msg=>$complaint });return 1}sub scream {my ($self,$line,$complaint)=@_;$self->poderror({-line=>$line,-severity=>'ERROR',-msg=>$complaint });return 1}sub _init_event {$_[0]{'_thispara'}='';$_[0]{'_line'}=$_[1]{'start_line'};$_[0]{'_cmds_since_head'}++}sub _check_fcode {my ($self,$inner,$outers)=@_;return if$inner eq 'L' && $Pod::Simple::VERSION ge '3.33';if (grep {$_ eq $inner}@$outers){$self->poderror({-line=>$self->{'_line'},-severity=>'WARNING',-msg=>"nested commands $inner<...$inner<...>...>"})}}sub handle_text {$_[0]{'_thispara'}.= $_[1]}sub handle_whiteline {my ($line,$line_n,$self)=@_;$self->poderror({-line=>$line_n,-severity=>'WARNING',-msg=>'line containing nothing but whitespace in paragraph'})}sub handle_pod_and_cut {my ($line,$line_n,$self)=@_;$self->{'_cmds_since_head'}++;if ($line =~ /=(pod|cut)\s+\S/){$self->poderror({-line=>$line_n,-severity=>'ERROR',-msg=>"Spurious text after =$1"})}}sub start_Para {shift->_init_event(@_)}sub end_Para {my$self=shift;if ($self->{'_head_num'}==1 && $self->{'_head_text'}eq 'NAME'){if ($self->{'_thispara'}=~ /^\s*(\S+?)\s*[,-]/){$self->{'_pod_name'}=$1 unless defined$self->{'_pod_name'}}}}sub start_Verbatim {my$self=shift;$self->_init_event(@_);if ($self->{'_head_num'}==1 && $self->{'_head_text'}eq 'NAME'){$self->poderror({-line=>$self->{'_line'},-severity=>'WARNING',-msg=>'Verbatim paragraph in NAME section' })}}sub start_Data {shift->_init_event()}sub start_head1 {shift->start_head(1,@_)}sub start_head2 {shift->start_head(2,@_)}sub start_head3 {shift->start_head(3,@_)}sub start_head4 {shift->start_head(4,@_)}sub start_head {my$self=shift;my$h=shift;$self->_init_event(@_);my$prev_h=$self->{'_head_num'};$self->{'_head_num'}=$h;$self->{"_count_head$h"}++;if ($h > 1 &&!$self->{'_count_head'.($h-1)}){$self->poderror({-line=>$self->{'_line'},-severity=>'WARNING',-msg=>"=head$h without preceding higher level"})}if ($self->{'_cmds_since_head'}==1 && $prev_h >= $h){$self->poderror({-line=>$self->{'_line'},-severity=>'WARNING',-msg=>'empty section in previous paragraph'})}}sub end_head1 {shift->end_head(@_)}sub end_head2 {shift->end_head(@_)}sub end_head3 {shift->end_head(@_)}sub end_head4 {shift->end_head(@_)}sub end_head {my$self=shift;my$arg=$self->{'_thispara'};$arg =~ s/\s+$//;$self->{'_head_text'}=$arg;$self->{'_cmds_since_head'}=0;my$h=$self->{'_head_num'};$self->node($arg);if ($arg eq ''){$self->poderror({-line=>$self->{'_line'},-severity=>'ERROR',-msg=>"empty =head$h" })}}sub start_over_bullet {shift->start_over(@_,'bullet')}sub start_over_number {shift->start_over(@_,'number')}sub start_over_text {shift->start_over(@_,'definition')}sub start_over_block {shift->start_over(@_,'block')}sub start_over_empty {my$self=shift;$self->start_over(@_,'empty');$self->poderror({-line=>$self->{'_line'},-severity=>'WARNING',-msg=>'empty =over/=back block' })}sub start_over {my$self=shift;my$type=pop;$self->_init_event(@_)}sub start_item_bullet {shift->_init_event(@_)}sub start_item_number {shift->_init_event(@_)}sub start_item_text {shift->_init_event(@_)}sub end_item_bullet {shift->end_item('bullet')}sub end_item_number {shift->end_item('number')}sub end_item_text {shift->end_item('definition')}sub end_item {my$self=shift;my$type=shift;if ($self->{'_thispara'}eq '' && (!@{$self->{'paras'}}|| $self->{'paras'}[0][0]!~ /Verbatim/i)){$self->poderror({-line=>$self->{'_line'},-severity=>'WARNING',-msg=>'=item has no contents' })}$self->node($self->{'_thispara'})}sub start_for {my ($self,$flags)=@_;$self->_init_event($flags);push @{$self->{'_begin_stack'}},[$self->{'_line'},$flags->{'target'}]}sub end_for {my ($self,$flags)=@_;my ($line,$target)=@{pop @{$self->{'_begin_stack'}}};if ($flags->{'fake-closer'}){$self->poderror({-line=>$line,-severity=>'ERROR',-msg=>"=begin $target without matching =end $target" })}}sub end_Document {my$self=shift;$self->num_errors(-1)&& return unless$self->content_seen;my%nodes;for ($self->node()){$nodes{$_}=1;if(/^(\S+)\s+\S/){$nodes{$1}||= 2}}for ($self->idx()){$nodes{$_}=3}for my$link (@{$self->{'_internal_links'}}){my ($name,$line)=@$link;unless ($nodes{$name}){$self->poderror({-line=>$line,-severity=>'ERROR',-msg=>"unresolved internal link '$name'"})}}if ($self->{'-warnings'}> 1){for my$node (sort keys %{$self->{'_unique_nodes'}}){my$count=$self->{'_unique_nodes'}{$node};if ($count > 1){$self->poderror({-line=>'-',-severity=>'WARNING',-msg=>"multiple occurrences ($count) of link target "."'$node'"})}}}}sub start_B {shift->start_fcode('B')}sub start_C {shift->start_fcode('C')}sub start_F {shift->start_fcode('F')}sub start_I {shift->start_fcode('I')}sub start_S {shift->start_fcode('S')}sub start_fcode {my ($self,$fcode)=@_;unshift @{$self->{'_fcode_stack'}},$fcode}sub end_B {shift->end_fcode()}sub end_C {shift->end_fcode()}sub end_F {shift->end_fcode()}sub end_I {shift->end_fcode()}sub end_S {shift->end_fcode()}sub end_fcode {my$self=shift;$self->_check_fcode(shift @{$self->{'_fcode_stack'}},$self->{'_fcode_stack'})}sub start_L {my ($self,$flags)=@_;$self->start_fcode('L');my$link=Pod::Checker::Hyperlink->new($flags,$self);if ($link){if ($link->type eq 'pod' && $link->node && (!$link->page || ($self->{'_pod_name'}&& $link->page eq $self->{'_pod_name'}))){push @{$self->{'_internal_links'}},[$link->{'-raw_node'},$link->line ]}else {$self->hyperlink($link)}}}sub end_L {my$self=shift;$self->end_fcode()}sub start_X {my$self=shift;$self->start_fcode('X');push @{$self->{'_fcode_pos'}},length$self->{'_thispara'}}sub end_X {my$self=shift;my$start=pop @{$self->{'_fcode_pos'}};my$end=length($self->{'_thispara'})- $start;my$x=substr($self->{'_thispara'},$start,$end,'');if ($x eq ""){$self->poderror({-line=>$self->{'_line'},-severity=>'ERROR',-msg=>"An empty X<>" })}$self->idx($x);$self->end_fcode()}package Pod::Checker::Hyperlink;sub new {my ($class,$simple_link,$caller)=@_;my$self=+{};bless$self,$class;$self->{'-line'}||= $caller->{'_line'};$self->{'-type'}||= $simple_link->{'type'};$self->{'-page'}=exists$simple_link->{'to'}? "$simple_link->{'to'}" : "";$self->{'-node'}=exists$simple_link->{'section'}? "$simple_link->{'section'}" : "";$self->{'-raw_node'}=$self->{'-node'};$self->{'-page'}=~ s/ ^ \s+ //x;$self->{'-page'}=~ s/ \s+ $ //x;$self->{'-node'}=~ s/ ^ \s+ //x;$self->{'-node'}=~ s/ \s+ $ //x;if ($self->{'-page'}eq "" && $self->{'-node'}eq ""){$caller->poderror({-line=>$caller->{'_line'},-severity=>'WARNING',-msg=>'empty link'});return}return$self}sub line {return $_[0]->{-line}}sub type {return $_[0]->{-type}}sub page {return $_[0]->{-page}}sub node {return $_[0]->{-node}}1