package Unicode::UCD;use strict;use warnings;no warnings 'surrogate';use charnames ();our$VERSION='0.72';require Exporter;our@ISA=qw(Exporter);our@EXPORT_OK=qw(charinfo charblock charscript charblocks charscripts charinrange charprop charprops_all general_categories bidi_types compexcl casefold all_casefolds casespec namedseq num prop_aliases prop_value_aliases prop_values prop_invlist prop_invmap search_invlist MAX_CP);use Carp;sub IS_ASCII_PLATFORM {ord("A")==65}my$v_unicode_version;sub openunicode {my (@path)=@_;my$rfh;for my$d (@INC){use File::Spec;my$f=File::Spec->catfile($d,"unicore",@path);return$rfh if open($rfh,'<',$f)}croak __PACKAGE__,": failed to find ",File::Spec->catfile("unicore",@path)," in @INC"}sub _dclone ($) {use if defined&DynaLoader::boot_DynaLoader,Storable=>qw(dclone);return dclone(shift)if defined&dclone;my$arg=shift;my$type=ref$arg;return$arg unless$type;if ($type eq 'ARRAY'){my@return;for my$element (@$arg){push@return,&_dclone($element)}return \@return}elsif ($type eq 'HASH'){my%return;for my$key (keys %$arg){$return{$key}=&_dclone($arg->{$key})}return \%return}else {croak "_dclone can't handle " .$type}}sub _getcode {my$arg=shift;if ($arg =~ /^[1-9]\d*$/){return$arg}elsif ($arg =~ /^(?:0[xX])?([[:xdigit:]]+)$/){return CORE::hex($1)}elsif ($arg =~ /^[Uu]\+([[:xdigit:]]+)$/){my$decimal=CORE::hex($1);return$decimal if IS_ASCII_PLATFORM;return utf8::unicode_to_native($decimal)}return}my%real_to_rational;my@BIDIS;my@CATEGORIES;my@DECOMPOSITIONS;my@NUMERIC_TYPES;my%SIMPLE_LOWER;my%SIMPLE_TITLE;my%SIMPLE_UPPER;my%UNICODE_1_NAMES;my%ISO_COMMENT;my$Hangul_Syllables_re=eval 'qr/\p{Block=Hangul_Syllables}/';sub charinfo {use feature 'unicode_strings';use if defined&DynaLoader::boot_DynaLoader,"Unicode::Normalize"=>qw(getCombinClass NFD);my$arg=shift;my$code=_getcode($arg);croak __PACKAGE__,"::charinfo: unknown code '$arg'" unless defined$code;return if$code > 0x10FFFF;my%prop;my$char=chr($code);@CATEGORIES=_read_table("To/Gc.pl")unless@CATEGORIES;$prop{'category'}=_search(\@CATEGORIES,0,$#CATEGORIES,$code)// $utf8::SwashInfo{'ToGc'}{'missing'};return if grep {lc $_ eq 'unassigned'}prop_value_aliases('Gc',$prop{'category'});$prop{'code'}=sprintf "%04X",$code;$prop{'name'}=($char =~ /\p{Cntrl}/)? '<control>' : (charnames::viacode($code)// "");$prop{'combining'}=getCombinClass($code);@BIDIS=_read_table("To/Bc.pl")unless@BIDIS;$prop{'bidi'}=_search(\@BIDIS,0,$#BIDIS,$code)// $utf8::SwashInfo{'ToBc'}{'missing'};UnicodeVersion()unless defined$v_unicode_version;if ($v_unicode_version ge v2.0.0 && $char =~ $Hangul_Syllables_re){$prop{'decomposition'}=join " ",map {sprintf("%04X",$_)}unpack "U*",NFD($char)}else {@DECOMPOSITIONS=_read_table("Decomposition.pl")unless@DECOMPOSITIONS;$prop{'decomposition'}=_search(\@DECOMPOSITIONS,0,$#DECOMPOSITIONS,$code)// ""}if (!defined (my$value=num($char))){$prop{'decimal'}=$prop{'digit'}=$prop{'numeric'}=""}else {if ($char =~ /\d/){$prop{'decimal'}=$prop{'digit'}=$prop{'numeric'}=$value}else {$prop{'decimal'}="";@NUMERIC_TYPES=_read_table("To/Nt.pl")unless@NUMERIC_TYPES;if ((_search(\@NUMERIC_TYPES,0,$#NUMERIC_TYPES,$code)// "")eq 'Digit'){$prop{'digit'}=$prop{'numeric'}=$value}else {$prop{'digit'}="";$prop{'numeric'}=$real_to_rational{$value}// $value}}}$prop{'mirrored'}=($char =~ /\p{Bidi_Mirrored}/)? 'Y' : 'N';%UNICODE_1_NAMES=_read_table("To/Na1.pl","use_hash")unless%UNICODE_1_NAMES;$prop{'unicode10'}=$UNICODE_1_NAMES{$code}// "";UnicodeVersion()unless defined$v_unicode_version;if ($v_unicode_version ge v6.0.0){$prop{'comment'}=""}else {%ISO_COMMENT=_read_table("To/Isc.pl","use_hash")unless%ISO_COMMENT;$prop{'comment'}=(defined$ISO_COMMENT{$code})? $ISO_COMMENT{$code}: ""}%SIMPLE_UPPER=_read_table("To/Uc.pl","use_hash")unless%SIMPLE_UPPER;$prop{'upper'}=(defined$SIMPLE_UPPER{$code})? sprintf("%04X",$SIMPLE_UPPER{$code}): "";%SIMPLE_LOWER=_read_table("To/Lc.pl","use_hash")unless%SIMPLE_LOWER;$prop{'lower'}=(defined$SIMPLE_LOWER{$code})? sprintf("%04X",$SIMPLE_LOWER{$code}): "";%SIMPLE_TITLE=_read_table("To/Tc.pl","use_hash")unless%SIMPLE_TITLE;$prop{'title'}=(defined$SIMPLE_TITLE{$code})? sprintf("%04X",$SIMPLE_TITLE{$code}): "";$prop{block}=charblock($code);$prop{script}=charscript($code);return \%prop}sub _search {my ($table,$lo,$hi,$code)=@_;return if$lo > $hi;my$mid=int(($lo+$hi)/ 2);if ($table->[$mid]->[0]< $code){if ($table->[$mid]->[1]>= $code){return$table->[$mid]->[2]}else {_search($table,$mid + 1,$hi,$code)}}elsif ($table->[$mid]->[0]> $code){_search($table,$lo,$mid - 1,$code)}else {return$table->[$mid]->[2]}}sub _read_table ($;$) {my$table=shift;my$return_hash=shift;$return_hash=0 unless defined$return_hash;my@return;my%return;local $_;my$list=do "unicore/$table";require "unicore/Heavy.pl";my$property=$table =~ s/\.pl//r;$property=$utf8::file_to_swash_name{$property};my$to_adjust=defined$property && $utf8::SwashInfo{$property}{'format'}=~ / ^ a /x;for (split /^/m,$list){my ($start,$end,$value)=/ ^ (.+?) \t (.*?) \t (.+?)
                                        \s* ( \# .* )?  # Optional comment
                                        $ /x;my$decimal_start=hex$start;my$decimal_end=($end eq "")? $decimal_start : hex$end;$value=hex$value if$to_adjust && $utf8::SwashInfo{$property}{'format'}eq 'ax';if ($return_hash){for my$i ($decimal_start .. $decimal_end){$return{$i}=($to_adjust)? $value + $i - $decimal_start : $value}}elsif (!$to_adjust && @return && $return[-1][1]==$decimal_start - 1 && $return[-1][2]eq $value){$return[-1]->[1]=$decimal_end}else {push@return,[$decimal_start,$decimal_end,$value ]}}return ($return_hash)? %return : @return}sub charinrange {my ($range,$arg)=@_;my$code=_getcode($arg);croak __PACKAGE__,"::charinrange: unknown code '$arg'" unless defined$code;_search($range,0,$#$range,$code)}sub charprop ($$;$) {my ($input_cp,$prop,$internal_ok)=@_;my$cp=_getcode($input_cp);croak __PACKAGE__,"::charprop: unknown code point '$input_cp'" unless defined$cp;my ($list_ref,$map_ref,$format,$default)=prop_invmap($prop,$internal_ok);return undef unless defined$list_ref;my$i=search_invlist($list_ref,$cp);croak __PACKAGE__,"::charprop: prop_invmap return is invalid for charprop('$input_cp', '$prop)" unless defined$i;my$map=$map_ref->[$i];if (!ref$map){my$long_form=prop_value_aliases($prop,$map);$map=$long_form if defined$long_form}if ($format =~ / ^ s /x){return join ",",@$map if ref$map;if ($map =~ / ^ \d+ $ /ax && $default !~ / ^ \d+ $ /ax){$map=chr$map}elsif ($map =~ / ^ (?: Y | N ) $ /x){undef$map unless exists$Unicode::UCD::prop_aliases{utf8::_loose_name(lc$prop)}}return$map}elsif ($format eq 'ar'){my$offset=$cp - $list_ref->[$i];return$map if$map =~ /nan/i;return$map + $offset if$offset!=0;return eval$map}elsif ($format =~ /^a/){return join "",map {chr $_}@$map if ref$map;return "" if$map eq "" && $format =~ /^a.*e/;return chr$cp if$map eq "0";if ($map eq '<hangul syllable>' && $format eq 'ad'){use Unicode::Normalize qw(NFD);return NFD(chr$cp)}my$offset=$cp - $list_ref->[$i];return chr($map + $cp - $list_ref->[$i])}elsif ($format eq 'n'){if ($map =~ / ( .+ ) <code\ point> $ /x){$map=sprintf("$1%04X",$cp)}elsif ($map eq '<hangul syllable>'){$map=charnames::viacode($cp)}return$map}else {croak __PACKAGE__,"::charprop: Internal error: unknown format '$format'.  Please perlbug this"}}sub charprops_all($) {my$input_cp=shift;my$cp=_getcode($input_cp);croak __PACKAGE__,"::charprops_all: unknown code point '$input_cp'" unless defined$cp;my%return;require "unicore/UCD.pl";for my$prop (keys%Unicode::UCD::prop_aliases){next if$prop eq 'perldecimaldigit';$return{scalar prop_aliases($prop)}=charprop($cp,$prop)}return \%return}my@BLOCKS;my%BLOCKS;sub _charblocks {unless (@BLOCKS){UnicodeVersion()unless defined$v_unicode_version;if ($v_unicode_version lt v2.0.0){my$subrange=[0,0x10FFFF,'No_Block' ];push@BLOCKS,$subrange;push @{$BLOCKS{'No_Block'}},$subrange}else {my$blocksfh=openunicode("Blocks.txt");local $_;local $/="\n";while (<$blocksfh>){$_ =~ s/;\s+/../ if$v_unicode_version lt v3.1.0;if (/^([0-9A-F]+)\.\.([0-9A-F]+);\s+(.+)/){my ($lo,$hi)=(hex($1),hex($2));my$subrange=[$lo,$hi,$3 ];push@BLOCKS,$subrange;push @{$BLOCKS{$3}},$subrange}}if (!IS_ASCII_PLATFORM){my@new_blocks=_read_table("To/Blk.pl");shift@BLOCKS;shift@BLOCKS;delete$BLOCKS{'Basic Latin'};delete$BLOCKS{'Latin-1 Supplement'};for my$i (0.. @new_blocks - 1){if ($new_blocks[$i][2]=~ s/Basic_Latin/Basic Latin/ or $new_blocks[$i][2]=~ s/Latin_1_Supplement/Latin-1 Supplement/){push @{$BLOCKS{$new_blocks[$i][2]}},$new_blocks[$i]}else {splice@new_blocks,$i;last}}unshift@BLOCKS,@new_blocks}}}}sub charblock {my$arg=shift;_charblocks()unless@BLOCKS;my$code=_getcode($arg);if (defined$code){my$result=_search(\@BLOCKS,0,$#BLOCKS,$code);return$result if defined$result;return 'No_Block'}elsif (exists$BLOCKS{$arg}){return _dclone$BLOCKS{$arg}}carp __PACKAGE__,"::charblock: unknown code '$arg'";return}my@SCRIPTS;my%SCRIPTS;sub _charscripts {unless (@SCRIPTS){UnicodeVersion()unless defined$v_unicode_version;if ($v_unicode_version lt v3.1.0){push@SCRIPTS,[0,0x10FFFF,'Unknown' ]}else {@SCRIPTS=_read_table("To/Sc.pl")}}for my$entry (@SCRIPTS){$entry->[2]=~ s/(_\w)/\L$1/g;push @{$SCRIPTS{$entry->[2]}},$entry}}sub charscript {my$arg=shift;_charscripts()unless@SCRIPTS;my$code=_getcode($arg);if (defined$code){my$result=_search(\@SCRIPTS,0,$#SCRIPTS,$code);return$result if defined$result;return$utf8::SwashInfo{'ToSc'}{'missing'}}elsif (exists$SCRIPTS{$arg}){return _dclone$SCRIPTS{$arg}}carp __PACKAGE__,"::charscript: unknown code '$arg'";return}sub charblocks {_charblocks()unless%BLOCKS;return _dclone \%BLOCKS}sub charscripts {_charscripts()unless%SCRIPTS;return _dclone \%SCRIPTS}my%GENERAL_CATEGORIES=('L'=>'Letter','LC'=>'CasedLetter','Lu'=>'UppercaseLetter','Ll'=>'LowercaseLetter','Lt'=>'TitlecaseLetter','Lm'=>'ModifierLetter','Lo'=>'OtherLetter','M'=>'Mark','Mn'=>'NonspacingMark','Mc'=>'SpacingMark','Me'=>'EnclosingMark','N'=>'Number','Nd'=>'DecimalNumber','Nl'=>'LetterNumber','No'=>'OtherNumber','P'=>'Punctuation','Pc'=>'ConnectorPunctuation','Pd'=>'DashPunctuation','Ps'=>'OpenPunctuation','Pe'=>'ClosePunctuation','Pi'=>'InitialPunctuation','Pf'=>'FinalPunctuation','Po'=>'OtherPunctuation','S'=>'Symbol','Sm'=>'MathSymbol','Sc'=>'CurrencySymbol','Sk'=>'ModifierSymbol','So'=>'OtherSymbol','Z'=>'Separator','Zs'=>'SpaceSeparator','Zl'=>'LineSeparator','Zp'=>'ParagraphSeparator','C'=>'Other','Cc'=>'Control','Cf'=>'Format','Cs'=>'Surrogate','Co'=>'PrivateUse','Cn'=>'Unassigned',);sub general_categories {return _dclone \%GENERAL_CATEGORIES}my%BIDI_TYPES=('L'=>'Left-to-Right','LRE'=>'Left-to-Right Embedding','LRO'=>'Left-to-Right Override','R'=>'Right-to-Left','AL'=>'Right-to-Left Arabic','RLE'=>'Right-to-Left Embedding','RLO'=>'Right-to-Left Override','PDF'=>'Pop Directional Format','EN'=>'European Number','ES'=>'European Number Separator','ET'=>'European Number Terminator','AN'=>'Arabic Number','CS'=>'Common Number Separator','NSM'=>'Non-Spacing Mark','BN'=>'Boundary Neutral','B'=>'Paragraph Separator','S'=>'Segment Separator','WS'=>'Whitespace','ON'=>'Other Neutrals',);sub bidi_types {return _dclone \%BIDI_TYPES}my$Composition_Exclusion_re=eval 'qr/\p{Composition_Exclusion}/';sub compexcl {my$arg=shift;my$code=_getcode($arg);croak __PACKAGE__,"::compexcl: unknown code '$arg'" unless defined$code;UnicodeVersion()unless defined$v_unicode_version;return if$v_unicode_version lt v3.0.0;no warnings "non_unicode";return chr($code)=~ $Composition_Exclusion_re}my%CASEFOLD;sub _casefold {unless (%CASEFOLD){my ($full_invlist_ref,$full_invmap_ref,undef,$default)=prop_invmap('Case_Folding');for my$i (0 .. @$full_invlist_ref - 1 - 1){next if$full_invmap_ref->[$i]==$default;my$adjust=-1;for my$j ($full_invlist_ref->[$i].. $full_invlist_ref->[$i+1]-1){$adjust++;if (!ref$full_invmap_ref->[$i]){$CASEFOLD{$j}{'status'}='C';$CASEFOLD{$j}{'simple'}=$CASEFOLD{$j}{'full'}=$CASEFOLD{$j}{'mapping'}=sprintf("%04X",$full_invmap_ref->[$i]+ $adjust);$CASEFOLD{$j}{'code'}=sprintf("%04X",$j);$CASEFOLD{$j}{'turkic'}=""}else {$CASEFOLD{$j}{'status'}='F';$CASEFOLD{$j}{'full'}=$CASEFOLD{$j}{'mapping'}=join " ",map {sprintf "%04X",$_}@{$full_invmap_ref->[$i]};$CASEFOLD{$j}{'simple'}="";$CASEFOLD{$j}{'code'}=sprintf("%04X",$j);$CASEFOLD{$j}{'turkic'}=""}}}(my ($simple_invlist_ref,$simple_invmap_ref,undef),$default)=prop_invmap('Simple_Case_Folding');for my$i (0 .. @$simple_invlist_ref - 1 - 1){next if$simple_invmap_ref->[$i]==$default;my$adjust=-1;for my$j ($simple_invlist_ref->[$i].. $simple_invlist_ref->[$i+1]-1){$adjust++;next if$CASEFOLD{$j}{'status'}eq 'C';$CASEFOLD{$j}{'status'}='S';$CASEFOLD{$j}{'simple'}=$CASEFOLD{$j}{'mapping'}=sprintf("%04X",$simple_invmap_ref->[$i]+ $adjust);$CASEFOLD{$j}{'code'}=sprintf("%04X",$j);$CASEFOLD{$j}{'turkic'}=""}}UnicodeVersion()unless defined$v_unicode_version;if ($v_unicode_version ge v3.2.0){$CASEFOLD{ord('I')}{'turkic'}='0131';$CASEFOLD{0x130}{'turkic'}=sprintf "%04X",ord('i')}elsif ($v_unicode_version ge v3.1.0){$CASEFOLD{0x130}{'code'}='0130';$CASEFOLD{0x131}{'code'}='0131';$CASEFOLD{0x130}{'status'}=$CASEFOLD{0x131}{'status'}='I';$CASEFOLD{0x130}{'turkic'}=$CASEFOLD{0x130}{'mapping'}=$CASEFOLD{0x130}{'full'}=$CASEFOLD{0x130}{'simple'}=$CASEFOLD{0x131}{'turkic'}=$CASEFOLD{0x131}{'mapping'}=$CASEFOLD{0x131}{'full'}=$CASEFOLD{0x131}{'simple'}=sprintf "%04X",ord('i')}}}sub casefold {my$arg=shift;my$code=_getcode($arg);croak __PACKAGE__,"::casefold: unknown code '$arg'" unless defined$code;_casefold()unless%CASEFOLD;return$CASEFOLD{$code}}sub all_casefolds () {_casefold()unless%CASEFOLD;return _dclone \%CASEFOLD}my%CASESPEC;sub _casespec {unless (%CASESPEC){UnicodeVersion()unless defined$v_unicode_version;if ($v_unicode_version ge v2.1.8){my$casespecfh=openunicode("SpecialCasing.txt");local $_;local $/="\n";while (<$casespecfh>){if (/^([0-9A-F]+); ([0-9A-F]+(?: [0-9A-F]+)*)?; ([0-9A-F]+(?: [0-9A-F]+)*)?; ([0-9A-F]+(?: [0-9A-F]+)*)?; (\w+(?: \w+)*)?/){my ($hexcode,$lower,$title,$upper,$condition)=($1,$2,$3,$4,$5);if (!IS_ASCII_PLATFORM){for my$var_ref (\$hexcode,\$lower,\$title,\$upper){next unless defined $$var_ref;$$var_ref=join " ",map {sprintf("%04X",utf8::unicode_to_native(hex $_))}split " ",$$var_ref}}my$code=hex($hexcode);if (exists$CASESPEC{$code}&& $v_unicode_version ne v2.1.8){if (exists$CASESPEC{$code}->{code}){my ($oldlower,$oldtitle,$oldupper,$oldcondition)=@{$CASESPEC{$code}}{qw(lower title upper condition)};if (defined$oldcondition){my ($oldlocale)=($oldcondition =~ /^([a-z][a-z](?:_\S+)?)/);delete$CASESPEC{$code};$CASESPEC{$code}->{$oldlocale}={code=>$hexcode,lower=>$oldlower,title=>$oldtitle,upper=>$oldupper,condition=>$oldcondition }}}my ($locale)=($condition =~ /^([a-z][a-z](?:_\S+)?)/);$CASESPEC{$code}->{$locale}={code=>$hexcode,lower=>$lower,title=>$title,upper=>$upper,condition=>$condition }}else {$CASESPEC{$code}={code=>$hexcode,lower=>$lower,title=>$title,upper=>$upper,condition=>$condition }}}}}}}sub casespec {my$arg=shift;my$code=_getcode($arg);croak __PACKAGE__,"::casespec: unknown code '$arg'" unless defined$code;_casespec()unless%CASESPEC;return ref$CASESPEC{$code}? _dclone$CASESPEC{$code}: $CASESPEC{$code}}my%NAMEDSEQ;sub _namedseq {unless (%NAMEDSEQ){my$namedseqfh=openunicode("Name.pl");local $_;local $/="\n";while (<$namedseqfh>){if (/^ [0-9A-F]+ \  /x){chomp;my ($sequence,$name)=split /\t/;my@s=map {chr(hex($_))}split(' ',$sequence);$NAMEDSEQ{$name}=join("",@s)}}}}sub namedseq {my$wantarray=wantarray();if (defined$wantarray){if ($wantarray){if (@_==0){_namedseq()unless%NAMEDSEQ;return%NAMEDSEQ}elsif (@_==1){my$s;if (%NAMEDSEQ){$s=$NAMEDSEQ{$_[0]}}else {$s=charnames::string_vianame($_[0])}return defined$s ? map {ord($_)}split('',$s): ()}}elsif (@_==1){return$NAMEDSEQ{$_[0]}if%NAMEDSEQ;return charnames::string_vianame($_[0])}}return}my%NUMERIC;sub _numeric {my@numbers=_read_table("To/Nv.pl");for my$entry (@numbers){my ($start,$end,$value)=@$entry;if ((my@rational=split /\//,$value)==2){my$real=$rational[0]/ $rational[1];$real_to_rational{$real}=$value;$value=$real;for my$i ($start .. $end){$NUMERIC{$i}=$value}}else {for my$i ($start .. $end){$NUMERIC{$i}=$value + $i - $start}}}return}sub num ($;$) {my ($string,$retlen_ref)=@_;use feature 'unicode_strings';_numeric unless%NUMERIC;$$retlen_ref=0 if$retlen_ref;my$length=length$string;return if$length==0;my$first_ord=ord(substr($string,0,1));return if!exists$NUMERIC{$first_ord}||!defined$NUMERIC{$first_ord};my$value=$NUMERIC{$first_ord};$$retlen_ref=1 if$retlen_ref;return$value if$length==1;return if$string =~ / ^ \D /x;my$zero_ord=$first_ord - $value;UnicodeVersion()unless defined$v_unicode_version;if ($v_unicode_version lt v6.0.0){for my$i (0 .. 9){my$ord=$zero_ord + $i;return unless chr($ord)=~ /\d/;my$numeric=$NUMERIC{$ord};return unless defined$numeric;return unless$numeric==$i}}for my$i (1 .. $length -1){my$ord=ord(substr($string,$i,1));my$digit=$ord - $zero_ord;if ($digit < 0 || $digit > 9){$$retlen_ref=$i if$retlen_ref;return}$value=$value * 10 + $digit}$$retlen_ref=$length if$retlen_ref;return$value}our%string_property_loose_to_name;our%ambiguous_names;our%loose_perlprop_to_name;our%prop_aliases;sub prop_aliases ($) {my$prop=$_[0];return unless defined$prop;require "unicore/UCD.pl";require "unicore/Heavy.pl";require "utf8_heavy.pl";$prop=lc$prop;my$list_ref;if (!exists$utf8::stricter_to_file_of{$prop}){my$loose=utf8::_loose_name($prop);if (exists$string_property_loose_to_name{$loose}){$prop=$string_property_loose_to_name{$loose}}else {my$retrying=0;RETRY: if (exists$utf8::loose_property_name_of{$loose}&& (!$retrying ||!exists$ambiguous_names{$loose})){$prop=$utf8::loose_property_name_of{$loose}}elsif (exists$loose_perlprop_to_name{$loose}){$list_ref=$loose_perlprop_to_name{$loose};if (@$list_ref==1){my@list=($list_ref->[0],$list_ref->[0]);$list_ref=\@list}}elsif (!exists$utf8::loose_to_file_of{$loose}){return}elsif ($loose =~ / [:=] /x){return}else {my@list;for my$property ("gc","script"){@list=prop_value_aliases($property,$loose);last if@list}if (@list){for my$i (0 .. @list -1){if (exists$ambiguous_names {utf8::_loose_name(lc$list[$i])}){$list[$i]=~ s/^Is_// or $list[$i]=~ s/^/Is_/}}return@list}my$began_with_in=$loose =~ s/^in(?!dic)//;@list=prop_value_aliases("block",$loose);if (@list){map {$_ =~ s/^/In_/}@list;return@list}if (!$retrying &&!$began_with_in && $loose =~ s/^is//){$retrying=1;goto RETRY}carp __PACKAGE__,"::prop_aliases: Unexpectedly could not find '$prop'.  Send bug report to perlbug\@perl.org";return}}}if (!$list_ref){$list_ref=$prop_aliases{$prop}if exists$prop_aliases{$prop};return unless$list_ref}return$list_ref->[1]unless wantarray;return @{_dclone$list_ref}}our%loose_to_standard_value;our%prop_value_aliases;sub prop_values ($) {my$prop=shift;return undef unless defined$prop;require "unicore/UCD.pl";require "utf8_heavy.pl";($prop)=prop_aliases($prop);return undef if!$prop;$prop=utf8::_loose_name(lc$prop);return undef unless exists$prop_value_aliases{$prop};my@return;for my$value_key (sort {lc$a cmp lc$b}keys %{$prop_value_aliases{$prop}}){push@return,$prop_value_aliases{$prop}{$value_key}[0]}return@return}sub prop_value_aliases ($$) {my ($prop,$value)=@_;return unless defined$prop && defined$value;require "unicore/UCD.pl";require "utf8_heavy.pl";($prop)=prop_aliases($prop);return if!$prop;$prop=utf8::_loose_name(lc$prop);if (!exists$prop_value_aliases{$prop}){return if!exists$Unicode::UCD::prop_aliases{$prop};return$value}$value=lc$value;my$loose_value=utf8::_loose_name($value);return unless exists$loose_to_standard_value{"$prop=$loose_value"};my$standard_value=$loose_to_standard_value{"$prop=$loose_value"};return unless exists$prop_value_aliases{$prop}{$standard_value};if (!exists$utf8::stricter_to_file_of{"$prop=$value"}&& exists$utf8::stricter_to_file_of{"$prop=$loose_value"}){while ($value =~ s/(\d)_(\d)/$1$2/g){}return unless exists$utf8::stricter_to_file_of{"$prop=$value"}}my$list_ref=$prop_value_aliases{$prop}{$standard_value};if (@$list_ref > 1){return$list_ref->[1]unless wantarray;return @{_dclone$list_ref}}return$list_ref->[0]unless wantarray;return ($list_ref->[0],$list_ref->[0])}$Unicode::UCD::MAX_CP=(~0)>> 1;our%loose_defaults;our$MAX_UNICODE_CODEPOINT;sub prop_invlist ($;$) {my$prop=$_[0];my$internal_ok=defined $_[1]&& $_[1]eq '_perl_core_internal_ok';return if!defined$prop;require "utf8_heavy.pl";no warnings 'deprecated';my$swash=utf8::SWASHNEW(__PACKAGE__,$prop,undef,1,0);return if!$swash || ref$swash eq "" || $swash->{'BITS'}!=1 || $swash->{'USER_DEFINED'}|| (!$internal_ok && $prop =~ /^\s*_/);if ($swash->{'EXTRAS'}){carp __PACKAGE__,"::prop_invlist: swash returned for $prop unexpectedly has EXTRAS magic";return}if ($swash->{'SPECIALS'}){carp __PACKAGE__,"::prop_invlist: swash returned for $prop unexpectedly has SPECIALS magic";return}my@invlist;if ($swash->{'LIST'}=~ /^V/){@invlist=split "\n",$swash->{'LIST'}=~ s/ \s* (?: \# .* )? $ //xmgr;shift@invlist}else {for my$range (split "\n",$swash->{'LIST'}=~ s/ \s* (?: \# .* )? $ //xmgr){my ($hex_begin,$hex_end)=split "\t",$range;my$begin=hex$hex_begin;if (@invlist && $begin==$invlist[-1]){pop@invlist}else {push@invlist,$begin}if (defined$hex_end){no warnings 'portable';my$end=hex$hex_end;last if$end==$Unicode::UCD::MAX_CP;push@invlist,$end + 1}else {push@invlist,$begin + 1}}}if ($swash->{'INVERT_IT'}){if (@invlist && $invlist[0]==0){shift@invlist}else {unshift@invlist,0}}return@invlist}our@algorithmic_named_code_points;our$HANGUL_BEGIN;our$HANGUL_COUNT;sub prop_invmap ($;$) {croak __PACKAGE__,"::prop_invmap: must be called in list context" unless wantarray;my$prop=$_[0];return unless defined$prop;my$internal_ok=defined $_[1]&& $_[1]eq '_perl_core_internal_ok';return if$prop =~ /^_/ &&!$internal_ok;my (@invlist,@invmap,$format,$missing);my$overrides;require "utf8_heavy.pl";require "unicore/UCD.pl";RETRY: my$has_multiples=0;my$swash=utf8::SWASHNEW(__PACKAGE__,"To$prop",undef,32,0);if (ref$swash eq "" || $swash->{'TYPE'}=~ / ^ To (?: Blk | Na | NFKCCF ) $ /x){my ($second_try)=prop_aliases($prop);return unless$second_try;$second_try=utf8::_loose_name(lc$second_try);if ($second_try eq "in"){$prop="age";goto RETRY}elsif ($second_try =~ / ^ s ( cf | fc | [ltu] c ) $ /x){$overrides=-1;$prop=$1;$prop='cf' if$prop eq 'fc';goto RETRY}elsif ($second_try eq "blk"){_charblocks();my%blocks;$blocks{'LIST'}="";$blocks{'TYPE'}="ToBlk";$utf8::SwashInfo{ToBlk}{'missing'}="No_Block";$utf8::SwashInfo{ToBlk}{'format'}="s";for my$block (@BLOCKS){$blocks{'LIST'}.= sprintf "%x\t%x\t%s\n",$block->[0],$block->[1],$block->[2]}$swash=\%blocks}elsif ($second_try eq "na"){my%names;$names{'LIST'}="";my$original=do "unicore/Name.pl";my$algorithm_names=\@algorithmic_named_code_points;my ($aliases_code_points,$aliases_maps,undef,undef)=&prop_invmap("_Perl_Name_Alias",'_perl_core_internal_ok');my%aliases;for (my$i=0;$i < @$aliases_code_points;$i++){my$code_point=$aliases_code_points->[$i];$aliases{$code_point}=$aliases_maps->[$i];if (!ref$aliases{$code_point}){$aliases{$code_point}=[$aliases{$code_point}]}map {s/:.*//}@{$aliases{$code_point}}}my$i=0;for my$line (split "\n",$original){my ($hex_code_point,$name)=split "\t",$line;next if$hex_code_point =~ /[^[:xdigit:]]/a;my$code_point=hex$hex_code_point;next if chr($code_point)=~ /[[:cntrl:]]/u;next if grep {$_ eq $name}@{$aliases{$code_point}};while ($i < @$algorithm_names && $code_point > $algorithm_names->[$i]->{'low'}){$names{'LIST'}.= sprintf "%x\t%x\t%s\n",$algorithm_names->[$i]->{'low'},$algorithm_names->[$i]->{'high'},$algorithm_names->[$i]->{'name'};$i++}$names{'LIST'}.= sprintf "%x\t\t%s\n",$code_point,$name}$names{'TYPE'}="ToNa";$utf8::SwashInfo{ToNa}{'missing'}="";$utf8::SwashInfo{ToNa}{'format'}="n";$swash=\%names}elsif ($second_try =~ / ^ ( d [mt] ) $ /x){my$original=do "unicore/Decomposition.pl";my%decomps;if ($second_try eq 'dt'){$decomps{'TYPE'}="ToDt";$utf8::SwashInfo{'ToDt'}{'missing'}="None";$utf8::SwashInfo{'ToDt'}{'format'}="s"}$decomps{'LIST'}="";UnicodeVersion()unless defined$v_unicode_version;my$done_hangul=($v_unicode_version lt v2.0.0)? 1 : 0;for my$line (split "\n",$original){my ($hex_lower,$hex_upper,$type_and_map)=split "\t",$line;my$code_point=hex$hex_lower;my$value;my$redo=0;if ($type_and_map =~ / ^ < ( .* ) > \s+ (.*) $ /x){$value=($second_try eq 'dt')? $1 : $2}else {$value=($second_try eq 'dt')? "Canonical" : $type_and_map}if (!$done_hangul && $code_point > $HANGUL_BEGIN){$done_hangul=1;$decomps{'LIST'}.= sprintf "%x\t%x\t%s\n",$HANGUL_BEGIN,$HANGUL_BEGIN + $HANGUL_COUNT - 1,($second_try eq 'dt')? "Canonical" : "<hangul syllable>"}if ($value =~ / / && $hex_upper ne "" && $hex_upper ne $hex_lower){$line=sprintf("%04X\t%s\t%s",hex($hex_lower)+ 1,$hex_upper,$value);$hex_upper="";$redo=1}$decomps{'LIST'}.= "$hex_lower\t$hex_upper\t$value\n";redo if$redo}$swash=\%decomps}elsif ($second_try ne 'nfkccf'){return}if ($second_try eq 'nfkccf' || $second_try eq 'dm'){my%revised_swash;my$list="";my@ranges=split "\n",$swash->{'LIST'};for (my$i=0;$i < @ranges;$i++){my ($hex_begin,$hex_end,$map)=split "\t",$ranges[$i];my@map=split " ",$map;if (@map > 1){if ($map eq '<hangul syllable>'){$list .= "$ranges[$i]\n"}else {croak __PACKAGE__,"::prop_invmap: Not expecting a mapping with multiple code points in a multi-element range, $ranges[$i]" if$hex_end ne "" && $hex_end ne $hex_begin;$list .= "$hex_begin\t\t" .join(" ",map {hex}@map)."\n"}next}my$begin=hex$hex_begin;my$end=(defined$hex_end && $hex_end ne "")? hex$hex_end : $begin;my$decimal_map=hex$map;if ($begin!=$end || $i==@ranges -1){for my$code_point ($begin .. $end){$list .= sprintf("%04X\t\t%d\n",$code_point,$decimal_map)}}else {my$offset=0;my$squished=0;for (;$i < @ranges;$i++){my ($next_hex_begin,$next_hex_end,$next_map)=split "\t",$ranges[$i+1];last if$next_map =~ / /;$offset++;my$next_decimal_map=hex$next_map;last if$next_decimal_map!=$decimal_map + $offset;my$next_begin=hex$next_hex_begin;last if$next_begin!=$begin + $offset;my$next_end=(defined$next_hex_end && $next_hex_end ne "")? hex$next_hex_end : $next_begin;last if$next_end!=$next_begin;$squished=1}if ($squished){my ($hex_end,undef,undef)=split "\t",$ranges[$i];$list .= "$hex_begin\t$hex_end\t$decimal_map\n"}else {$list .= "$hex_begin\t\t$decimal_map\n"}}}my$type=($second_try eq 'nfkccf')? 'ToNFKCCF' : 'ToDm';$revised_swash{'LIST'}=$list;$revised_swash{'TYPE'}=$type;$revised_swash{'SPECIALS'}=$swash->{'SPECIALS'};$swash=\%revised_swash;$utf8::SwashInfo{$type}{'missing'}=0;$utf8::SwashInfo{$type}{'format'}='a'}}if ($swash->{'EXTRAS'}){carp __PACKAGE__,"::prop_invmap: swash returned for $prop unexpectedly has EXTRAS magic";return}my$returned_prop=$swash->{'TYPE'};$missing=$utf8::SwashInfo{$returned_prop}{'missing'};$missing='N' unless defined$missing;$format=$utf8::SwashInfo{$returned_prop}{'format'};$format='b' unless defined$format;my$requires_adjustment=$format =~ /^a/;if ($swash->{'LIST'}=~ /^V/){@invlist=split "\n",$swash->{'LIST'}=~ s/ \s* (?: \# .* )? $ //xmgr;shift@invlist;if ($swash->{'INVERT_IT'}){if (@invlist && $invlist[0]==0){shift@invlist}else {unshift@invlist,0}}if (@invlist){for my$i (0 .. @invlist - 1){$invmap[$i]=($i % 2==0)? 'Y' : 'N'}if ($invlist[0]!=0){unshift@invlist,0;unshift@invmap,'N'}}}else {if ($swash->{'INVERT_IT'}){croak __PACKAGE__,":prop_invmap: Don't know how to deal with inverted"}for my$range (split "\n",$swash->{'LIST'}){$range =~ s/ \s* (?: \# .* )? $ //xg;my ($hex_begin,$hex_end,$map)=split "\t",$range;my$begin=hex$hex_begin;no warnings 'portable';my$end=(defined$hex_end && $hex_end ne "")? hex$hex_end : $begin;if (!@invlist){if ($begin!=0){push@invlist,0;push@invmap,$missing}}elsif (@invlist > 1 && $invlist[-2]==$begin){if ($end!=$begin){croak __PACKAGE__,":prop_invmap: Multiple maps per code point in '$prop' require single-element ranges: begin=$begin, end=$end, map=$map"}if (!ref$invmap[-2]){$invmap[-2]=[$invmap[-2],$map ]}else {push @{$invmap[-2]},$map}$has_multiples=1;next}elsif ($invlist[-1]==$begin){if (!$requires_adjustment && @invlist > 1 && ((defined$map)? $invmap[-2]eq $map : $invmap[-2]eq 'Y')){$invlist[-1]=$end + 1;next}pop@invlist;pop@invmap}push@invlist,$begin;if ($returned_prop eq 'ToDm'){if ($map =~ /^ < /x){push@invmap,$map}else {my@map=split " ",$map;if (@map==1){push@invmap,$map[0]}else {push@invmap,\@map}}}else {$map=($format eq 'x' || $format eq 'ax')? hex$map : $format eq 'b' ? 'Y' : $map;push@invmap,$map}if ($end < $Unicode::UCD::MAX_CP){push@invlist,$end + 1;push@invmap,$missing}}}if (!@invlist){push@invlist,0;push@invmap,$missing}if ($invlist[-1]!=$MAX_UNICODE_CODEPOINT + 1){push@invmap,$invmap[-1];push@invlist,$MAX_UNICODE_CODEPOINT + 1}$overrides=$swash->{'SPECIALS'}unless defined$overrides;if ($overrides){if ($overrides < 0){$format='a'}else {$format='al';for my$cp_maybe_utf8 (keys %$overrides){my$cp;my@map;if ($overrides==$swash->{'SPECIALS'}){$cp=$cp_maybe_utf8;if (!utf8::decode($cp)){croak __PACKAGE__,"::prop_invmap: Malformed UTF-8: ",map {sprintf("\\x{%02X}",unpack("C",$_))}split "",$cp}$cp=unpack("W",$cp);@map=unpack "W*",$swash->{'SPECIALS'}{$cp_maybe_utf8};$format='ale' if@map==0}else {$cp=$cp_maybe_utf8;@map=hex$overrides->{$cp};$format='a'}my$i=search_invlist(\@invlist,$cp);if ($cp < $invlist[$i]|| $cp >= $invlist[$i + 1]){croak __PACKAGE__,"::prop_invmap: wrong_range, cp=$cp; i=$i, current=$invlist[$i]; next=$invlist[$i + 1]"}my$cur_map=$invmap[$i];if ($invlist[$i + 1]> $cp + 1){splice@invlist,$i + 1,0,$cp + 1;splice@invmap,$i + 1,0,$cur_map}if ($invlist[$i]< $cp){$i++;splice@invlist,$i,0,$cp;splice@invmap,$i,0,'dummy'}$invmap[$i]=(scalar@map==0)? "" : (scalar@map > 1)? \@map : $map[0]}}}elsif ($format eq 'x'){$format='s'}elsif ($returned_prop eq 'ToDm'){$format='ad'}elsif ($format eq 'sw'){map {$_=[split " ",$_ ]if $_ =~ / /}@invmap;$format='sl'}elsif ($returned_prop =~ / To ( _Perl )? NameAlias/x){$format='sl'}elsif ($returned_prop eq 'ToPerlDecimalDigit'){$format='ae'}elsif ($returned_prop eq 'ToNv'){$format='ar'}elsif ($format eq 'ax'){$format='a'}elsif ($format ne 'n' && $format !~ / ^ a /x){$format='s'}if ($has_multiples && $format !~ /l/){croak __PACKAGE__,"::prop_invmap: Wrong format '$format' for prop_invmap('$prop'); should indicate has lists"}return (\@invlist,\@invmap,$format,$missing)}sub search_invlist {my$list_ref=shift;my$input_code_point=shift;my$code_point=_getcode($input_code_point);if (!defined$code_point){carp __PACKAGE__,"::search_invlist: unknown code '$input_code_point'";return}my$max_element=@$list_ref - 1;return if$max_element < 0;return if$code_point < $list_ref->[0];return$max_element if$code_point >= $list_ref->[$max_element];use integer;my$i=$max_element / 2;my$lower=0;my$upper=$max_element;while (1){if ($code_point >= $list_ref->[$i]){last if$code_point < $list_ref->[$i+1];$lower=$i}else {$upper=$i}my$temp=($upper + $lower)/ 2;return$i if$temp==$i;$i=$temp}return$i}my$UNICODEVERSION;sub UnicodeVersion {unless (defined$UNICODEVERSION){my$versionfh=openunicode("version");local $/="\n";chomp($UNICODEVERSION=<$versionfh>);croak __PACKAGE__,"::VERSION: strange version '$UNICODEVERSION'" unless$UNICODEVERSION =~ /^\d+(?:\.\d+)+$/}$v_unicode_version=pack "C*",split /\./,$UNICODEVERSION;return$UNICODEVERSION}1;