use strict;use Algorithm::Diff qw(diff);use File::stat;use vars qw ($opt_C $opt_c $opt_u $opt_U);use Getopt::Std;my$usage=<< "ENDUSAGE";getopts('U:C:cu')or bag("$usage");bag("$usage")unless@ARGV==2;my ($file1,$file2)=@ARGV;if (defined$opt_C || defined$opt_c){$opt_c="";$opt_u=undef}elsif (defined$opt_U || defined$opt_u){$opt_u="";$opt_c=undef}else {$opt_c=""}my ($char1,$char2);my$Context_Lines;if (defined$opt_c){$Context_Lines=defined$opt_C ? $opt_C : 3;$char1='*' x 3;$char2='-' x 3}elsif (defined$opt_u){$Context_Lines=defined$opt_U ? $opt_U : 3;$char1='-' x 3;$char2='+' x 3}my$File_Length_Difference=0;open (F1,$file1)or bag("Couldn't open $file1: $!");open (F2,$file2)or bag("Couldn't open $file2: $!");my (@f1,@f2);chomp(@f1=<F1>);close F1;chomp(@f2=<F2>);close F2;my$diffs=diff(\@f1,\@f2);exit 0 unless @$diffs;my$st=stat($file1);print "$char1 $file1\t",scalar localtime($st->mtime),"\n";$st=stat($file2);print "$char2 $file2\t",scalar localtime($st->mtime),"\n";my ($hunk,$oldhunk);for my$piece (@$diffs){$hunk=new Hunk ($piece,$Context_Lines);next unless$oldhunk;if ($hunk->does_overlap($oldhunk)){$hunk->prepend_hunk($oldhunk)}else {$oldhunk->output_diff(\@f1,\@f2)}}continue {$oldhunk=$hunk}$oldhunk->output_diff(\@f1,\@f2);exit 1;sub bag {my$msg=shift;$msg .= "\n";warn$msg;exit 2}{package Hunk;sub new {my ($class,$piece,$context_items)=@_;my$block=new Block ($piece);my$before_diff=$File_Length_Difference;my$after_diff=$before_diff + $block->{"length_diff"};$File_Length_Difference += $block->{"length_diff"};my@remove_array=$block->remove;my@insert_array=$block->insert;my ($a1,$a2,$b1,$b2,$start1,$start2,$end1,$end2);$a1=@remove_array ? $remove_array[0 ]->{"item_no"}: -1;$a2=@remove_array ? $remove_array[-1]->{"item_no"}: -1;$b1=@insert_array ? $insert_array[0 ]->{"item_no"}: -1;$b2=@insert_array ? $insert_array[-1]->{"item_no"}: -1;$start1=$a1==-1 ? $b1 - $before_diff : $a1;$end1=$a2==-1 ? $b2 - $after_diff : $a2;$start2=$b1==-1 ? $a1 + $before_diff : $b1;$end2=$b2==-1 ? $a2 + $after_diff : $b2;my$hunk={"start1"=>$start1,"start2"=>$start2,"end1"=>$end1,"end2"=>$end2,"blocks"=>[$block],};bless$hunk,$class;$hunk->flag_context($context_items);return$hunk}sub flag_context {my ($hunk,$context_items)=@_;return unless$context_items;my$start1=$hunk->{"start1"};my$num_added=$context_items > $start1 ? $start1 : $context_items;$hunk->{"start1"}-= $num_added;$hunk->{"start2"}-= $num_added;my$end1=$hunk->{"end1"};$num_added=($end1+$context_items > $#f1)? $#f1 - $end1 : $context_items;$hunk->{"end1"}+= $num_added;$hunk->{"end2"}+= $num_added}sub does_overlap {my ($hunk,$oldhunk)=@_;return "" unless$oldhunk;return ($hunk->{"start1"}- $oldhunk->{"end1"}<= 1 || $hunk->{"start2"}- $oldhunk->{"end2"}<= 1)}sub prepend_hunk {my ($hunk,$oldhunk)=@_;$hunk->{"start1"}=$oldhunk->{"start1"};$hunk->{"start2"}=$oldhunk->{"start2"};unshift (@{$hunk->{"blocks"}},@{$oldhunk->{"blocks"}})}sub output_diff {if (defined$main::opt_u){&output_unified_diff(@_)}elsif (defined$main::opt_c){&output_context_diff(@_)}else {die "unknown diff"}}sub output_unified_diff {my ($hunk,$fileref1,$fileref2)=@_;my@blocklist;my$range1=$hunk->unified_range(1);my$range2=$hunk->unified_range(2);print "@@ -$range1 +$range2 @@\n";my$low=$hunk->{"start1"};my$hi=$hunk->{"end1"};my ($num_added,$num_removed)=(0,0);my@outlist=@$fileref1[$low..$hi];map {s/^/ /}@outlist;for my$block (@{$hunk->{"blocks"}}){for my$item ($block->remove){my$op=$item->{"sign"};my$offset=$item->{"item_no"}- $low + $num_added;$outlist[$offset]=~ s/^ /$op/;$num_removed++}for my$item ($block->insert){my$op=$item->{"sign"};my$i=$item->{"item_no"};my$offset=$i - $hunk->{"start2"}+ $num_removed;splice(@outlist,$offset,0,"$op$$fileref2[$i]");$num_added++}}map {s/$/\n/}@outlist;print@outlist}sub output_context_diff {my ($hunk,$fileref1,$fileref2)=@_;my@blocklist;print "***************\n";my$range1=$hunk->context_range(1);my$range2=$hunk->context_range(2);print "*** $range1 ****\n";my$low=$hunk->{"start1"};my$hi=$hunk->{"end1"};if (@blocklist=grep {$_->remove}@{$hunk->{"blocks"}}){my@outlist=@$fileref1[$low..$hi];map {s/^/  /}@outlist;for my$block (@blocklist){my$op=$block->op;for my$item ($block->remove){$outlist[$item->{"item_no"}- $low]=~ s/^ /$op/}}map {s/$/\n/}@outlist;print@outlist}print "--- $range2 ----\n";$low=$hunk->{"start2"};$hi=$hunk->{"end2"};if (@blocklist=grep {$_->insert}@{$hunk->{"blocks"}}){my@outlist=@$fileref2[$low..$hi];map {s/^/  /}@outlist;for my$block (@blocklist){my$op=$block->op;for my$item ($block->insert){$outlist[$item->{"item_no"}- $low]=~ s/^ /$op/}}map {s/$/\n/}@outlist;print@outlist}}sub context_range {my ($hunk,$flag)=@_;my ($start,$end)=($hunk->{"start$flag"},$hunk->{"end$flag"});$start++;$end++;my$range=($start < $end)? "$start,$end" : $end;return$range}sub unified_range {my ($hunk,$flag)=@_;my ($start,$end)=($hunk->{"start$flag"},$hunk->{"end$flag"});$start++;$end++;my$length=$end - $start + 1;my$first=$length < 2 ? $end : $start;my$range=$length==1 ? $first : "$first,$length";return$range}}{package Block;sub new {my ($class,$chunk)=@_;my@changes=();for my$item (@$chunk){my ($sign,$item_no,$text)=@$item;my$hashref={"sign"=>$sign,"item_no"=>$item_no};push@changes,$hashref}my$block={"changes"=>\@changes };bless$block,$class;$block->{"length_diff"}=$block->insert - $block->remove;return$block}sub op {my$block=shift;my$insert=$block->insert;my$remove=$block->remove;$remove && $insert and return '!';$remove and return '-';$insert and return '+';warn "unknown block type";return '^'}sub remove {return grep {$_->{"sign"}eq '-'}@{shift->{"changes"}}}sub insert {return grep {$_->{"sign"}eq '+'}@{shift->{"changes"}}}}
Usage: $0 [{-c | -u}] [{-C | -U} lines] oldfile newfile
    -c will do a context diff with 3 lines of context
    -C will do a context diff with 'lines' lines of context
    -u will do a unified diff with 3 lines of context
    -U will do a unified diff with 'lines' lines of context
ENDUSAGE
