package Archive::Any::Lite;use strict;use warnings;use File::Spec;our$VERSION='0.11';our$IGNORE_SYMLINK;sub new {my ($class,$file,$opts)=@_;$file=File::Spec->rel2abs($file);unless (-f $file){warn "$file not found\n";return}my$type=!ref$opts ? $opts : '';my$handler=($type && lc$type eq 'tar')|| $file =~ /\.(?:tar|tar\.(?:gz|bz2)|gtar|tgz)$/ ? 'Archive::Any::Lite::Tar' : ($type && lc$type eq 'zip')|| $file =~ /\.(?:zip)$/ ? 'Archive::Any::Lite::Zip' : undef;unless ($handler){warn "No handler available for $file\n";return}bless {file=>$file,handler=>$handler,opts=>ref$opts ? $opts : undef,},$class}sub extract {my ($self,$dir,$opts)=@_;$self->{handler}->extract($self->{file},$dir,$opts || $self->{opts})}sub files {my$self=shift;$self->{handler}->files($self->{file})}sub is_impolite {my$self=shift;my@files=$self->files;my$first_file=$files[0];my ($first_dir)=File::Spec->splitdir($first_file);return grep(!/^\Q$first_dir\E/,@files)? 1 : 0}sub is_naughty {my ($self)=shift;return (grep {m{^(?:/|(?:\./)*\.\./)}}$self->files)? 1 : 0}sub type {my$self=shift;my ($type)=lc$self->{handler}=~ /::(\w+)$/;return$type}package Archive::Any::Lite::Tar;use Archive::Tar;sub files {my ($self,$file)=@_;Archive::Tar->list_archive($file)}sub extract {my ($self,$file,$dir,$opts)=@_;$dir='.' unless defined$dir;$dir=File::Spec->rel2abs($dir);my$tar=Archive::Tar->new;my$fh;if ($file =~ /\.(tgz|tar\.gz)$/){require IO::Zlib;$fh=IO::Zlib->new($file,"rb")or do {warn "$file: $!";return}}elsif ($file =~ /\.tar.bz2$/){require IO::Uncompress::Bunzip2;$fh=IO::Uncompress::Bunzip2->new($file)or do {warn "$file: $!";return}}else {open$fh,'<',$file or do {warn "$file: $!";return};binmode$fh}local$Archive::Tar::WARN;my%errors;my$has_extracted;my%read_opts=(limit=>1);if ($opts){for (qw/limit md5 filter filter_cb extract/){if (exists$opts->{"tar_$_"}){$read_opts{$_}=$opts->{"tar_$_"}}elsif (exists$opts->{$_}){$read_opts{$_}=$opts->{$_}}}}until (eof$fh){my@files=$tar->read($fh,undef,\%read_opts);if (my$error=$tar->error){warn$error unless$errors{$error}++}if (!@files &&!$has_extracted){warn "No data could be read from $file";return}for my$file (@files){next if$IGNORE_SYMLINK && ($file->is_symlink or $file->is_hardlink);my$path=File::Spec->catfile($dir,$file->prefix,$file->name);$tar->extract_file($file,File::Spec->canonpath($path))or do {if (my$error=$tar->error){warn$error unless$errors{$error}++}}}$has_extracted += @files}return if%errors;return 1}sub type {'tar'}package Archive::Any::Lite::Zip;use Archive::Zip qw/:ERROR_CODES/;sub files {my ($self,$file)=@_;my$zip=Archive::Zip->new($file)or return;$zip->memberNames}sub extract {my ($self,$file,$dir,$opts)=@_;my$zip=Archive::Zip->new($file)or return;$dir='.' unless defined$dir;my$error=0;for my$member ($zip->members){next if$IGNORE_SYMLINK && $member->isSymbolicLink;my$path=File::Spec->catfile($dir,$member->fileName);my$ret=$member->extractToFileNamed(File::Spec->canonpath($path));$error++ if$ret!=AZ_OK}return if$error;return 1}sub type {'zip'}1;