package Data::Dump::Trace;$VERSION="0.02";use strict;use base 'Exporter';our@EXPORT_OK=qw(call mcall wrap autowrap trace);use Carp qw(croak);use overload ();my%obj_name;my%autowrap_class;my%name_count;sub autowrap {while (@_){my$class=shift;my$info=shift;$info={prefix=>$info }unless ref($info);for ($info->{prefix}){unless ($_){$_=lc($class);s/.*:://}$_='$' .$_ unless /^\$/}$autowrap_class{$class}=$info}}sub wrap {my%arg=@_;my$name=$arg{name}|| "func";my$func=$arg{func};my$proto=$arg{proto};return sub {call($name,$func,$proto,@_)}if$func;if (my$obj=$arg{obj}){$name='$' .$name unless$name =~ /^\$/;$obj_name{overload::StrVal($obj)}=$name;return bless {name=>$name,obj=>$obj,proto=>$arg{proto},},"Data::Dump::Trace::Wrapper"}croak("Either the 'func' or 'obj' option must be given")}sub trace {my($symbol,$prototype)=@_;no strict 'refs';no warnings 'redefine';*{$symbol}=wrap(name=>$symbol,func=>\&{$symbol},proto=>$prototype)}sub call {my$name=shift;my$func=shift;my$proto=shift;my$fmt=Data::Dump::Trace::Call->new($name,$proto,\@_);if (!defined wantarray){$func->(@_);return$fmt->return_void(\@_)}elsif (wantarray){return$fmt->return_list(\@_,$func->(@_))}else {return$fmt->return_scalar(\@_,scalar$func->(@_))}}sub mcall {my$o=shift;my$method=shift;my$proto=shift;return if$method eq "DESTROY" &&!$o->can("DESTROY");my$oname=ref($o)? $obj_name{overload::StrVal($o)}|| "\$o" : $o;my$fmt=Data::Dump::Trace::Call->new("$oname->$method",$proto,\@_);if (!defined wantarray){$o->$method(@_);return$fmt->return_void(\@_)}elsif (wantarray){return$fmt->return_list(\@_,$o->$method(@_))}else {return$fmt->return_scalar(\@_,scalar$o->$method(@_))}}package Data::Dump::Trace::Wrapper;sub AUTOLOAD {my$self=shift;our$AUTOLOAD;my$method=substr($AUTOLOAD,rindex($AUTOLOAD,'::')+2);Data::Dump::Trace::mcall($self->{obj},$method,$self->{proto}{$method},@_)}package Data::Dump::Trace::Call;use Term::ANSIColor ();use Data::Dump ();*_dump=\&Data::Dump::dump;our%COLOR=(name=>"yellow",output=>"cyan",error=>"red",debug=>"red",);%COLOR=()unless -t STDOUT;sub _dumpav {return "(" ._dump(@_).")" if @_==1;return _dump(@_)}sub _dumpkv {return _dumpav(@_)if @_ % 2;my%h=@_;my$str=_dump(\%h);$str =~ s/^\{/(/ && $str =~ s/\}\z/)/;return$str}sub new {my($class,$name,$proto,$input_args)=@_;my$self=bless {name=>$name,proto=>$proto,},$class;my$proto_arg=$self->proto_arg;if ($proto_arg =~ /o/){for (@$input_args){push(@{$self->{input_av}},_dump($_))}}else {$self->{input}=$proto_arg eq "%" ? _dumpkv(@$input_args): _dumpav(@$input_args)}return$self}sub proto_arg {my$self=shift;my($arg,$ret)=split(/\s*=\s*/,$self->{proto}|| "");$arg ||= '@';return$arg}sub proto_ret {my$self=shift;my($arg,$ret)=split(/\s*=\s*/,$self->{proto}|| "");$ret ||= '@';return$ret}sub color {my($self,$category,$text)=@_;return$text unless$COLOR{$category};return Term::ANSIColor::colored($text,$COLOR{$category})}sub print_call {my$self=shift;my$outarg=shift;print$self->color("name","$self->{name}");if (my$input=$self->{input}){$input="" if$input eq "()" && $self->{name}=~ /->/;print$self->color("input",$input)}else {my$proto_arg=$self->proto_arg;print "(";my$i=0;for (@{$self->{input_av}}){print ", " if$i;my$proto=substr($proto_arg,0,1,"");if ($proto ne "o"){print$self->color("input",$_)}if ($proto eq "o" || $proto eq "O"){print " = " if$proto eq "O";print$self->color("output",_dump($outarg->[$i]))}}continue {$i++}print ")"}}sub return_void {my$self=shift;my$arg=shift;$self->print_call($arg);print "\n";return}sub return_scalar {my$self=shift;my$arg=shift;$self->print_call($arg);my$s=shift;my$name;my$proto_ret=$self->proto_ret;my$wrap=$autowrap_class{ref($s)};if ($proto_ret =~ /^\$\w+\z/ && ref($s)&& ref($s)!~ /^(?:ARRAY|HASH|CODE|GLOB)\z/){$name=$proto_ret}else {$name=$wrap->{prefix}if$wrap}if ($name){$name .= $name_count{$name}if$name_count{$name}++;print " = ",$self->color("output",$name),"\n";$s=Data::Dump::Trace::wrap(name=>$name,obj=>$s,proto=>$wrap->{proto})}else {print " = ",$self->color("output",_dump($s));if (!$s && $proto_ret =~ /!/ && $!){print " ",$self->color("error",errno($!))}print "\n"}return$s}sub return_list {my$self=shift;my$arg=shift;$self->print_call($arg);print " = ",$self->color("output",$self->proto_ret eq "%" ? _dumpkv(@_): _dumpav(@_)),"\n";return @_}sub errno {my$t="";for (keys %!){if ($!{$_}){$t=$_;last}}my$n=int($!);return "$t($n) $!"}1;