package HTML::TreeBuilder;use warnings;use strict;use integer;use Carp ();our$VERSION='5.07';our$DEBUG;BEGIN {if (defined&DEBUG){}elsif ($] < 5.00404){eval 'sub DEBUG { $Debug } '}elsif (!$DEBUG){eval 'sub DEBUG () {0}'}elsif ($DEBUG =~ m<^\d+$>s){eval 'sub DEBUG () { ' .$DEBUG .' }'}else {warn "Non-numeric value \"$DEBUG\" in \$HTML::Element::DEBUG";eval 'sub DEBUG () { $DEBUG }'}}use HTML::Entities ();use HTML::Tagset 3.02 ();use HTML::Element ();use HTML::Parser 3.46 ();our@ISA=qw(HTML::Element HTML::Parser);*HTML::TreeBuilder::isKnown=\%HTML::Tagset::isKnown;*HTML::TreeBuilder::canTighten=\%HTML::Tagset::canTighten;*HTML::TreeBuilder::isHeadElement=\%HTML::Tagset::isHeadElement;*HTML::TreeBuilder::isBodyElement=\%HTML::Tagset::isBodyElement;*HTML::TreeBuilder::isPhraseMarkup=\%HTML::Tagset::isPhraseMarkup;*HTML::TreeBuilder::isHeadOrBodyElement=\%HTML::Tagset::isHeadOrBodyElement;*HTML::TreeBuilder::isList=\%HTML::Tagset::isList;*HTML::TreeBuilder::isTableElement=\%HTML::Tagset::isTableElement;*HTML::TreeBuilder::isFormElement=\%HTML::Tagset::isFormElement;*HTML::TreeBuilder::p_closure_barriers=\@HTML::Tagset::p_closure_barriers;sub new_from_file {my$class=shift;Carp::croak("new_from_file takes only one argument")unless @_==1;Carp::croak("new_from_file is a class method only")if ref$class;my$new=$class->new();defined$new->parse_file($_[0])or Carp::croak("unable to parse file: $!");return$new}sub new_from_content {my$class=shift;Carp::croak("new_from_content is a class method only")if ref$class;my$new=$class->new();for my$whunk (@_){if (ref($whunk)eq 'SCALAR'){$new->parse($$whunk)}else {$new->parse($whunk)}last if$new->{'_stunted'}}$new->eof();return$new}sub new_from_url {undef our$lwp_response;my$class=shift;Carp::croak("new_from_url takes only one argument")unless @_==1;Carp::croak("new_from_url is a class method only")if ref$class;my$url=shift;my$new=$class->new();require LWP::UserAgent;LWP::UserAgent->VERSION(5.815);$lwp_response=LWP::UserAgent->new->get($url);Carp::croak("GET failed on $url: " .$lwp_response->status_line)unless$lwp_response->is_success;Carp::croak("$url returned " .$lwp_response->content_type ." not HTML")unless$lwp_response->content_is_html;$new->parse($lwp_response->decoded_content);$new->eof;undef$lwp_response;return$new}sub parse_content {my$tree=shift;my$retval;for my$whunk (@_){if (ref($whunk)eq 'SCALAR'){$retval=$tree->parse($$whunk)}else {$retval=$tree->parse($whunk)}last if$tree->{'_stunted'}}$tree->eof();return$retval}sub new {my$class=shift;$class=ref($class)|| $class;my$self=$class->element_class->new('html');{my$other_self=HTML::Parser->new();%$self=(%$self,%$other_self);bless$other_self,"HTML::TreeBuilder::_hideyhole"}$self->{'_implicit_tags'}=1;$self->{'_implicit_body_p_tag'}=0;$self->{'_tighten'}=1;$self->{'_implicit'}=1;$self->{'_ignore_unknown'}=1;$self->{'_ignore_text'}=0;$self->{'_warn'}=0;$self->{'_no_space_compacting'}=0;$self->{'_store_comments'}=0;$self->{'_store_declarations'}=1;$self->{'_store_pis'}=0;$self->{'_p_strict'}=0;$self->{'_no_expand_entities'}=0;if (@_){my%attr=@_;for (keys%attr){$self->{"_$_"}=$attr{$_}}}$HTML::Element::encoded_content=$self->{'_no_expand_entities'};bless$self,$class;$self->{'_element_count'}=1;$self->{'_head'}=$self->insert_element('head',1);$self->{'_pos'}=undef;$self->{'_body'}=$self->insert_element('body',1);$self->{'_pos'}=undef;return$self}sub _elem {my ($self,$elem,$val)=@_;my$old=$self->{$elem};$self->{$elem}=$val if defined$val;return$old}sub implicit_tags {shift->_elem('_implicit_tags',@_)}sub implicit_body_p_tag {shift->_elem('_implicit_body_p_tag',@_)}sub p_strict {shift->_elem('_p_strict',@_)}sub no_space_compacting {shift->_elem('_no_space_compacting',@_)}sub ignore_unknown {shift->_elem('_ignore_unknown',@_)}sub ignore_text {shift->_elem('_ignore_text',@_)}sub ignore_ignorable_whitespace {shift->_elem('_tighten',@_)}sub store_comments {shift->_elem('_store_comments',@_)}sub store_declarations {shift->_elem('_store_declarations',@_)}sub store_pis {shift->_elem('_store_pis',@_)}sub warn {shift->_elem('_warn',@_)}sub no_expand_entities {shift->_elem('_no_expand_entities',@_);$HTML::Element::encoded_content=@_}sub warning {my$self=shift;CORE::warn("HTML::Parse: $_[0]\n")if$self->{'_warn'}}{my$_Closed_by_structurals=[qw(p h1 h2 h3 h4 h5 h6 pre textarea)];my$indent;sub start {return if $_[0]{'_stunted'};my ($self,$tag,$attr)=@_;if ($tag eq 'x-html'){print "Ignoring open-x-html tag.\n" if DEBUG;return}$tag =~ s{/$}{}s;unless ($tag =~ m/^[-_a-zA-Z0-9:%]+$/s){DEBUG and print "Start-tag name $tag is no good.  Skipping.\n";return}my$ptag=(my$pos=$self->{'_pos'}|| $self)->{'_tag'};my$already_inserted;if (DEBUG){my@lineage=$pos->lineage;$indent='  ' x (1 + @lineage);print$indent,"Proposing a new \U$tag\E under ",join('/',map $_->{'_tag'},reverse($pos,@lineage))|| 'Root',".\n"}for my$k (keys %$attr){$attr->{' ' .$k }=delete$attr->{$k}if length$k and substr($k,0,1)eq '_'}my$e=$self->element_class->new($tag,%$attr);if ($self->{'_implicit_tags'}){unless ($HTML::TreeBuilder::isTableElement{$tag}){if ($ptag eq 'table'){print$indent," * Phrasal \U$tag\E right under TABLE makes implicit TR and TD\n" if DEBUG > 1;$self->insert_element('tr',1);$pos=$self->insert_element('td',1)}elsif ($ptag eq 'tr'){print$indent," * Phrasal \U$tag\E right under TR makes an implicit TD\n" if DEBUG > 1;$pos=$self->insert_element('td',1)}$ptag=$pos->{'_tag'}}if ($self->{'_p_strict'}and $HTML::TreeBuilder::isKnown{$tag}and not $HTML::Tagset::is_Possible_Strict_P_Content{$tag}){my$here=$pos;my$here_tag=$ptag;while (1){if ($here_tag eq 'p'){print$indent," * Inserting $tag closes strict P.\n" if DEBUG > 1;$self->end(\q{p});last}last if$HTML::TreeBuilder::isKnown{$here_tag}and not $HTML::Tagset::is_Possible_Strict_P_Content{$here_tag};$here_tag =($here=$here->{'_parent'}|| last)->{'_tag'}}$ptag=($pos=$self->{'_pos'}|| $self)->{'_tag'}}}if (!$self->{'_implicit_tags'}){print$indent," * _implicit_tags is off.  doing nothing\n" if DEBUG > 1}elsif ($HTML::TreeBuilder::isHeadOrBodyElement{$tag}){if ($pos->is_inside('body')){print$indent," * ambilocal element \U$tag\E is fine under BODY.\n" if DEBUG > 1}elsif ($pos->is_inside('head')){print$indent," * ambilocal element \U$tag\E is fine under HEAD.\n" if DEBUG > 1}else {if ($ptag eq 'html'){die "Where'd my head go?" unless ref$self->{'_head'};if ($self->{'_head'}{'_implicit'}){print$indent," * ambilocal element \U$tag\E makes an implicit HEAD.\n" if DEBUG > 1;$self->{'_pos'}=$self->{'_head'}}else {$self->warning("Ambilocal element <$tag> not under HEAD or BODY!?");$self->{'_pos'}=$self->{'_head'}}}else {$self->warning("Ambilocal element <$tag> neither under head nor body, nor right under html!?")}}}elsif ($HTML::TreeBuilder::isBodyElement{$tag}){if ($ptag eq 'body'){}elsif ($HTML::TreeBuilder::isBodyElement{$ptag}and not $HTML::TreeBuilder::isHeadOrBodyElement{$ptag}){print$indent," * Inferring that $ptag is under BODY.\n",if DEBUG > 3}elsif ($pos->is_inside('head')){print$indent," * body-element \U$tag\E minimizes HEAD, makes implicit BODY.\n" if DEBUG > 1;$ptag=($pos=$self->{'_pos'}=$self->{'_body'}|| die "Where'd my body go?")->{'_tag'}}elsif (!$pos->is_inside('body')){print$indent," * body-element \U$tag\E makes implicit BODY.\n" if DEBUG > 1;$ptag=($pos=$self->{'_pos'}=$self->{'_body'}|| die "Where'd my body go?")->{'_tag'}}if ($tag eq 'p' or $tag eq 'h1' or $tag eq 'h2' or $tag eq 'h3' or $tag eq 'h4' or $tag eq 'h5' or $tag eq 'h6' or $tag eq 'form'){$self->end($_Closed_by_structurals,@HTML::TreeBuilder::p_closure_barriers)}elsif ($tag eq 'ol' or $tag eq 'ul' or $tag eq 'dl'){if ($ptag eq 'h1' or $ptag eq 'h2' or $ptag eq 'h3' or $ptag eq 'h4' or $ptag eq 'h5' or $ptag eq 'h6'){$self->end(\$ptag)}}elsif ($tag eq 'li'){unless (exists$HTML::TreeBuilder::isList{$ptag}or $self->end(\q{*},keys%HTML::TreeBuilder::isList)){print$indent," * inserting implicit UL for lack of containing ",join('|',keys%HTML::TreeBuilder::isList),".\n" if DEBUG > 1;$self->insert_element('ul',1)}}elsif ($tag eq 'dt' or $tag eq 'dd'){unless ($ptag eq 'dl' or $self->end(\q{*},'dl')){print$indent," * inserting implicit DL for lack of containing DL.\n" if DEBUG > 1;$self->insert_element('dl',1)}}elsif ($HTML::TreeBuilder::isFormElement{$tag}){if ($self->{'_ignore_formies_outside_form'}and not $pos->is_inside('form')){print$indent," * ignoring \U$tag\E because not in a FORM.\n" if DEBUG > 1;return}if ($tag eq 'option'){$self->end(\q{option});$ptag=($self->{'_pos'}|| $self)->{'_tag'};unless ($ptag eq 'select' or $ptag eq 'optgroup'){print$indent," * \U$tag\E makes an implicit SELECT.\n" if DEBUG > 1;$pos=$self->insert_element('select',1)}}}elsif ($HTML::TreeBuilder::isTableElement{$tag}){if (!$pos->is_inside('table')){print$indent," * \U$tag\E makes an implicit TABLE\n" if DEBUG > 1;$self->insert_element('table',1)}if ($tag eq 'td' or $tag eq 'th'){unless ($ptag eq 'tr' or $self->end(\q{*},'tr','table')){print$indent," * \U$tag\E under \U$ptag\E makes an implicit TR\n" if DEBUG > 1;$self->insert_element('tr',1)}}else {$self->end(\$tag,'table')}}elsif ($HTML::TreeBuilder::isPhraseMarkup{$tag}){if ($ptag eq 'body' and $self->{'_implicit_body_p_tag'}){print " * Phrasal \U$tag\E right under BODY makes an implicit P\n" if DEBUG > 1;$pos=$self->insert_element('p',1)}}}elsif ($HTML::TreeBuilder::isHeadElement{$tag}){if ($pos->is_inside('body')){print$indent," * head element \U$tag\E found inside BODY!\n" if DEBUG;$self->warning("Header element <$tag> in body")}elsif (!$pos->is_inside('head')){print$indent," * head element \U$tag\E makes an implicit HEAD.\n" if DEBUG > 1}else {print$indent," * head element \U$tag\E goes inside existing HEAD.\n" if DEBUG > 1}$self->{'_pos'}=$self->{'_head'}|| die "Where'd my head go?"}elsif ($tag eq 'html'){if (delete$self->{'_implicit'}){print$indent," * good! found the real HTML element!\n" if DEBUG > 1}else {print$indent," * Found a second HTML element\n" if DEBUG;$self->warning("Found a nested <html> element")}for (keys %$attr){$self->attr($_,$attr->{$_})}$self->{'_pos'}=undef;return$self}elsif ($tag eq 'head'){my$head=$self->{'_head'}|| die "Where'd my head go?";if (delete$head->{'_implicit'}){print$indent," * good! found the real HEAD element!\n" if DEBUG > 1}else {print$indent," * Found a second HEAD element\n" if DEBUG;$self->warning("Found a second <head> element")}for (keys %$attr){$head->attr($_,$attr->{$_})}return$self->{'_pos'}=$head}elsif ($tag eq 'body'){my$body=$self->{'_body'}|| die "Where'd my body go?";if (delete$body->{'_implicit'}){print$indent," * good! found the real BODY element!\n" if DEBUG > 1}else {print$indent," * Found a second BODY element\n" if DEBUG;$self->warning("Found a second <body> element")}for (keys %$attr){$body->attr($_,$attr->{$_})}return$self->{'_pos'}=$body}elsif ($tag eq 'frameset'){if (!($self->{'_frameset_seen'}++)and!$self->{'_noframes_seen'}and!$self->is_inside('body')){my$c=$self->{'_content'}|| die "Contentless root?";my$body=$self->{'_body'}|| die "Where'd my BODY go?";for (my$i=0;$i < @$c;++$i ){if ($c->[$i]eq $body){splice(@$c,$i,0,$self->{'_pos'}=$pos=$e);HTML::Element::_weaken($e->{'_parent'}=$self);$already_inserted=1;print$indent," * inserting 'frameset' right before BODY.\n" if DEBUG > 1;last}}die "BODY not found in children of root?" unless$already_inserted}}elsif ($tag eq 'frame'){}elsif ($tag eq 'noframes'){if ($self->{'_noframes_seen'}++){print$indent," * ANOTHER noframes element?\n" if DEBUG}else {if ($pos->is_inside('body')){print$indent," * 'noframes' inside 'body'.  Odd!\n" if DEBUG}else {$e->push_content($self->{'_body'}|| die "Where'd my body go?");print$indent," * Moving body to be under noframes.\n" if DEBUG}}}else {if ($self->{'_ignore_unknown'}){print$indent," * Ignoring unknown tag \U$tag\E\n" if DEBUG;$self->warning("Skipping unknown tag $tag");return}else {print$indent," * Accepting unknown tag \U$tag\E\n" if DEBUG}}print$indent,"(Attaching ",$e->{'_tag'}," under ",($self->{'_pos'}|| $self)->{'_tag'},")\n" if DEBUG;if ($self->{'_tighten'}and!$self->{'_ignore_text'}){my ($sibs,$par);if (($sibs=($par=$self->{'_pos'}|| $self)->{'_content'})and @$sibs and!ref($sibs->[-1])and $sibs->[-1]!~ m<[^\n\r\f\t ]>s and ($HTML::TreeBuilder::canTighten{$tag}or ((@$sibs==1)? $HTML::TreeBuilder::canTighten{$par->{'_tag'}}: (ref$sibs->[-2]and $HTML::TreeBuilder::canTighten{$sibs->[-2]{'_tag'}})))and!$par->is_inside('pre','xmp','textarea','plaintext')){pop @$sibs;print$indent,"Popping a preceding all-WS node\n" if DEBUG}}$self->insert_element($e)unless$already_inserted;if (DEBUG){if ($self->{'_pos'}){print$indent,"(Current lineage of pos:  \U$tag\E under ",join('/',reverse($self->{'_pos'}->lineage_tag_names)),".)\n"}else {print$indent,"(Pos points nowhere!?)\n"}}unless (($self->{'_pos'}|| '')eq $e){&{$self->{"_tweak_$tag"}|| $self->{'_tweak_*'}|| return$e}(map $_,$e,$tag,$self)}return$e}}{my$indent;sub end {return if $_[0]{'_stunted'};my ($self,$tag,@stop)=@_;if ($tag eq 'x-html'){print "Ignoring close-x-html tag.\n" if DEBUG;return}unless (ref($tag)or $tag =~ m/^[-_a-zA-Z0-9:%]+$/s){DEBUG and print "End-tag name $tag is no good.  Skipping.\n";return}my$ptag=(my$p=$self->{'_pos'}|| $self)->{'_tag'};if (ref($tag)){$tag=$$tag if ref($tag)eq 'SCALAR'}else {@stop=$tag =~ /^t[hdr]\z/ ? 'table' : ()}if (DEBUG){my@lineage_tags=$p->lineage_tag_names;$indent='  ' x (1 + @lineage_tags);print$indent,"Ending ",ref($tag)? ('[',join(' ',@$tag),']'): "\U$tag\E",scalar(@stop)? (" no higher than [",join(' ',@stop),"]"): (),".\n";print$indent," (Current lineage: ",join('/',@lineage_tags),".)\n" if DEBUG > 1;if (DEBUG > 3){print$indent," (Called from ",(caller(1))[3],' line ',(caller(1))[2],")\n"}}my@to_close;if ($tag eq '*'){PARENT: while (defined$p){$ptag=$p->{'_tag'};print$indent," (Looking at $ptag.)\n" if DEBUG > 2;for (@stop){if ($ptag eq $_){print$indent," (Hit a $_; closing everything up to here.)\n" if DEBUG > 2;last PARENT}}push@to_close,$p;$p=$p->{'_parent'};print$indent," (Moving on up to ",$p ? $p->{'_tag'}: 'nil',")\n" if DEBUG > 1}unless (defined$p){print$indent," (We never found a limit.)\n" if DEBUG > 1;return}$self->{'_pos'}=$p}elsif (ref$tag){PARENT: while (defined$p){$ptag=$p->{'_tag'};print$indent," (Looking at $ptag.)\n" if DEBUG > 2;for (@$tag){if ($ptag eq $_){print$indent," (Closing $_.)\n" if DEBUG > 2;last PARENT}}for (@stop){if ($ptag eq $_){print$indent," (Hit a limiting $_ -- bailing out.)\n" if DEBUG > 1;return}}push@to_close,$p;$p=$p->{'_parent'}}return unless defined$p;push@to_close,$p;$self->{'_pos'}=$p->{'_parent'}}else {while (defined$p){$ptag=$p->{'_tag'};print$indent," (Looking at $ptag.)\n" if DEBUG > 2;if ($ptag eq $tag){print$indent," (Closing $tag.)\n" if DEBUG > 2;last}for (@stop){if ($ptag eq $_){print$indent," (Hit a limiting $_ -- bailing out.)\n" if DEBUG > 1;return}}push@to_close,$p;$p=$p->{'_parent'}}return unless defined$p;push@to_close,$p;$self->{'_pos'}=$p->{'_parent'}}$self->{'_pos'}=undef if$self eq ($self->{'_pos'}|| '');print$indent,"(Pos now points to ",$self->{'_pos'}? $self->{'_pos'}{'_tag'}: '???',".)\n" if DEBUG > 1;for my$e (@to_close){$ptag=$e->{'_tag'};&{$self->{"_tweak_$ptag"}|| $self->{'_tweak_*'}|| next}(map $_,$e,$ptag,$self);print$indent,"Back from tweaking.\n" if DEBUG;last if$self->{'_stunted' }}return@to_close}}{my ($indent,$nugget);sub text {return if $_[0]{'_stunted'};my ($self,$text,$is_cdata)=@_;return unless length$text;my$ignore_text=$self->{'_ignore_text'};my$no_space_compacting=$self->{'_no_space_compacting'};my$no_expand_entities=$self->{'_no_expand_entities'};my$pos=$self->{'_pos'}|| $self;HTML::Entities::decode($text)unless$ignore_text || $is_cdata || $HTML::Tagset::isCDATA_Parent{$pos->{'_tag'}}|| $no_expand_entities;if (DEBUG){my@lineage_tags=$pos->lineage_tag_names;$indent='  ' x (1 + @lineage_tags);$nugget =(length($text)<= 25)? $text : (substr($text,0,25).'...');$nugget =~ s<([\x00-\x1F])>
                 <'\\x'.(unpack("H2",$1))>eg;print$indent,"Proposing a new text node ($nugget) under ",join('/',reverse($pos->{'_tag'},@lineage_tags))|| 'Root',".\n"}my$ptag;if ($HTML::Tagset::isCDATA_Parent{$ptag=$pos->{'_tag'}}or $pos->is_inside('pre','textarea')){return if$ignore_text;$pos->push_content($text)}else {if (!$self->{'_implicit_tags'}|| $text !~ /[^\n\r\f\t ]/){}elsif ($ptag eq 'head' or $ptag eq 'noframes'){if ($self->{'_implicit_body_p_tag'}){print$indent," * Text node under \U$ptag\E closes \U$ptag\E, implicates BODY and P.\n" if DEBUG > 1;$self->end(\$ptag);$pos=$self->{'_body'}? ($self->{'_pos'}=$self->{'_body'}): $self->insert_element('body',1);$pos=$self->insert_element('p',1)}else {print$indent," * Text node under \U$ptag\E closes, implicates BODY.\n" if DEBUG > 1;$self->end(\$ptag);$pos=$self->{'_body'}? ($self->{'_pos'}=$self->{'_body'}): $self->insert_element('body',1)}}elsif ($ptag eq 'html'){if ($self->{'_implicit_body_p_tag'}){print$indent," * Text node under HTML implicates BODY and P.\n" if DEBUG > 1;$pos=$self->{'_body'}? ($self->{'_pos'}=$self->{'_body'}): $self->insert_element('body',1);$pos=$self->insert_element('p',1)}else {print$indent," * Text node under HTML implicates BODY.\n" if DEBUG > 1;$pos=$self->{'_body'}? ($self->{'_pos'}=$self->{'_body'}): $self->insert_element('body',1)}}elsif ($ptag eq 'body'){if ($self->{'_implicit_body_p_tag'}){print$indent," * Text node under BODY implicates P.\n" if DEBUG > 1;$pos=$self->insert_element('p',1)}}elsif ($ptag eq 'table'){print$indent," * Text node under TABLE implicates TR and TD.\n" if DEBUG > 1;$self->insert_element('tr',1);$pos=$self->insert_element('td',1)}elsif ($ptag eq 'tr'){print$indent," * Text node under TR implicates TD.\n" if DEBUG > 1;$pos=$self->insert_element('td',1)}return if$ignore_text;$text =~ s/[\n\r\f\t ]+/ /g unless$no_space_compacting;print$indent," (Attaching text node ($nugget) under ",$pos->{'_tag'},").\n" if DEBUG > 1;$pos->push_content($text)}&{$self->{'_tweak_~text'}|| return}($text,$pos,$pos->{'_tag'}.'');return}}sub comment {return if $_[0]{'_stunted'};my ($self,$text)=@_;my$pos=$self->{'_pos'}|| $self;return unless$self->{'_store_comments'}|| $HTML::Tagset::isCDATA_Parent{$pos->{'_tag'}};if (DEBUG){my@lineage_tags=$pos->lineage_tag_names;my$indent='  ' x (1 + @lineage_tags);my$nugget =(length($text)<= 25)? $text : (substr($text,0,25).'...');$nugget =~ s<([\x00-\x1F])>
                 <'\\x'.(unpack("H2",$1))>eg;print$indent,"Proposing a Comment ($nugget) under ",join('/',reverse($pos->{'_tag'},@lineage_tags))|| 'Root',".\n"}(my$e=$self->element_class->new('~comment'))->{'text'}=$text;$pos->push_content($e);++($self->{'_element_count'});&{$self->{'_tweak_~comment'}|| $self->{'_tweak_*'}|| return$e}(map $_,$e,'~comment',$self);return$e}sub declaration {return if $_[0]{'_stunted'};my ($self,$text)=@_;my$pos=$self->{'_pos'}|| $self;if (DEBUG){my@lineage_tags=$pos->lineage_tag_names;my$indent='  ' x (1 + @lineage_tags);my$nugget =(length($text)<= 25)? $text : (substr($text,0,25).'...');$nugget =~ s<([\x00-\x1F])>
                 <'\\x'.(unpack("H2",$1))>eg;print$indent,"Proposing a Declaration ($nugget) under ",join('/',reverse($pos->{'_tag'},@lineage_tags))|| 'Root',".\n"}(my$e=$self->element_class->new('~declaration'))->{'text'}=$text;$self->{_decl}=$e;return$e}sub process {return if $_[0]{'_stunted'};return unless $_[0]->{'_store_pis'};my ($self,$text)=@_;my$pos=$self->{'_pos'}|| $self;if (DEBUG){my@lineage_tags=$pos->lineage_tag_names;my$indent='  ' x (1 + @lineage_tags);my$nugget =(length($text)<= 25)? $text : (substr($text,0,25).'...');$nugget =~ s<([\x00-\x1F])>
                 <'\\x'.(unpack("H2",$1))>eg;print$indent,"Proposing a PI ($nugget) under ",join('/',reverse($pos->{'_tag'},@lineage_tags))|| 'Root',".\n"}(my$e=$self->element_class->new('~pi'))->{'text'}=$text;$pos->push_content($e);++($self->{'_element_count'});&{$self->{'_tweak_~pi'}|| $self->{'_tweak_*'}|| return$e}(map $_,$e,'~pi',$self);return$e}sub eof {return if $_[0]->{'_done'};return $_[0]->SUPER::eof()if $_[0]->{'_stunted'};my$x=$_[0];print "EOF received.\n" if DEBUG;my (@rv);if (wantarray){@rv=$x->SUPER::eof()}else {$rv[0]=$x->SUPER::eof()}$x->end('html')unless$x eq ($x->{'_pos'}|| $x);unless ($x->{'_implicit_tags'}){for my$node ($x->{'_head'},$x->{'_body'}){$node->replace_with_content if defined$node and ref$node and $node->{'_implicit'}and $node->{'_parent'}}}$x->delete_ignorable_whitespace()if$x->{'_tighten'}and!$x->{'_ignore_text'};$x->{'_done'}=1;return@rv if wantarray;return$rv[0]}sub stunt {my$self=$_[0];print "Stunting the tree.\n" if DEBUG;$self->{'_done'}=1;if ($HTML::Parser::VERSION < 3){$self->{'_buf'}='';my$fh=*HTML::Parser::F{IO};if (defined$fh){print "Closing Parser's filehandle $fh\n" if DEBUG;close($fh)}}else {$self->SUPER::eof()}$self->stunted(1);return}sub stunted {shift->_elem('_stunted',@_)}sub done {shift->_elem('_done',@_)}sub delete {$_[0]->{'_element_count'}=1;delete @{$_[0]}{'_body','_head','_pos' };for (@{delete($_[0]->{'_content'})|| []},){$_->delete if defined $_ and ref $_ and $_ ne $_[0]}$_[0]->detach if $_[0]->{'_parent'}and $_[0]->{'_parent'}{'_content'};return}sub tighten_up {shift->delete_ignorable_whitespace(@_)}sub elementify {my$self=$_[0];my$to_class=$self->element_class;delete @{$self}{grep {;length $_ and substr($_,0,1)eq '_' and $_ ne '_tag' and $_ ne '_parent' and $_ ne '_content' and $_ ne '_implicit' and $_ ne '_pos' and $_ ne '_element_class'}keys %$self };bless$self,$to_class}sub element_class {return 'HTML::Element' if not ref $_[0];return $_[0]->{_element_class}|| 'HTML::Element'}sub guts {my@out;my@stack=($_[0]);my$destructive=$_[1];my$this;while (@stack){$this=shift@stack;if (!ref$this){push@out,$this}elsif (!$this->{'_implicit'}){push@out,$this;delete$this->{'_parent'}if$destructive}else {delete$this->{'_parent'}if$destructive;unshift@stack,@{($destructive ? delete($this->{'_content'}): $this->{'_content'})|| []}}}return@out if wantarray;return unless@out;return$out[0]if@out==1 and ref($out[0]);my$x=HTML::Element->new('div','_implicit'=>1);$x->push_content(@out);return$x}sub disembowel {$_[0]->guts(1)}1;