package HTTP::Cookies;use strict;use HTTP::Date qw(str2time parse_date time2str);use HTTP::Headers::Util qw(_split_header_words join_header_words);use vars qw($EPOCH_OFFSET);our$VERSION='6.04';require HTTP::Cookies::Netscape;$EPOCH_OFFSET=0;if ($^O eq "MacOS"){require Time::Local;$EPOCH_OFFSET=Time::Local::timelocal(0,0,0,1,0,70)}sub new {my$class=shift;my$self=bless {COOKIES=>{},},$class;my%cnf=@_;for (keys%cnf){$self->{lc($_)}=$cnf{$_}}$self->load;$self}sub add_cookie_header {my$self=shift;my$request=shift || return;my$url=$request->uri;my$scheme=$url->scheme;unless ($scheme =~ /^https?\z/){return}my$domain=_host($request,$url);$domain="$domain.local" unless$domain =~ /\./;my$secure_request=($scheme eq "https");my$req_path=_url_path($url);my$req_port=$url->port;my$now=time();_normalize_path($req_path)if$req_path =~ /%/;my@cval;my$set_ver;my$netscape_only=0;while ($domain =~ /\./){my$cookies=$self->{COOKIES}{$domain};next unless$cookies;if ($self->{delayload}&& defined($cookies->{'//+delayload'})){my$cookie_data=$cookies->{'//+delayload'}{'cookie'};delete$self->{COOKIES}{$domain};$self->load_cookie($cookie_data->[1]);$cookies=$self->{COOKIES}{$domain};next unless$cookies}my$path;for$path (sort {length($b)<=> length($a)}keys %$cookies){if (index($req_path,$path)!=0){next}my($key,$array);while (($key,$array)=each %{$cookies->{$path}}){my($version,$val,$port,$path_spec,$secure,$expires)=@$array;if ($secure &&!$secure_request){next}if ($expires && $expires < $now){next}if ($port){my$found;if ($port =~ s/^_//){$found++ if$port eq $req_port;$port=""}else {my$p;for$p (split(/,/,$port)){$found++,last if$p eq $req_port}}unless ($found){next}}if ($version > 0 && $netscape_only){next}if (!$set_ver++){if ($version >= 1){push(@cval,"\$Version=$version")}elsif (!$self->{hide_cookie2}){$request->header(Cookie2=>'$Version="1"')}}if ($val =~ /\W/ && $version){$val =~ s/([\\\"])/\\$1/g;$val=qq("$val")}push(@cval,"$key=$val");if ($version >= 1){push(@cval,qq(\$Path="$path"))if$path_spec;push(@cval,qq(\$Domain="$domain"))if$domain =~ /^\./;if (defined$port){my$p='$Port';$p .= qq(="$port") if length$port;push(@cval,$p)}}}}}continue {if ($domain =~ s/^\.+//){$netscape_only=1}else {$domain =~ s/[^.]*//;$netscape_only=0}}if (@cval){if (my$old=$request->header("Cookie")){unshift(@cval,$old)}$request->header(Cookie=>join("; ",@cval));if (my$hash=$request->{_http_cookies}){%$hash=(map split(/=/,$_,2),@cval)}}$request}sub get_cookies {my$self=shift;my$url=shift;$url="https://$url" unless$url =~ m,^[a-zA-Z][a-zA-Z0-9.+\-]*:,;require HTTP::Request;my$req=HTTP::Request->new(GET=>$url);my$cookies=$req->{_http_cookies}={};$self->add_cookie_header($req);if (@_){return map$cookies->{$_},@_ if wantarray;return$cookies->{$_[0]}}return$cookies}sub extract_cookies {my$self=shift;my$response=shift || return;my@set=_split_header_words($response->_header("Set-Cookie2"));my@ns_set=$response->_header("Set-Cookie");return$response unless@set || @ns_set;my$request=$response->request;my$url=$request->uri;my$req_host=_host($request,$url);$req_host="$req_host.local" unless$req_host =~ /\./;my$req_port=$url->port;my$req_path=_url_path($url);_normalize_path($req_path)if$req_path =~ /%/;if (@ns_set){my$now=time();my%in_set2;for (@set){$in_set2{$_->[0]}++}my$set;for$set (@ns_set){$set =~ s/^\s+//;my@cur;my$param;my$expires;my$first_param=1;for$param (split(/;\s*/,$set)){next unless length($param);my($k,$v)=split(/\s*=\s*/,$param,2);if (defined$v){$v =~ s/\s+$//}else {$k =~ s/\s+$//}if (!$first_param && lc($k)eq "expires"){my$etime=str2time($v);if (defined$etime){push(@cur,"Max-Age"=>$etime - $now);$expires++}else {my($year,$mon,$day,$hour,$min,$sec,$tz)=parse_date($v);if ($year){my$thisyear=(gmtime)[5]+ 1900;if ($year < $thisyear){push(@cur,"Max-Age"=>-1);$expires++}elsif ($year >= $thisyear + 10){push(@cur,"Max-Age"=>10 * 365 * 24 * 60 * 60);$expires++}}}}elsif (!$first_param && lc($k)=~ /^(?:version|discard|ns-cookie)/){}else {push(@cur,$k=>$v)}$first_param=0}next unless@cur;next if$in_set2{$cur[0]};push(@cur,"Discard"=>undef)unless$expires;push(@cur,"Version"=>0);push(@cur,"ns-cookie"=>1);push(@set,\@cur)}}SET_COOKIE: for my$set (@set){next unless @$set >= 2;my$key=shift @$set;my$val=shift @$set;my%hash;while (@$set){my$k=shift @$set;my$v=shift @$set;my$lc=lc($k);$k=$lc if$lc =~ /^(?:discard|domain|max-age|
                                    path|port|secure|version)$/x;if ($k eq "discard" || $k eq "secure"){$v=1 unless defined$v}next if exists$hash{$k};$hash{$k}=$v};my%orig_hash=%hash;my$version=delete$hash{version};$version=1 unless defined($version);my$discard=delete$hash{discard};my$secure=delete$hash{secure};my$maxage=delete$hash{'max-age'};my$ns_cookie=delete$hash{'ns-cookie'};my$domain=delete$hash{domain};$domain=lc($domain)if defined$domain;if (defined($domain)&& $domain ne $req_host && $domain ne ".$req_host"){if ($domain !~ /\./ && $domain ne "local"){next SET_COOKIE}$domain=".$domain" unless$domain =~ /^\./;if ($domain =~ /\.\d+$/){next SET_COOKIE}my$len=length($domain);unless (substr($req_host,-$len)eq $domain){next SET_COOKIE}my$hostpre=substr($req_host,0,length($req_host)- $len);if ($hostpre =~ /\./ &&!$ns_cookie){next SET_COOKIE}}else {$domain=$req_host}my$path=delete$hash{path};my$path_spec;if (defined$path && $path ne ''){$path_spec++;_normalize_path($path)if$path =~ /%/;if (!$ns_cookie && substr($req_path,0,length($path))ne $path){next SET_COOKIE}}else {$path=$req_path;$path =~ s,/[^/]*$,,;$path="/" unless length($path)}my$port;if (exists$hash{port}){$port=delete$hash{port};if (defined$port){$port =~ s/\s+//g;my$found;for my$p (split(/,/,$port)){unless ($p =~ /^\d+$/){next SET_COOKIE}$found++ if$p eq $req_port}unless ($found){next SET_COOKIE}}else {$port="_$req_port"}}$self->set_cookie($version,$key,$val,$path,$domain,$port,$path_spec,$secure,$maxage,$discard,\%hash)if$self->set_cookie_ok(\%orig_hash)}$response}sub set_cookie_ok {1}sub set_cookie {my$self=shift;my($version,$key,$val,$path,$domain,$port,$path_spec,$secure,$maxage,$discard,$rest)=@_;return$self if!defined($path)|| $path !~ m,^/, || !defined($key)|| $key =~ m,^\$,;if (defined$port){return$self unless$port =~ /^_?\d+(?:,\d+)*$/}my$expires;if (defined$maxage){if ($maxage <= 0){delete$self->{COOKIES}{$domain}{$path}{$key};return$self}$expires=time()+ $maxage}$version=0 unless defined$version;my@array=($version,$val,$port,$path_spec,$secure,$expires,$discard);push(@array,{%$rest})if defined($rest)&& %$rest;pop(@array)while!defined$array[-1];$self->{COOKIES}{$domain}{$path}{$key}=\@array;$self}sub save {my$self=shift;my$file=shift || $self->{'file'}|| return;open(my$fh,'>',$file)or die "Can't open $file: $!";print {$fh}"#LWP-Cookies-1.0\n";print {$fh}$self->as_string(!$self->{ignore_discard});1}sub load {my$self=shift;my$file=shift || $self->{'file'}|| return;local $/="\n";open(my$fh,'<',$file)or return;my$magic=<$fh>;chomp$magic;unless ($magic =~ /^#LWP-Cookies-\d+\.\d+/){warn "$file does not seem to contain cookies";return}while (my$line=<$fh>){chomp$line;next unless$line =~ s/^Set-Cookie3:\s*//;my$cookie;for$cookie (_split_header_words($line)){my($key,$val)=splice(@$cookie,0,2);my%hash;while (@$cookie){my$k=shift @$cookie;my$v=shift @$cookie;$hash{$k}=$v}my$version=delete$hash{version};my$path=delete$hash{path};my$domain=delete$hash{domain};my$port=delete$hash{port};my$expires=str2time(delete$hash{expires});my$path_spec=exists$hash{path_spec};delete$hash{path_spec};my$secure=exists$hash{secure};delete$hash{secure};my$discard=exists$hash{discard};delete$hash{discard};my@array=($version,$val,$port,$path_spec,$secure,$expires,$discard);push(@array,\%hash)if%hash;$self->{COOKIES}{$domain}{$path}{$key}=\@array}}1}sub revert {my$self=shift;$self->clear->load;$self}sub clear {my$self=shift;if (@_==0){$self->{COOKIES}={}}elsif (@_==1){delete$self->{COOKIES}{$_[0]}}elsif (@_==2){delete$self->{COOKIES}{$_[0]}{$_[1]}}elsif (@_==3){delete$self->{COOKIES}{$_[0]}{$_[1]}{$_[2]}}else {require Carp;Carp::carp('Usage: $c->clear([domain [,path [,key]]])')}$self}sub clear_temporary_cookies {my($self)=@_;$self->scan(sub {if($_[9]or not $_[8]){$_[8]=-1;$self->set_cookie(@_)}})}sub DESTROY {my$self=shift;local($.,$@,$!,$^E,$?);$self->save if$self->{'autosave'}}sub scan {my($self,$cb)=@_;my($domain,$path,$key);for$domain (sort keys %{$self->{COOKIES}}){for$path (sort keys %{$self->{COOKIES}{$domain}}){for$key (sort keys %{$self->{COOKIES}{$domain}{$path}}){my($version,$val,$port,$path_spec,$secure,$expires,$discard,$rest)=@{$self->{COOKIES}{$domain}{$path}{$key}};$rest={}unless defined($rest);&$cb($version,$key,$val,$path,$domain,$port,$path_spec,$secure,$expires,$discard,$rest)}}}}sub as_string {my($self,$skip_discard)=@_;my@res;$self->scan(sub {my($version,$key,$val,$path,$domain,$port,$path_spec,$secure,$expires,$discard,$rest)=@_;return if$discard && $skip_discard;my@h=($key,$val);push(@h,"path",$path);push(@h,"domain"=>$domain);push(@h,"port"=>$port)if defined$port;push(@h,"path_spec"=>undef)if$path_spec;push(@h,"secure"=>undef)if$secure;push(@h,"expires"=>HTTP::Date::time2isoz($expires))if$expires;push(@h,"discard"=>undef)if$discard;my$k;for$k (sort keys %$rest){push(@h,$k,$rest->{$k})}push(@h,"version"=>$version);push(@res,"Set-Cookie3: " .join_header_words(\@h))});join("\n",@res,"")}sub _host {my($request,$url)=@_;if (my$h=$request->header("Host")){$h =~ s/:\d+$//;return lc($h)}return lc($url->host)}sub _url_path {my$url=shift;my$path;if($url->can('epath')){$path=$url->epath}else {$path=$url->path}$path="/" unless length$path;$path}sub _normalize_path {my$x;$_[0]=~ s/%([0-9a-fA-F][0-9a-fA-F])/
	         $x = uc($1);
                 $x eq "2F" || $x eq "25" ? "%$x" :
                                            pack("C", hex($x));
              /eg;$_[0]=~ s/([\0-\x20\x7f-\xff])/sprintf("%%%02X",ord($1))/eg}1;