package Net::SNMP;use strict;BEGIN {die 'Perl version 5.6.0 or greater is required' if ($] < 5.006)}our$VERSION='v6.0.1';$VERSION=eval$VERSION;use Net::SNMP::Dispatcher();use Net::SNMP::PDU qw(:ALL !DEBUG_INFO);use Net::SNMP::Security();use Net::SNMP::Transport qw(:ports);use base qw(Exporter);our@EXPORT=qw(INTEGER INTEGER32 OCTET_STRING OBJECT_IDENTIFIER IPADDRESS COUNTER COUNTER32 GAUGE GAUGE32 UNSIGNED32 TIMETICKS OPAQUE COUNTER64 NOSUCHOBJECT NOSUCHINSTANCE ENDOFMIBVIEW snmp_dispatcher);our@EXPORT_OK=qw(oid_context_match);our%EXPORT_TAGS=(asn1=>[qw(INTEGER INTEGER32 OCTET_STRING NULL OBJECT_IDENTIFIER SEQUENCE IPADDRESS COUNTER COUNTER32 GAUGE GAUGE32 UNSIGNED32 TIMETICKS OPAQUE COUNTER64 NOSUCHOBJECT NOSUCHINSTANCE ENDOFMIBVIEW GET_REQUEST GET_NEXT_REQUEST GET_RESPONSE SET_REQUEST TRAP GET_BULK_REQUEST INFORM_REQUEST SNMPV2_TRAP REPORT) ],debug=>[qw(DEBUG_ALL DEBUG_NONE DEBUG_MESSAGE DEBUG_TRANSPORT DEBUG_DISPATCHER DEBUG_PROCESSING DEBUG_SECURITY snmp_debug) ],generictrap=>[qw(COLD_START WARM_START LINK_DOWN LINK_UP AUTHENTICATION_FAILURE EGP_NEIGHBOR_LOSS ENTERPRISE_SPECIFIC) ],snmp=>[qw(SNMP_VERSION_1 SNMP_VERSION_2C SNMP_VERSION_3 SNMP_PORT SNMP_TRAP_PORT snmp_debug snmp_dispatcher snmp_dispatch_once snmp_type_ntop oid_base_match oid_lex_cmp oid_lex_sort ticks_to_time) ],translate=>[qw(TRANSLATE_NONE TRANSLATE_OCTET_STRING TRANSLATE_NULL TRANSLATE_TIMETICKS TRANSLATE_OPAQUE TRANSLATE_NOSUCHOBJECT TRANSLATE_NOSUCHINSTANCE TRANSLATE_ENDOFMIBVIEW TRANSLATE_UNSIGNED TRANSLATE_ALL) ],);Exporter::export_ok_tags(qw(asn1 debug generictrap snmp translate));$EXPORT_TAGS{ALL}=[@EXPORT_OK ];sub DEBUG_ALL {0xff}sub DEBUG_NONE {0x00}sub DEBUG_MESSAGE {0x02}sub DEBUG_TRANSPORT {0x04}sub DEBUG_DISPATCHER {0x08}sub DEBUG_PROCESSING {0x10}sub DEBUG_SECURITY {0x20}our$DEBUG=DEBUG_NONE;our$DISPATCHER;our$BLOCKING=0;our$NONBLOCKING=0;BEGIN {if (!defined ($DISPATCHER=Net::SNMP::Dispatcher->instance())){die 'FATAL: Failed to create Dispatcher instance'}if ($] < 5.009){*VERSION=\&require_version}}{my@trans_argv=qw(hostname (?:de?st|peer)?(?:addr|port) (?:src|sock|local)(?:addr|port) maxmsgsize mtu retries timeout domain listen);sub new {my ($class,%argv)=@_;my$this=bless {'_callback'=>undef,'_context_engine_id'=>undef,'_context_name'=>undef,'_delay'=>0,'_hostname'=>q{},'_discovery_queue'=>[],'_error'=>undef,'_nonblocking'=>FALSE,'_pdu'=>undef,'_security'=>undef,'_translate'=>TRANSLATE_ALL,'_transport'=>undef,'_transport_argv'=>[],'_version'=>SNMP_VERSION_1,},$class;for (keys%argv){if (/^-?debug$/i){$this->debug(delete$argv{$_})}elsif (/^-?nonblocking$/i){$this->{_nonblocking}=(delete$argv{$_})? TRUE : FALSE}elsif (/^-?translate$/i){$this->translate(delete$argv{$_})}elsif (/^-?version$/i){$this->_version($argv{$_})}else {my$key=$_;for (@trans_argv){if ($key =~ /^-?$_$/i){push @{$this->{_transport_argv}},$key,delete$argv{$key};last}}}if (defined$this->{_error}){$this->_object_type_validate();return wantarray ? (undef,$this->{_error}): undef}}if (!defined$this->_object_type_validate()){return wantarray ? (undef,$this->{_error}): undef}($this->{_security},$this->{_error})=Net::SNMP::Security->new(%argv);if (!defined$this->{_security}){return wantarray ? (undef,$this->{_error}): undef}$this->_error_clear();return wantarray ? ($this,q{}): $this}}sub open {my ($this)=@_;$this->_error_clear();($this->{_transport},$this->{_error})=Net::SNMP::Transport->new(@{$this->{_transport_argv}});if (!defined$this->{_transport}){return$this->_error()}$this->_error_clear();$this->{_hostname}=$this->{_transport}->dest_hostname();if ($this->version()==SNMP_VERSION_3){$this->_perform_discovery()}return defined($this->{_error})? $this->_error(): $this->{_transport}}sub session {my$class=shift;my ($this,$error)=$class->new(@_);if (defined$this){if (!defined$this->open()){return wantarray ? (undef,$this->error()): undef}}return wantarray ? ($this,$error): $this}sub manager {goto&session}sub close {my ($this)=@_;$this->_error_clear();$this->{_pdu}=undef;$this->{_transport}=undef;return}sub snmp_dispatcher {return$DISPATCHER->loop()}sub snmp_event_loop {require Carp;Carp::croak('snmp_event_loop() is obsolete, use snmp_dispatcher() instead');goto&snmp_dispatcher}sub snmp_dispatch_once {return$DISPATCHER->one_event()}sub get_request {my$this=shift;$this->_error_clear();my@argv;if (!defined$this->_prepare_argv([qw(-callback -delay -contextengineid -contextname -varbindlist)],\@_,\@argv)){return$this->_error()}if (!defined$this->_create_pdu()){return$this->_error()}if (!defined$this->{_pdu}->prepare_get_request(@argv)){return$this->_error($this->{_pdu}->error())}return$this->_send_pdu()}sub get_next_request {my$this=shift;$this->_error_clear();my@argv;if (!defined$this->_prepare_argv([qw(-callback -delay -contextengineid -contextname -varbindlist)],\@_,\@argv)){return$this->_error()}if (!defined$this->_create_pdu()){return$this->_error()}if (!defined$this->{_pdu}->prepare_get_next_request(@argv)){return$this->_error($this->{_pdu}->error())}return$this->_send_pdu()}sub set_request {my$this=shift;$this->_error_clear();my@argv;if (!defined$this->_prepare_argv([qw(-callback -delay -contextengineid -contextname -varbindlist)],\@_,\@argv)){return$this->_error()}if (!defined$this->_create_pdu()){return$this->_error()}if (!defined$this->{_pdu}->prepare_set_request(@argv)){return$this->_error($this->{_pdu}->error())}return$this->_send_pdu()}sub trap {my$this=shift;$this->_error_clear();my@argv;if (!defined$this->_prepare_argv([qw(-delay -enterprise -agentaddr -generictrap -specifictrap -timestamp -varbindlist)],\@_,\@argv)){return$this->_error()}if (!defined$this->_create_pdu()){return$this->_error()}if (!defined$this->{_pdu}->prepare_trap(@argv)){return$this->_error($this->{_pdu}->error())}$this->_send_pdu();return defined($this->{_error})? $this->_error(): TRUE}sub get_bulk_request {my$this=shift;$this->_error_clear();my@argv;if (!defined$this->_prepare_argv([qw(-callback -delay -contextengineid -contextname -nonrepeaters -maxrepetitions -varbindlist)],\@_,\@argv)){return$this->_error()}if (!defined$this->_create_pdu()){return$this->_error()}if (!defined$this->{_pdu}->prepare_get_bulk_request(@argv)){return$this->_error($this->{_pdu}->error())}return$this->_send_pdu()}sub inform_request {my$this=shift;$this->_error_clear();my@argv;if (!defined$this->_prepare_argv([qw(-callback -delay -contextengineid -contextname -varbindlist)],\@_,\@argv)){return$this->_error()}if (!defined$this->_create_pdu()){return$this->_error()}if (!defined$this->{_pdu}->prepare_inform_request(@argv)){return$this->_error($this->{_pdu}->error())}return$this->_send_pdu()}sub snmpv2_trap {my$this=shift;$this->_error_clear();my@argv;if (!defined$this->_prepare_argv([qw(-delay -contextengineid -contextname -varbindlist)],\@_,\@argv)){return$this->_error()}if (!defined$this->_create_pdu()){return$this->_error()}if (!defined$this->{_pdu}->prepare_snmpv2_trap(@argv)){return$this->_error($this->{_pdu}->error())}$this->_send_pdu();return defined($this->{_error})? $this->_error(): TRUE}sub get_table {my$this=shift;$this->_error_clear();my@argv;if ((@_)&& ($_[0]=~ m/^\.?\d+(?:\.\d+)* *$/)){unshift @_,'-baseoid'}if (!defined$this->_prepare_argv([qw(-callback -delay -contextengineid -contextname -baseoid -maxrepetitions)],\@_,\@argv)){return$this->_error()}if ($argv[0]!~ m/^\.?\d+(?:\.\d+)* *$/){return$this->_error('The base OBJECT IDENTIFIER "%s" is expected in dotted decimal ' .'notation',$argv[0])}if (!defined$this->_create_pdu()){return$this->_error()}my$argv={base_oid=>$argv[0],callback=>$this->{_pdu}->callback(),max_reps=>5,repeat_cnt=>0,table=>undef,types=>undef,use_bulk=>FALSE };$this->{_pdu}->callback(sub {$this->{_pdu}=$_[0];$this->_error_clear();if ($this->{_pdu}->error()){$this->_error($this->{_pdu}->error())}$this->_get_table_cb($argv);return});if ($this->version()==SNMP_VERSION_1){if (defined$argv[1]){return$this->_error('The max-repetitions argument is not applicable when using SNMPv1')}}else {if (!defined$argv[1]){$argv->{use_bulk}=TRUE;$argv->{max_reps}=$this->_msg_size_max_reps()}elsif ($argv[1]> 1){$argv->{use_bulk}=TRUE;$argv->{max_reps}=$argv[1]}}if ($argv->{use_bulk}){if (!defined$this->{_pdu}->prepare_get_bulk_request(0,$argv->{max_reps},[$argv[0]])){return$this->_error($this->{_pdu}->error())}}else {if (!defined$this->{_pdu}->prepare_get_next_request([$argv[0]])){return$this->_error($this->{_pdu}->error())}}return$this->_send_pdu()}sub get_entries {my$this=shift;$this->_error_clear();my@argv;if (!defined$this->_prepare_argv([qw(-callback -delay -contextengineid -contextname -entryoid -columns -startindex -endindex -maxrepetitions -rowcallback)],\@_,\@argv)){return$this->_error()}if (ref$argv[1]ne 'ARRAY'){return$this->_error('The columns argument expects an array reference')}if (!scalar @{$argv[1]}){return$this->_error('An empty columns list was specified')}if (defined$argv[0]){require Carp;Carp::croak('The entryoid argument is obsolete, use the columns argument ' .'with a list of column OBJECT IDENTIFIERs');if ($argv[0]!~ m/^\.?\d+(?:\.\d+)* *$/){return$this->_error('The entryoid value "%s" is expected in dotted decimal notation',$argv[0])}my$columns={};for (@{$argv[1]}){if (!m/^\d+$/){return$this->_error('The columns list value "%s" is expected in positive numeric ' .'format',$_)}if (exists$columns->{$_}){return$this->_error('The columns list value "%s" is duplicated in the columns list',$_)}else {$columns->{$_}=$_}}$argv[1]=[];for (sort {$a <=> $b}(keys %{$columns})){push @{$argv[1]},join q{.},$argv[0],$_}}for (@{$argv[1]}){if (!m/^\.?\d+(?:\.\d+)* *$/){return$this->_error('The columns list OBJECT IDENTIFIER "%s" is expected in dotted ' .'decimal notation',$_)}}my$start_index=undef;if (defined$argv[2]){if ($argv[2]!~ m/^\d+(?:\.\d+)*$/){return$this->_error('The start index "%s" is expected in dotted decimal notation',$argv[2])}my@subids=split m/\./,$argv[2];if ($subids[-1]> 0){$subids[-1]--}else {pop@subids}$start_index=(@subids)? join(q{.},@subids): q{}}if (defined$argv[3]){if ($argv[3]!~ /^\d+(?:\.\d+)*$/){return$this->_error('The end index "%s" is expected in dotted decimal notation',$argv[3])}if (defined$argv[2]){if (oid_lex_cmp($argv[2],$argv[3])> 0){return$this->_error('The end index cannot be less than the start index')}}}if (defined$argv[5]){if (ref$argv[5]eq 'CODE'){$argv[5]=[$argv[5]]}elsif ((ref($argv[5])ne 'ARRAY')|| (ref($argv[5]->[0])ne 'CODE')){return$this->_error('The syntax of the row callback is invalid')}}if (!defined$this->_create_pdu()){return$this->_error()}my$argv={callback=>$this->{_pdu}->callback(),columns=>$argv[1],end_index=>$argv[3],entries=>undef,last_index=>undef,max_reps=>0,row_callback=>$argv[5],start_index=>$argv[2],types=>undef,use_bulk=>FALSE };$this->{_pdu}->callback(sub {$this->{_pdu}=$_[0];$this->_error_clear();if ($this->{_pdu}->error()){$this->_error($this->{_pdu}->error())}$this->_get_entries_cb($argv);return});my$vbl=[map {(defined$start_index)? join q{.},$_,$start_index : $_}@{$argv->{columns}}];if ($this->version()==SNMP_VERSION_1){if (defined$argv[4]){return$this->_error('The max-repetitions argument is not applicable when using SNMPv1')}}else {if (!defined$argv[4]){$argv->{use_bulk}=TRUE;$argv->{max_reps}=int($this->_msg_size_max_reps()/ @{$argv->{columns}})+ 1}elsif ($argv[4]> 1){$argv->{use_bulk}=TRUE;$argv->{max_reps}=$argv[4]}}if ($argv->{use_bulk}){if (!defined$this->{_pdu}->prepare_get_bulk_request(0,$argv->{max_reps},$vbl)){return$this->_error($this->{_pdu}->error())}}else {if (!defined$this->{_pdu}->prepare_get_next_request($vbl)){return$this->_error($this->{_pdu}->error())}}return$this->_send_pdu()}sub version {my ($this)=@_;return$this->_error('The SNMP version is not modifiable')if (@_==2);return$this->{_version}}sub error {return $_[0]->{_error}|| q{}}sub hostname {return $_[0]->{_hostname}}sub error_status {return defined($_[0]->{_pdu})? $_[0]->{_pdu}->error_status(): 0}sub error_index {return defined($_[0]->{_pdu})? $_[0]->{_pdu}->error_index(): 0}sub var_bind_list {return defined($_[0]->{_pdu})? $_[0]->{_pdu}->var_bind_list(): undef}sub var_bind_names {return defined($_[0]->{_pdu})? @{$_[0]->{_pdu}->var_bind_names()}: ()}sub var_bind_types {return defined($_[0]->{_pdu})? $_[0]->{_pdu}->var_bind_types(): undef}sub timeout {my$this=shift;if (!defined$this->{_transport}){return$this->_error('The session is closed')}if (defined (my$timeout=$this->{_transport}->timeout(@_))){return$timeout}return$this->_error($this->{_transport}->error())}sub retries {my$this=shift;if (!defined$this->{_transport}){return$this->_error('The session is closed')}if (defined (my$retries=$this->{_transport}->retries(@_))){return$retries}return$this->_error($this->{_transport}->error())}sub max_msg_size {my$this=shift;if (!defined$this->{_transport}){return$this->_error('The session is closed')}if (defined (my$max_size=$this->{_transport}->max_msg_size(@_))){return$max_size}return$this->_error($this->{_transport}->error())}sub mtu {goto&max_msg_size}sub translate {my ($this,$mask)=@_;if (@_!=2){return$this->{_translate}}if (ref($mask)ne 'ARRAY'){$this->_translate_mask($_[1],TRANSLATE_ALL)}else {my@argv=@{$mask};my$arg;while (defined ($arg=shift@argv)){if ($arg =~ /^-?all$/i){$this->_translate_mask(shift(@argv),TRANSLATE_ALL)}elsif ($arg =~ /^-?none$/i){$this->_translate_mask(!(shift@argv),TRANSLATE_ALL)}elsif ($arg =~ /^-?octet_?string$/i){$this->_translate_mask(shift(@argv),TRANSLATE_OCTET_STRING)}elsif ($arg =~ /^-?null$/i){$this->_translate_mask(shift(@argv),TRANSLATE_NULL)}elsif ($arg =~ /^-?timeticks$/i){$this->_translate_mask(shift(@argv),TRANSLATE_TIMETICKS)}elsif ($arg =~ /^-?opaque$/i){$this->_translate_mask(shift(@argv),TRANSLATE_OPAQUE)}elsif ($arg =~ /^-?nosuchobject$/i){$this->_translate_mask(shift(@argv),TRANSLATE_NOSUCHOBJECT)}elsif ($arg =~ /^-?nosuchinstance$/i){$this->_translate_mask(shift(@argv),TRANSLATE_NOSUCHINSTANCE)}elsif ($arg =~ /^-?endofmibview$/i){$this->_translate_mask(shift(@argv),TRANSLATE_ENDOFMIBVIEW)}elsif ($arg =~ /^-?unsigned$/i){$this->_translate_mask(shift(@argv),TRANSLATE_UNSIGNED)}else {return$this->_error('The translate argument "%s" is unknown',$arg)}}}DEBUG_INFO('translate mask = 0x%02x',$this->{_translate});return$this->{_translate}}sub debug {my (undef,$mask)=@_;if (@_==2){$DEBUG=($mask =~ /^\d+$/)? $mask : ($mask)? DEBUG_ALL : DEBUG_NONE;eval {Net::SNMP::Message->debug($DEBUG & DEBUG_MESSAGE)};eval {Net::SNMP::Transport->debug($DEBUG & DEBUG_TRANSPORT)};eval {Net::SNMP::Dispatcher->debug($DEBUG & DEBUG_DISPATCHER)};eval {Net::SNMP::MessageProcessing->debug($DEBUG & DEBUG_PROCESSING)};eval {Net::SNMP::Security->debug($DEBUG & DEBUG_SECURITY)}}return$DEBUG}sub snmp_debug {return debug(undef,$_[0])}sub pdu {return $_[0]->{_pdu}}sub nonblocking {return $_[0]->{_nonblocking}}sub security {return $_[0]->{_security}}sub transport {return $_[0]->{_transport}}sub oid_base_match {my ($base,$oid)=@_;defined$base || return FALSE;defined$oid || return FALSE;$base =~ s/^\.//o;$oid =~ s/^\.//o;$base=pack 'N*',split m/\./,$base;$oid=pack 'N*',split m/\./,$oid;return (substr($oid,0,length$base)eq $base)? TRUE : FALSE}sub oid_context_match {require Carp;Carp::croak('oid_context_match() is obsolete, use oid_base_match() instead');goto&oid_base_match}sub oid_lex_cmp {my ($aa,$bb)=@_;for ($aa,$bb){s/^\.//;s/ /\.0/g;$_=pack 'N*',split m/\./}return$aa cmp $bb}sub oid_lex_sort {if (@_ <= 1){return @_}return map {$_->[0]}sort {$a->[1]cmp $b->[1]}map {my$oid=$_;$oid =~ s/^\.//;$oid =~ s/ /\.0/g;[$_,pack 'N*',split m/\./,$oid]}@_}sub snmp_type_ntop {goto&asn1_itoa}sub ticks_to_time {goto&asn1_ticks_to_time}sub DESTROY {my ($this)=@_;if ($this->{_nonblocking}){if (--$NONBLOCKING < 0){die 'FATAL: Invalid non-blocking object count'}}else {if (--$BLOCKING < 0){die 'FATAL: Invalid blocking object count'}}}sub _send_pdu {my ($this)=@_;if ($this->{_nonblocking}&&!$this->{_security}->discovered()){push @{$this->{_discovery_queue}},[$this->{_pdu},$this->{_delay}];return TRUE}$DISPATCHER->send_pdu($this->{_pdu},$this->{_delay});if (!$this->{_nonblocking}){snmp_dispatcher()}return ($this->{_nonblocking})? TRUE : $this->var_bind_list()}sub _create_pdu {my ($this)=@_;($this->{_pdu},$this->{_error})=Net::SNMP::PDU->new(-version=>$this->{_version},-security=>$this->{_security},-transport=>$this->{_transport},-translate=>$this->{_translate},-callback=>$this->_callback_closure(),-requestid=>$DISPATCHER->msg_handle_alloc(),defined($this->{_context_engine_id})? (-contextengineid=>$this->{_context_engine_id}): (),defined($this->{_context_name})? (-contextname=>$this->{_context_name}): (),);if (!defined$this->{_pdu}){return$this->_error()}$this->_error_clear();return$this->{_pdu}}{my$versions={'(?:snmp)?v?1',SNMP_VERSION_1,'(?:snmp)?v?2c?',SNMP_VERSION_2C,'(?:snmp)?v?3',SNMP_VERSION_3,};sub _version {my ($this,$version)=@_;$this->_error_clear();if ($version eq q{}){return$this->_error('An empty SNMP version was specified')}for (keys %{$versions}){if ($version =~ m/^$_$/i){$_[1]=$this->{_version}=$versions->{$_};return TRUE}}return$this->_error('The SNMP version "%s" is unknown',$version)}}{my$obj_args={-callback=>\&_callback,-contextengineid=>\&_context_engine_id,-contextname=>\&_context_name,-delay=>\&_delay,};sub _prepare_argv {my ($this,$allowed,$named,$unnamed)=@_;my%argv;if ((@{$named})&& ($named->[0]=~ m/^\.?\d+(?:\.\d+)* *$/)){$argv{-varbindlist}=$named}else {%argv=@{$named}}my%new_args;for my$key (keys%argv){my@match=grep {/^-?\Q$key\E$/i}@{$allowed};if (@match==1){if (exists$obj_args->{$match[0]}){if (!defined$this->${\$obj_args->{$match[0]}}($argv{$key})){return$this->_error()}}else {$new_args{$match[0]}=$argv{$key}}}else {return$this->_error('The argument "%s" is unknown',$key)}}for (@{$allowed}){next if exists$obj_args->{$_};push @{$unnamed},exists($new_args{$_})? $new_args{$_}: undef}return TRUE}}sub _callback {my ($this,$callback)=@_;if (!$this->{_nonblocking}){return$this->_error('The callback argument is not applicable to blocking objects')}my@argv;if (!defined$callback){$this->{_callback}=undef;return TRUE}elsif ((ref($callback)eq 'ARRAY')&& (ref($callback->[0])eq 'CODE')){($callback,@argv)=@{$callback}}elsif (ref($callback)ne 'CODE'){return$this->_error('The syntax of the callback is invalid')}$this->{_callback}=[$callback,\@argv];return TRUE}sub _callback_closure {my ($this)=@_;if (!$this->{_nonblocking}||!defined$this->{_callback}){return sub {$this->{_pdu}=$_[0];$this->_error_clear();if ($this->{_pdu}->error()){$this->_error($this->{_pdu}->error())}return}}my ($callback,$argv)=@{$this->{_callback}};return sub {$this->{_pdu}=$_[0];$this->_error_clear();if ($this->{_pdu}->error()){$this->_error($this->{_pdu}->error())}$callback->($this,@{$argv});return}}sub _context_engine_id {my ($this,$context_engine_id)=@_;$this->_error_clear();if ($this->version()!=SNMP_VERSION_3){return$this->_error('The contextEngineID argument is only supported in SNMPv3')}if (!defined$context_engine_id){$this->{_context_engine_id}=undef}elsif ($context_engine_id =~ m/^(?:0x)?([A-F0-9]+)$/i){my$cei=pack 'H*',length($1)% 2 ? '0'.$1 : $1;my$len=length$cei;if ($len < 5 || $len > 32){return$this->_error('The contextEngineID length of %d is out of range (5..32)',$len)}$this->{_context_engine_id}=$cei}else {return$this->_error('The contextEngineID "%s" is expected in hexadecimal format',$context_engine_id)}return TRUE}sub _context_name {my ($this,$context_name)=@_;$this->_error_clear();if ($this->version()!=SNMP_VERSION_3){return$this->_error('The contextName argument is only supported in SNMPv3')}if (!defined$context_name){$this->{_context_name}=undef}elsif (length($context_name)<= 32){$this->{_context_name}=$context_name}else {return$this->_error('The contextName length of %d is out of range (0..32)',length$context_name)}return TRUE}sub _delay {my ($this,$delay)=@_;$this->_error_clear();if (!$this->{_nonblocking}){return$this->_error('The delay argument is not applicable to blocking objects')}if ($delay !~ /^\d+(?:\.\d+)?$/){return$this->_error('The delay value "%s" is expected in positive numeric format',$delay)}if ($delay < 0 || $delay > 31556926){return$this->_error('The delay value "%s" is out of range (0..31556926)',$delay)}$this->{_delay}=$delay;return TRUE}sub _object_type_validate {my ($this)=@_;my$count=($this->{_nonblocking})? ++$NONBLOCKING : ++$BLOCKING;if ($this->{_nonblocking}&& $BLOCKING){return$this->_error('Cannot create non-blocking objects when blocking objects exist')}elsif (!$this->{_nonblocking}&& $NONBLOCKING){return$this->_error('Cannot create blocking objects when non-blocking objects exist')}return$count}sub _perform_discovery {my ($this)=@_;return TRUE if ($this->{_security}->discovered());if (!defined$this->_create_pdu()){return$this->_discovery_failed()}$this->{_pdu}->callback(sub {$this->{_pdu}=$_[0];$this->_error_clear();if ($this->{_pdu}->error()){$this->_error($this->{_pdu}->error().' during discovery')}$this->_discovery_engine_id_cb();return});if (!defined$this->{_pdu}->prepare_get_request()){$this->_error($this->{_pdu}->error());return$this->_discovery_failed()}$DISPATCHER->send_pdu($this->{_pdu},0);if (!$this->{_nonblocking}){snmp_dispatcher()}return ($this->{_error})? $this->_error(): TRUE}sub _discovery_engine_id_cb {my ($this)=@_;if ($this->{_error}!~ /usmStatsUnknownEngineIDs/){return$this->_discovery_failed()}$this->_error_clear();if ($this->{_security}->discovered()){DEBUG_INFO('discovery complete');return$this->_discovery_complete()}if (!defined$this->_create_pdu()){return$this->_discovery_failed()}$this->{_pdu}->callback(sub {$this->{_pdu}=$_[0];$this->_error_clear();if ($this->{_pdu}->error()){$this->_error($this->{_pdu}->error().' during synchronization')}$this->_discovery_synchronization_cb();return});if (!defined$this->{_pdu}->prepare_get_request()){$this->_error($this->{_pdu}->error());return$this->_discovery_failed()}$DISPATCHER->send_pdu($this->{_pdu},0);if (!$this->{_nonblocking}){snmp_dispatcher()}return ($this->{_error})? $this->_error(): TRUE}sub _discovery_synchronization_cb {my ($this)=@_;if (($this->{_security}->discovered())&& ($this->{_error}=~ /usmStatsNotInTimeWindows/)){$this->_error_clear();DEBUG_INFO('discovery and synchronization complete');return$this->_discovery_complete()}if ((!$this->{_error})|| ($this->{_error}=~ /usmStatsNotInTimeWindows/)){$this->_error_clear();$this->_error('Time synchronization failed during discovery')}DEBUG_INFO('synchronization failed');return$this->_discovery_failed()}sub _discovery_failed {my ($this)=@_;$this->{_pdu}=undef;$this->{_transport}=undef;while (my$q=shift @{$this->{_discovery_queue}}){$q->[0]->status_information($this->{_error})}return$this->_error()}sub _discovery_complete {my ($this)=@_;while (my$q=shift @{$this->{_discovery_queue}}){$DISPATCHER->send_pdu(@{$q})}return ($this->{_error})? $this->_error(): TRUE}sub _translate_mask {my ($this,$enable,$mask)=@_;if ($enable){$this->{_translate}|= $mask}else {$this->{_translate}&= ~$mask}return$this->{_translate}}sub _msg_size_max_reps {my ($this)=@_;if (!defined$this->{_transport}){return 25}return int$this->{_transport}->max_msg_size()* 0.017}sub _get_table_cb {my ($this,$argv)=@_;my$callback=$this->{_pdu}->callback();$this->{_pdu}->callback($argv->{callback});my$list=$this->var_bind_list();my$types=$this->var_bind_types();my@names=$this->var_bind_names();my$next=undef;while (@names){$next=shift@names;if (!oid_base_match($argv->{base_oid},$next)|| ($types->{$next}==ENDOFMIBVIEW)){$next=undef;last}if (!exists$argv->{table}->{$next}){$argv->{table}->{$next}=$list->{$next};$argv->{types}->{$next}=$types->{$next}}elsif (++$argv->{repeat_cnt}> $argv->{max_reps}){$this->{_pdu}->status_information('A loop was detected with the table on the remote host');return}}if (defined$next){$this->_get_table_entries_request_next($argv,$callback,[$next]);return}if ($this->error_status()==2){$this->{_pdu}->error(undef)}if (!$this->{_pdu}->error()&&!defined$argv->{table}){$this->{_pdu}->error('The requested table is empty or does not exist')}$this->{_pdu}->var_bind_list($argv->{table},$argv->{types});$this->{_pdu}->process_response_pdu();return}sub _get_entries_cb {my ($this,$argv)=@_;my$callback=$this->{_pdu}->callback();$this->{_pdu}->callback($argv->{callback});my$list=$this->var_bind_list();my$types=$this->var_bind_types();my@names=$this->var_bind_names();my$max_index=(defined$argv->{last_index})? $argv->{last_index}: '0';my$last_entry=TRUE;my$cache={};while (@names){my@row=();my$row_index=undef;for my$col_num (0 .. $#{$argv->{columns}}){my$name=shift@names;if (!defined$name){DEBUG_INFO('column number / oid number mismatch');$last_entry=FALSE;@row=();last}my$column=quotemeta$argv->{columns}->[$col_num];my$index;if ($name =~ m/$column\.(\d+(:?\.\d+)*)/){$index=$1}else {DEBUG_INFO('last_entry: column mismatch: %s',$name);$last_entry=TRUE;next}DEBUG_INFO('found index [%s]',$index);if ((defined$argv->{start_index})&& (oid_lex_cmp($index,$argv->{start_index})< 0)){DEBUG_INFO('index [%s] less than start_index [%s]',$index,$argv->{start_index});if (oid_lex_cmp($index,$max_index)> 0){$max_index=$index;$last_entry=FALSE;DEBUG_INFO('new max_index [%s]',$max_index)}next}elsif ((defined$argv->{end_index})&& (oid_lex_cmp($index,$argv->{end_index})> 0)){DEBUG_INFO('last_entry: index [%s] greater than end_index [%s]',$index,$argv->{end_index});$last_entry=TRUE;next}$cache->{$index}->[$col_num]=$name;if (!defined$row_index){$row_index=$index}my$index_cmp=oid_lex_cmp($index,$row_index);if ($index_cmp==0){$row[$col_num]=$name}elsif ($index_cmp < 0){@row=();$row_index=$index;$row[$col_num]=$name;DEBUG_INFO('new minimum row_index [%s]',$row_index)}else {DEBUG_INFO('index [%s] greater than current row_index [%s]',$index,$row_index)}}if (!@row ||!defined$row_index){next}for my$col_num (0 .. $#{$argv->{columns}}){if (!defined$row[$col_num]){if (defined$cache->{$row_index}->[$col_num]){DEBUG_INFO('using cache: %s',$cache->{$row_index}->[$col_num]);$row[$col_num]=$cache->{$row_index}->[$col_num]}else {next}}if (!exists$argv->{entries}->{$row[$col_num]}){$last_entry=FALSE;$argv->{entries}->{$row[$col_num]}=$list->{$row[$col_num]};$argv->{types}->{$row[$col_num]}=$types->{$row[$col_num]}}else {DEBUG_INFO('not adding duplicate: %s',$row[$col_num])}}$this->_get_entries_exec_row_cb($argv,$row_index,\@row);if (oid_lex_cmp($row_index,$max_index)> 0){$max_index=$row_index;DEBUG_INFO('new max_index [%s]',$max_index)}}if (defined$argv->{last_index}){if (oid_lex_cmp($max_index,$argv->{last_index})> 0){$argv->{last_index}=$max_index}elsif ($last_entry==FALSE){DEBUG_INFO('last_entry: max_index [%s] not greater than last_index [%s])',$max_index,$argv->{last_index});$last_entry=TRUE}}else {$argv->{last_index}=$max_index}if ($last_entry==FALSE){my$vbl=[map {join q{.},$_,$max_index}@{$argv->{columns}}];$this->_get_table_entries_request_next($argv,$callback,$vbl);return}if ($this->error_status()==2){$this->{_pdu}->error(undef)}if (!$this->{_pdu}->error()&&!defined$argv->{entries}){$this->{_pdu}->error('The requested entries are empty or do not exist')}$this->{_pdu}->var_bind_list($argv->{entries},$argv->{types});if ($this->{_pdu}->error()){$this->_get_entries_exec_row_cb($argv,0,[])}$this->{_pdu}->process_response_pdu();return}sub _get_table_entries_request_next {my ($this,$argv,$callback,$vbl)=@_;my$pdu=$this->{_pdu};if (!defined$this->_create_pdu()){$pdu->status_information($this->error());return}$this->{_pdu}->callback($callback);if (defined$pdu->context_engine_id()){$this->{_pdu}->context_engine_id($pdu->context_engine_id())}if (defined$pdu->context_name()){$this->{_pdu}->context_name($pdu->context_name())}if ($argv->{use_bulk}){if (!defined$this->{_pdu}->prepare_get_bulk_request(0,$argv->{max_reps},$vbl)){$pdu->status_information($this->{_pdu}->error());return}}else {if (!defined$this->{_pdu}->prepare_get_next_request($vbl)){$pdu->status_information($this->{_pdu}->error());return}}$DISPATCHER->send_pdu($this->{_pdu},0);return}sub _get_entries_exec_row_cb {my ($this,$argv,$index,$row)=@_;return if!defined$argv->{row_callback};my ($cb,@argv)=@{$argv->{row_callback}};for (my$col_num=$#{$argv->{columns}};$col_num >= 0;--$col_num){if (defined$row->[$col_num]){unshift@argv,$argv->{entries}->{$row->[$col_num]}}else {unshift@argv,undef}}unshift@argv,$index;return eval {$cb->(@argv)}}sub _error {my$this=shift;if (defined$this->{_pdu}&& defined$this->{_pdu}->callback()){$this->{_pdu}->callback(undef)}if (!defined$this->{_error}){$this->{_error}=(@_ > 1)? sprintf(shift(@_),@_): $_[0];if ($this->debug()){printf "error: [%d] %s(): %s\n",(caller 0)[2],(caller 1)[3],$this->{_error}}}return}sub _error_clear {return $_[0]->{_error}=undef}sub require_version {my ($this,@argv)=@_;if (@argv > 0){my$wanted=$argv[0];if ($wanted =~ /(\d+)\.(\d{1,3})\.(\d{1,3})/){$argv[0]=sprintf '%d.%03d%03d',$1,$2,$3}}my$version=eval {sprintf '%d.%03d%03d',unpack 'C*',$this->UNIVERSAL::VERSION(@argv)};if ($@){local $_=$@;s/ at(?:.*)\n//;require Carp;Carp::croak($_)}return$version}sub DEBUG_INFO {return$DEBUG if (!$DEBUG);return printf sprintf('debug: [%d] %s(): ',(caller 0)[2],(caller 1)[3]).((@_ > 1)? shift(@_): '%s')."\n",@_}1;