package Net::SNMP::Security::USM;use strict;use Net::SNMP::Security qw(:ALL);use Net::SNMP::Message qw(:msgFlags asn1_itoa OCTET_STRING SEQUENCE INTEGER SNMP_VERSION_3 TRUE FALSE);use Crypt::DES();use Digest::MD5();use Digest::SHA1();use Digest::HMAC();our$VERSION=v4.0.1;use base qw(Net::SNMP::Security);our@EXPORT_OK;our%EXPORT_TAGS=(authprotos=>[qw(AUTH_PROTOCOL_NONE AUTH_PROTOCOL_HMACMD5 AUTH_PROTOCOL_HMACSHA) ],levels=>[qw(SECURITY_LEVEL_NOAUTHNOPRIV SECURITY_LEVEL_AUTHNOPRIV SECURITY_LEVEL_AUTHPRIV) ],models=>[qw(SECURITY_MODEL_ANY SECURITY_MODEL_SNMPV1 SECURITY_MODEL_SNMPV2C SECURITY_MODEL_USM) ],privprotos=>[qw(PRIV_PROTOCOL_NONE PRIV_PROTOCOL_DES PRIV_PROTOCOL_AESCFB128 PRIV_PROTOCOL_DRAFT_3DESEDE PRIV_PROTOCOL_DRAFT_AESCFB128 PRIV_PROTOCOL_DRAFT_AESCFB192 PRIV_PROTOCOL_DRAFT_AESCFB256) ],);Exporter::export_ok_tags(qw(authprotos levels models privprotos));$EXPORT_TAGS{ALL}=[@EXPORT_OK ];sub AUTH_PROTOCOL_NONE {'1.3.6.1.6.3.10.1.1.1'}sub AUTH_PROTOCOL_HMACMD5 {'1.3.6.1.6.3.10.1.1.2'}sub AUTH_PROTOCOL_HMACSHA {'1.3.6.1.6.3.10.1.1.3'}sub PRIV_PROTOCOL_NONE {'1.3.6.1.6.3.10.1.2.1'}sub PRIV_PROTOCOL_DES {'1.3.6.1.6.3.10.1.2.2'}sub PRIV_PROTOCOL_AESCFB128 {'1.3.6.1.6.3.10.1.2.4'}sub PRIV_PROTOCOL_DRAFT_3DESEDE {'1.3.6.1.4.1.14832.1.1'}sub PRIV_PROTOCOL_DRAFT_AESCFB128 {'1.3.6.1.4.1.14832.1.2'}sub PRIV_PROTOCOL_DRAFT_AESCFB192 {'1.3.6.1.4.1.14832.1.3'}sub PRIV_PROTOCOL_DRAFT_AESCFB256 {'1.3.6.1.4.1.14832.1.4'}our$ENGINE_ID;sub new {my ($class,%argv)=@_;my$this=bless {'_error'=>undef,'_version'=>SNMP_VERSION_3,'_authoritative'=>FALSE,'_discovered'=>FALSE,'_synchronized'=>FALSE,'_engine_id'=>q{},'_engine_boots'=>0,'_engine_time'=>0,'_latest_engine_time'=>0,'_time_epoc'=>time(),'_user_name'=>q{},'_auth_data'=>undef,'_auth_key'=>undef,'_auth_password'=>undef,'_auth_protocol'=>AUTH_PROTOCOL_HMACMD5,'_priv_data'=>undef,'_priv_key'=>undef,'_priv_password'=>undef,'_priv_protocol'=>PRIV_PROTOCOL_DES,'_security_level'=>SECURITY_LEVEL_NOAUTHNOPRIV },$class;for (keys%argv){if (/^-?authoritative$/i){$this->{_authoritative}=(delete$argv{$_})? TRUE : FALSE}elsif (/^-?authprotocol$/i){$this->_auth_protocol(delete$argv{$_})}elsif (/^-?privprotocol$/i){$this->_priv_protocol(delete$argv{$_})}if (defined$this->{_error}){return wantarray ? (undef,$this->{_error}): undef}}for (keys%argv){if (/^-?version$/i){$this->_version($argv{$_})}elsif (/^-?debug$/i){$this->debug($argv{$_})}elsif ((/^-?engineid$/i)&& ($this->{_authoritative})){$this->_engine_id($argv{$_})}elsif (/^-?username$/i){$this->_user_name($argv{$_})}elsif (/^-?authkey$/i){$this->_auth_key($argv{$_})}elsif (/^-?authpassword$/i){$this->_auth_password($argv{$_})}elsif (/^-?privkey$/i){$this->_priv_key($argv{$_})}elsif (/^-?privpassword$/i){$this->_priv_password($argv{$_})}else {$this->_error('The argument "%s" is unknown',$_)}if (defined$this->{_error}){return wantarray ? (undef,$this->{_error}): undef}}if ($this->{_authoritative}){$this->_snmp_engine_init()}if (!defined$this->_security_params()){return wantarray ? (undef,$this->{_error}): undef}return wantarray ? ($this,q{}): $this}sub generate_request_msg {my ($this,$pdu,$msg)=@_;$this->_error_clear();if (@_ < 3){return$this->_error('The required PDU and/or Message object is missing')}if ($pdu->version()!=$this->{_version}){return$this->_error('The SNMP version %d was expected, but %d was found',$this->{_version},$pdu->version())}if ($pdu->security_level()> $this->{_security_level}){return$this->_error('The PDU securityLevel %d is greater than the configured value %d',$pdu->security_level(),$this->{_security_level})}if ($pdu->expect_response()){if ($this->{_authoritative}){return$this->_error('Must be a non-authoritative SNMP engine to generate a %s',asn1_itoa($pdu->pdu_type()))}}else {if (!$this->{_authoritative}){return$this->_error('Must be an authoritative SNMP engine to generate a %s',asn1_itoa($pdu->pdu_type()))}}my$msg_global_data=$msg->clear();my$msg_engine_time=$this->_engine_time();my$msg_engine_boots=$this->_engine_boots();my$pdu_buffer=$pdu->copy();my$priv_params=q{};if ($pdu->security_level()> SECURITY_LEVEL_AUTHNOPRIV){if (!defined$this->_encrypt_data($msg,$priv_params,$pdu_buffer)){return$this->_error()}}if (!defined$msg->prepare(OCTET_STRING,$priv_params)){return$this->_error($msg->error())}my$auth_params=q{};my$auth_location=0;if ($pdu->security_level()> SECURITY_LEVEL_NOAUTHNOPRIV){$auth_location=$msg->length()+ 12 + length$pdu_buffer;$auth_params=pack 'x12'}if (!defined$msg->prepare(OCTET_STRING,$auth_params)){return$this->_error($msg->error())}if (!defined$msg->prepare(OCTET_STRING,$pdu->security_name())){return$this->_error($msg->error())}if (!defined$msg->prepare(INTEGER,$msg_engine_time)){return$this->_error($msg->error())}if (!defined$msg->prepare(INTEGER,$msg_engine_boots)){return$this->_error($msg->error())}if (!defined$msg->prepare(OCTET_STRING,$this->_engine_id())){return$this->_error($msg->error())}if (!defined$msg->prepare(SEQUENCE)){return$this->_error($msg->error())}if (!defined$msg->prepare(OCTET_STRING,$msg->clear())){return$this->_error($msg->error())}if (!defined$msg->append($pdu_buffer)){return$this->_error($msg->error())}if (!defined$msg->prepend($msg_global_data)){return$this->_error($msg->error())}if (!defined$msg->prepare(INTEGER,$this->{_version})){return$this->_error($msg->error())}if (!defined$msg->prepare(SEQUENCE)){return$this->_error($msg->error())}if ($pdu->security_level()> SECURITY_LEVEL_NOAUTHNOPRIV){if (!defined$this->_authenticate_outgoing_msg($msg,$auth_location)){return$this->_error($msg->error())}}return$msg}sub process_incoming_msg {my ($this,$msg)=@_;$this->_error_clear();return$this->_error('The required Message object is missing')if (@_ < 2);my$msg_params=$msg->process(OCTET_STRING);return$this->_error($msg->error())if!defined$msg_params;$msg->index($msg->index()- length$msg_params);return$this->_error($msg->error())if!defined$msg->process(SEQUENCE);my$msg_engine_id;if (!defined($msg_engine_id=$msg->process(OCTET_STRING))){return$this->_error($msg->error())}my$msg_engine_boots;if (!defined ($msg_engine_boots=$msg->process(INTEGER))){return$this->_error($msg->error())}if (($msg_engine_boots < 0)|| ($msg_engine_boots > 2147483647)){return$this->_error('The msgAuthoritativeEngineBoots value %d is out of range ' .'(0..2147483647)',$msg_engine_boots)}my$msg_engine_time;if (!defined ($msg_engine_time=$msg->process(INTEGER))){return$this->_error($msg->error())}if (($msg_engine_time < 0)|| ($msg_engine_time > 2147483647)){return$this->_error('The msgAuthoritativeEngineTime value %d is out of range ' .'(0..2147483647)',$msg_engine_time)}if (!defined$msg->security_name($msg->process(OCTET_STRING))){return$this->_error($msg->error())}my$auth_params;if (!defined ($auth_params=$msg->process(OCTET_STRING))){return$this->_error($msg->error())}if (my$len=length$auth_params){if ($len!=12){return$this->_error('The msgAuthenticationParameters length of %d is invalid',$len)}substr ${$msg->reference},($msg->index()- 12),12,pack 'x12'}my$priv_params;if (!defined ($priv_params=$msg->process(OCTET_STRING))){return$this->_error($msg->error())}if ($this->{_discovered}){if ($msg_engine_id ne $this->_engine_id()){return$this->_error('The msgAuthoritativeEngineID "%s" was expected, but "%s" was ' .'found',unpack('H*',$this->_engine_id()),unpack 'H*',$msg_engine_id)}if ($msg->security_name()ne $this->_user_name()){return$this->_error('The msgUserName "%s" was expected, but "%s" was found',$this->_user_name(),$msg->security_name())}}else {if (!defined$this->_engine_id_discovery($msg_engine_id)){return$this->_error()}}my$security_level=$msg->security_level();if ($security_level > $this->{_security_level}){return$this->_error('The message securityLevel %d is greater than the configured ' .'value %d',$security_level,$this->{_security_level})}if ($security_level > SECURITY_LEVEL_NOAUTHNOPRIV){if (!defined$this->_authenticate_incoming_msg($msg,$auth_params)){return$this->_error()}if (!$this->_synchronize($msg_engine_boots,$msg_engine_time)){return$this->_error()}if (!defined$this->_timeliness($msg_engine_boots,$msg_engine_time)){return$this->_error()}if ($security_level > SECURITY_LEVEL_AUTHNOPRIV){if (length($priv_params)!=8){return$this->_error('The msgPrivacyParameters length of %d is invalid',length$priv_params)}if (($this->{_priv_protocol}eq PRIV_PROTOCOL_AESCFB128)|| ($this->{_priv_protocol}eq PRIV_PROTOCOL_DRAFT_AESCFB192)|| ($this->{_priv_protocol}eq PRIV_PROTOCOL_DRAFT_AESCFB256)){substr$priv_params,0,0,pack 'NN',$msg_engine_boots,$msg_engine_time}return$this->_decrypt_data($msg,$priv_params,$msg->process(OCTET_STRING))}}return TRUE}sub user_name {return $_[0]->{_user_name}}sub auth_protocol {my ($this)=@_;if ($this->{_security_level}> SECURITY_LEVEL_NOAUTHNOPRIV){return$this->{_auth_protocol}}return AUTH_PROTOCOL_NONE}sub auth_key {return $_[0]->{_auth_key}}sub priv_protocol {my ($this)=@_;if ($this->{_security_level}> SECURITY_LEVEL_AUTHNOPRIV){return$this->{_priv_protocol}}return PRIV_PROTOCOL_NONE}sub priv_key {return $_[0]->{_priv_key}}sub engine_id {return $_[0]->{_engine_id}}sub engine_boots {goto _engine_boots}sub engine_time {goto&_engine_time}sub security_level {return $_[0]->{_security_level}}sub security_model {return SECURITY_MODEL_USM}sub security_name {goto&_user_name}sub discovered {my ($this)=@_;if ($this->{_security_level}> SECURITY_LEVEL_NOAUTHNOPRIV){return ($this->{_discovered}&& $this->{_synchronized})}return$this->{_discovered}}sub _version {my ($this,$version)=@_;if ($version!=SNMP_VERSION_3){return$this->_error('The SNMP version %s is not supported',$version)}return$this->{_version}=$version}sub _engine_id {my ($this,$engine_id)=@_;if (@_ < 2){return$this->{_engine_id}}if ($engine_id =~ m/^(?:0x)?([A-F0-9]+)$/i){my$eid=pack 'H*',length($1)% 2 ? '0'.$1 : $1;my$len=length$eid;if ($len < 5 || $len > 32){return$this->_error('The authoritativeEngineID length of %d is out of range (5..32)',$len)}$this->{_engine_id}=$eid}else {return$this->_error('The authoritativeEngineID "%s" is expected in hexadecimal format',$engine_id)}return$this->{_engine_id}}sub _user_name {my ($this,$user_name)=@_;if (@_==2){if ($user_name eq q{}){return$this->_error('An empty userName was specified')}elsif (length($user_name)> 32){return$this->_error('The userName length of %d is out of range (1..32)',length$user_name)}$this->{_user_name}=$user_name}return ($this->{_discovered})? $this->{_user_name}: q{}}sub _snmp_engine_init {my ($this)=@_;if ($this->{_engine_id}eq q{}){if (!defined$ENGINE_ID){$ENGINE_ID=eval {require Sys::Hostname;pack('H10','8000000001').gethostbyname Sys::Hostname::hostname()};if ($@){$ENGINE_ID=pack 'x11H2','01'}}$this->{_engine_id}=$ENGINE_ID}$this->{_engine_boots}=1;$this->{_time_epoc}=$^T;$this->{_synchronized}=TRUE;$this->{_discovered}=TRUE;return TRUE}sub _auth_key {my ($this,$auth_key)=@_;if (@_==2){if ($auth_key =~ m/^(?:0x)?([A-F0-9]+)$/i){$this->{_auth_key}=pack 'H*',length($1)% 2 ? '0'.$1 : $1;if (!defined$this->_auth_key_validate()){return$this->_error()}}else {return$this->_error('The authKey "%s" is expected in hexadecimal format',$auth_key)}}return$this->{_auth_key}}sub _auth_password {my ($this,$auth_password)=@_;if (@_==2){if ($auth_password eq q{}){return$this->_error('An empty authentication password was specified')}$this->{_auth_password}=$auth_password}return$this->{_auth_password}}{my$protocols={'(?:hmac-)?md5(?:-96)?',AUTH_PROTOCOL_HMACMD5,quotemeta AUTH_PROTOCOL_HMACMD5,AUTH_PROTOCOL_HMACMD5,'(?:hmac-)?sha(?:-?1|-96)?',AUTH_PROTOCOL_HMACSHA,quotemeta AUTH_PROTOCOL_HMACSHA,AUTH_PROTOCOL_HMACSHA,};sub _auth_protocol {my ($this,$proto)=@_;if (@_ < 2){return$this->{_auth_protocol}}if ($proto eq q{}){return$this->_error('An empty authProtocol was specified')}for (keys %{$protocols}){if ($proto =~ /^$_$/i){return$this->{_auth_protocol}=$protocols->{$_}}}return$this->_error('The authProtocol "%s" is unknown',$proto)}}sub _priv_key {my ($this,$priv_key)=@_;if (@_==2){if ($priv_key =~ m/^(?:0x)?([A-F0-9]+)$/i){$this->{_priv_key}=pack 'H*',length($1)% 2 ? '0'.$1 : $1;if (!defined$this->_priv_key_validate()){return$this->_error()}}else {return$this->_error('The privKey "%s" is expected in hexadecimal format',$priv_key)}}return$this->{_priv_key}}sub _priv_password {my ($this,$priv_password)=@_;if (@_==2){if ($priv_password eq q{}){return$this->_error('An empty privacy password was specified')}$this->{_priv_password}=$priv_password}return$this->{_priv_password}}{my$protocols={'(?:cbc-)?des',PRIV_PROTOCOL_DES,quotemeta PRIV_PROTOCOL_DES,PRIV_PROTOCOL_DES,'(?:cbc-)?(?:3|triple-)des(?:-?ede)?',PRIV_PROTOCOL_DRAFT_3DESEDE,quotemeta PRIV_PROTOCOL_DRAFT_3DESEDE,PRIV_PROTOCOL_DRAFT_3DESEDE,'(?:(?:cfb)?128-?)?aes(?:-?128)?',PRIV_PROTOCOL_AESCFB128,quotemeta PRIV_PROTOCOL_AESCFB128,PRIV_PROTOCOL_AESCFB128,quotemeta PRIV_PROTOCOL_DRAFT_AESCFB128,PRIV_PROTOCOL_AESCFB128,'(?:(?:cfb)?192-?)aes(?:-?128)?',PRIV_PROTOCOL_DRAFT_AESCFB192,quotemeta PRIV_PROTOCOL_DRAFT_AESCFB192,PRIV_PROTOCOL_DRAFT_AESCFB192,'(?:(?:cfb)?256-?)aes(?:-?128)?',PRIV_PROTOCOL_DRAFT_AESCFB256,quotemeta PRIV_PROTOCOL_DRAFT_AESCFB256,PRIV_PROTOCOL_DRAFT_AESCFB256,};sub _priv_protocol {my ($this,$proto)=@_;if (@_ < 2){return$this->{_priv_protocol}}if ($proto eq q{}){return$this->_error('An empty privProtocol was specified')}my$priv_proto;for (keys %{$protocols}){if ($proto =~ /^$_$/i){$priv_proto=$protocols->{$_};last}}if (!defined$priv_proto){return$this->_error('The privProtocol "%s" is unknown',$proto)}if (($priv_proto eq PRIV_PROTOCOL_AESCFB128)|| ($priv_proto eq PRIV_PROTOCOL_DRAFT_AESCFB192)|| ($priv_proto eq PRIV_PROTOCOL_DRAFT_AESCFB256)){if (defined (my$error=load_module('Crypt::Rijndael'))){return$this->_error('Support for privProtocol "%s" is unavailable %s',$proto,$error)}}return$this->{_priv_protocol}=$priv_proto}}sub _engine_boots {return ($_[0]->{_synchronized})? $_[0]->{_engine_boots}: 0}sub _engine_time {my ($this)=@_;return 0 if (!$this->{_synchronized});$this->{_engine_time}=time()- $this->{_time_epoc};if ($this->{_engine_time}> 2147483647){DEBUG_INFO('snmpEngineTime rollover');if (++$this->{_engine_boots}==2147483647){die 'FATAL: Unable to handle snmpEngineBoots value'}$this->{_engine_time}-= 2147483647;$this->{_time_epoc}=time()- $this->{_engine_time};if (!$this->{_authoritative}){$this->{_synchronized}=FALSE;return$this->{_latest_engine_time}=0}}if ($this->{_engine_time}< 0){die 'FATAL: Unable to handle negative snmpEngineTime value'}return$this->{_engine_time}}sub _security_params {my ($this)=@_;$this->_error_clear();if ($this->{_user_name}eq q{}){return$this->_error('The required userName was not specified')}if ((defined$this->{_auth_password})&& ($this->{_discovered})){if (!defined$this->{_auth_key}){return$this->_error()if!defined$this->_auth_key_generate()}$this->{_auth_password}=undef}if (defined$this->{_auth_key}){if (!defined$this->_auth_key_validate()){return$this->_error('The authKey is invalid')}if (!defined$this->_auth_data_init()){return$this->_error('Failed to initialize the authentication data')}if ($this->{_discovered}){$this->{_security_level}=SECURITY_LEVEL_AUTHNOPRIV}}if (!defined ($this->{_auth_key})&&!defined$this->{_auth_password}){if (defined ($this->{_priv_key})|| defined$this->{_priv_password}){return$this->_error('The securityLevel is unsupported (privacy requires authentication)')}}if ((defined$this->{_priv_password})&& ($this->{_discovered})){if (!defined$this->{_priv_key}){return$this->_error()if!defined$this->_priv_key_generate()}$this->{_priv_password}=undef}if (defined$this->{_priv_key}){if (!defined$this->_priv_key_validate()){return$this->_error('The privKey is invalid')}if (!defined$this->_priv_data_init()){return$this->_error('Failed to initialize the privacy data')}if ($this->{_discovered}){$this->{_security_level}=SECURITY_LEVEL_AUTHPRIV}}DEBUG_INFO('securityLevel = %d',$this->{_security_level});return$this->{_security_level}}sub _engine_id_discovery {my ($this,$engine_id)=@_;return TRUE if ($this->{_authoritative});DEBUG_INFO('engineID = 0x%s',unpack 'H*',$engine_id || q{});if (length($engine_id)< 5 || length($engine_id)> 32){return$this->_error('The msgAuthoritativeEngineID length of %d is out of range (5..32)',length$engine_id)}$this->{_engine_id}=$engine_id;$this->{_discovered}=TRUE;if (!defined$this->_security_params()){$this->{_discovered}=FALSE;return$this->_error()}return TRUE}sub _synchronize {my ($this,$msg_boots,$msg_time)=@_;return TRUE if ($this->{_authoritative});return TRUE if ($this->{_security_level}< SECURITY_LEVEL_AUTHNOPRIV);if (($msg_boots > $this->_engine_boots())|| (($msg_boots==$this->_engine_boots())&& ($msg_time > $this->{_latest_engine_time}))){DEBUG_INFO('update: engineBoots = %d, engineTime = %d',$msg_boots,$msg_time);$this->{_engine_boots}=$msg_boots;$this->{_latest_engine_time}=$this->{_engine_time}=$msg_time;$this->{_time_epoc}=time()- $this->{_engine_time};if (!$this->{_synchronized}){$this->{_synchronized}=TRUE;if (!defined$this->_security_params()){return ($this->{_synchronized}=FALSE)}}return TRUE}DEBUG_INFO('no update: engineBoots = %d, msgBoots = %d; ' .'latestTime = %d, msgTime = %d',$this->_engine_boots(),$msg_boots,$this->{_latest_engine_time},$msg_time);return TRUE}sub _timeliness {my ($this,$msg_boots,$msg_time)=@_;return TRUE if ($this->{_security_level}< SECURITY_LEVEL_AUTHNOPRIV);my$engine_time=$this->_engine_time();my$engine_boots=$this->_engine_boots();if ($engine_boots==2147483647){$this->{_synchronized}=FALSE;return$this->_error('The system is not in the time window')}if (!$this->{_authoritative}){if ($msg_boots < $engine_boots){return$this->_error('The message is not in the time window')}if (($msg_boots==$engine_boots)&& ($msg_time < ($engine_time - 150))){return$this->_error('The message is not in the time window')}}else {if ($msg_boots!=$engine_boots){return$this->_error('The message is not in the time window')}if (($msg_time < ($engine_time - 150))|| ($msg_time > ($engine_time + 150))){return$this->_error('The message is not in the time window')}}return TRUE}sub _authenticate_outgoing_msg {my ($this,$msg,$auth_location)=@_;if (!$auth_location){return$this->_error('Authentication failure (Unable to set msgAuthenticationParameters)')}substr ${$msg->reference},-$auth_location,12,$this->_auth_hmac($msg);return TRUE}sub _authenticate_incoming_msg {my ($this,$msg,$auth_params)=@_;if ($auth_params ne $this->_auth_hmac($msg)){return$this->_error('Authentication failure')}DEBUG_INFO('authentication passed');return TRUE}sub _auth_hmac {my ($this,$msg)=@_;return q{} if (!defined($this->{_auth_data})||!defined$msg);return substr $this->{_auth_data}->reset()->add(${$msg->reference()})->digest(),0,12}sub _auth_data_init {my ($this)=@_;if (!defined$this->{_auth_key}){return$this->_error('The required authKey is not defined')}return TRUE if defined$this->{_auth_data};if ($this->{_auth_protocol}eq AUTH_PROTOCOL_HMACMD5){$this->{_auth_data}=Digest::HMAC->new($this->{_auth_key},'Digest::MD5')}elsif ($this->{_auth_protocol}eq AUTH_PROTOCOL_HMACSHA){$this->{_auth_data}=Digest::HMAC->new($this->{_auth_key},'Digest::SHA1')}else {return$this->_error('The authProtocol "%s" is unknown',$this->{_auth_protocol})}return TRUE}{my$encrypt={PRIV_PROTOCOL_DES,\&_priv_encrypt_des,PRIV_PROTOCOL_DRAFT_3DESEDE,\&_priv_encrypt_3desede,PRIV_PROTOCOL_AESCFB128,\&_priv_encrypt_aescfbxxx,PRIV_PROTOCOL_DRAFT_AESCFB192,\&_priv_encrypt_aescfbxxx,PRIV_PROTOCOL_DRAFT_AESCFB256,\&_priv_encrypt_aescfbxxx };sub _encrypt_data {if (!exists$encrypt->{$_[0]->{_priv_protocol}}){return $_[0]->_error('Encryption error (Unknown protocol)')}if (!defined $_[1]->prepare(OCTET_STRING,$_[0]->${\$encrypt->{$_[0]->{_priv_protocol}}}($_[2],$_[3]))){return $_[0]->_error('Encryption error')}return $_[3]=$_[1]->clear()}}{my$decrypt={PRIV_PROTOCOL_DES,\&_priv_decrypt_des,PRIV_PROTOCOL_DRAFT_3DESEDE,\&_priv_decrypt_3desede,PRIV_PROTOCOL_AESCFB128,\&_priv_decrypt_aescfbxxx,PRIV_PROTOCOL_DRAFT_AESCFB192,\&_priv_decrypt_aescfbxxx,PRIV_PROTOCOL_DRAFT_AESCFB256,\&_priv_decrypt_aescfbxxx };sub _decrypt_data {if (!defined $_[3]){return $_[0]->_error($_[1]->error()|| 'Decryption error (No data)')}if (!exists$decrypt->{$_[0]->{_priv_protocol}}){return $_[0]->_error('Decryption error (Unknown protocol)')}$_[1]->clear();if (!defined $_[1]->prepend($_[0]->${\$decrypt->{$_[0]->{_priv_protocol}}}($_[2],$_[3]))){return $_[0]->_error($_[1]->error())}return $_[0]->_error($_[1]->error())if (!$_[1]->length());my$msglen=$_[1]->process(SEQUENCE);if ((!defined$msglen)|| ($msglen > $_[1]->length())){return $_[0]->_error('Decryption error')}$_[1]->index(0);DEBUG_INFO('privacy passed');return TRUE}}sub _priv_data_init {my ($this)=@_;if (!defined$this->{_priv_key}){return$this->_error('The required privKey is not defined')}return TRUE if defined$this->{_priv_data};my$init={PRIV_PROTOCOL_DES,\&_priv_data_init_des,PRIV_PROTOCOL_DRAFT_3DESEDE,\&_priv_data_init_3desede,PRIV_PROTOCOL_AESCFB128,\&_priv_data_init_aescfbxxx,PRIV_PROTOCOL_DRAFT_AESCFB192,\&_priv_data_init_aescfbxxx,PRIV_PROTOCOL_DRAFT_AESCFB256,\&_priv_data_init_aescfbxxx };if (!exists$init->{$this->{_priv_protocol}}){return$this->_error('The privProtocol "%s" is unknown',$this->{_priv_protocol})}return$this->${\$init->{$this->{_priv_protocol}}}()}sub _priv_data_init_des {my ($this)=@_;if (!defined$this->{_priv_key}){return$this->_error('The required privKey is not defined')}$this->{_priv_data}->{des}=Crypt::DES->new(substr$this->{_priv_key},0,8);$this->{_priv_data}->{pre_iv}=substr$this->{_priv_key},8,8;$this->{_priv_data}->{salt}=int rand ~0;return TRUE}sub _priv_encrypt_des {if (!defined $_[0]->{_priv_data}){return $_[0]->_error('The required privacy data is not defined')}my$pad=8 - (length($_[2])% 8);$_[2].= pack('C',$pad)x $pad;if ($_[0]->{_priv_data}->{salt}++==~0){$_[0]->{_priv_data}->{salt}=0}$_[1]=pack 'NN',$_[0]->{_engine_boots},$_[0]->{_priv_data}->{salt};my$iv=$_[0]->{_priv_data}->{pre_iv}^ $_[1];my$cipher=q{};while ($_[2]=~ /(.{8})/gs){$cipher .= $iv=$_[0]->{_priv_data}->{des}->encrypt($1 ^ $iv)}return$cipher}sub _priv_decrypt_des {if (!defined $_[0]->{_priv_data}){return $_[0]->_error('The required privacy data is not defined')}if (length($_[1])!=8){return $_[0]->_error('The msgPrivParameters length of %d is invalid',length $_[1])}if (length($_[2])% 8){return $_[0]->_error('The DES cipher length is not a multiple of the block size')}my$iv=$_[0]->{_priv_data}->{pre_iv}^ $_[1];my$plain=q{};while ($_[2]=~ /(.{8})/gs){$plain .= $iv ^ $_[0]->{_priv_data}->{des}->decrypt($1);$iv=$1}return$plain}sub _priv_data_init_3desede {my ($this)=@_;if (!defined$this->{_priv_key}){return$this->_error('The required privKey is not defined')}$this->{_priv_data}->{des1}=Crypt::DES->new(substr$this->{_priv_key},0,8);$this->{_priv_data}->{des2}=Crypt::DES->new(substr$this->{_priv_key},8,8);$this->{_priv_data}->{des3}=Crypt::DES->new(substr$this->{_priv_key},16,8);$this->{_priv_data}->{pre_iv}=substr$this->{_priv_key},24,8;$this->{_priv_data}->{salt}=int rand ~0;if ($this->{_auth_protocol}eq AUTH_PROTOCOL_HMACMD5){$this->{_priv_data}->{hash}=Digest::MD5->new()}elsif ($this->{_auth_protocol}eq AUTH_PROTOCOL_HMACSHA){$this->{_priv_data}->{hash}=Digest::SHA1->new()}return TRUE}sub _priv_encrypt_3desede {if (!defined $_[0]->{_priv_data}){return $_[0]->_error('The required privacy data is not defined')}my$pad=8 - (length($_[2])% 8);$_[2].= pack('C',$pad)x $pad;if ($_[0]->{_priv_data}->{salt}++==~0){$_[0]->{_priv_data}->{salt}=0}$_[1]=pack 'NN',$_[0]->{_engine_boots},$_[0]->{_priv_data}->{salt};if (exists $_[0]->{_priv_data}->{hash}){$_[1]=substr $_[0]->{_priv_data}->{hash}->add($_[1])->digest(),0,8}my$iv=$_[0]->{_priv_data}->{pre_iv}^ $_[1];my$cipher=q{};while ($_[2]=~ /(.{8})/gs){$cipher .= $iv=$_[0]->{_priv_data}->{des3}->encrypt($_[0]->{_priv_data}->{des2}->decrypt($_[0]->{_priv_data}->{des1}->encrypt($1 ^ $iv)))}return$cipher}sub _priv_decrypt_3desede {if (!defined $_[0]->{_priv_data}){return $_[0]->_error('The required privacy data is not defined')}if (length($_[1])!=8){return $_[0]->_error('The msgPrivParameters length of %d is invalid',length $_[1])}if (length($_[2])% 8){return $_[0]->_error('The CBC-3DES-EDE cipher length is not a multiple of the block size')}my$iv=$_[0]->{_priv_data}->{pre_iv}^ $_[1];my$plain=q{};while ($_[2]=~ /(.{8})/gs){$plain .= $iv ^ $_[0]->{_priv_data}->{des1}->decrypt($_[0]->{_priv_data}->{des2}->encrypt($_[0]->{_priv_data}->{des3}->decrypt($1)));$iv=$1}return$plain}sub _priv_data_init_aescfbxxx {my ($this)=@_;if (!defined$this->{_priv_key}){return$this->_error('The required privKey is not defined')}{no strict 'subs';$this->{_priv_data}->{aes}=Crypt::Rijndael->new($this->{_priv_key},Crypt::Rijndael::MODE_CFB())}$this->{_priv_data}->{salt1}=int rand ~0;$this->{_priv_data}->{salt2}=int rand ~0;return TRUE}sub _priv_encrypt_aescfbxxx {if (!defined $_[0]->{_priv_data}){return $_[0]->_error('The required privacy data is not defined')}my$length=length $_[2];if ($length <= 16){return $_[0]->_error('The AES plain text length is not greater than the block size')}if ($_[0]->{_priv_data}->{salt1}++==~0){$_[0]->{_priv_data}->{salt1}=0;if ($_[0]->{_priv_data}->{salt2}++==~0){$_[0]->{_priv_data}->{salt2}=0}}$_[1]=pack 'NN',$_[0]->{_priv_data}->{salt2},$_[0]->{_priv_data}->{salt1};$_[2].= "\000" x (16 - ($length % 16));$_[0]->{_priv_data}->{aes}->set_iv(pack('NN',$_[0]->{_engine_boots},$_[0]->{_engine_time}).$_[1]);return substr $_[0]->{_priv_data}->{aes}->encrypt($_[2]),0,$length}sub _priv_decrypt_aescfbxxx {if (!defined $_[0]->{_priv_data}){return $_[0]->_error('The required privacy data is not defined')}if (length($_[1])!=16){return $_[0]->_error('The AES IV length of %d is invalid',length $_[1])}my$length=length $_[2];if ($length <= 16){return $_[0]->_error('The AES cipher length is not greater than the block size')}$_[2].= "\000" x (16 - ($length % 16));$_[0]->{_priv_data}->{aes}->set_iv($_[1]);return substr $_[0]->{_priv_data}->{aes}->decrypt($_[2]),0,$length}sub _auth_key_generate {my ($this)=@_;if (!defined($this->{_engine_id})||!defined$this->{_auth_password}){return$this->_error('Unable to generate the authKey')}$this->{_auth_key}=$this->_password_localize($this->{_auth_password});return$this->{_auth_key}}sub _auth_key_validate {my ($this)=@_;my$key_len={AUTH_PROTOCOL_HMACMD5,[16,'HMAC-MD5' ],AUTH_PROTOCOL_HMACSHA,[20,'HMAC-SHA1' ],};if (!exists$key_len->{$this->{_auth_protocol}}){return$this->_error('The authProtocol "%s" is unknown',$this->{_auth_protocol})}if (length($this->{_auth_key})!=$key_len->{$this->{_auth_protocol}}->[0]){return$this->_error('The %s authKey length of %d is invalid, expected %d',$key_len->{$this->{_auth_protocol}}->[1],length($this->{_auth_key}),$key_len->{$this->{_auth_protocol}}->[0])}return TRUE}sub _priv_key_generate {my ($this)=@_;if (!defined($this->{_engine_id})||!defined$this->{_priv_password}){return$this->_error('Unable to generate the privKey')}$this->{_priv_key}=$this->_password_localize($this->{_priv_password});return$this->_error()if!defined$this->{_priv_key};if ($this->{_priv_protocol}eq PRIV_PROTOCOL_DRAFT_3DESEDE){$this->{_priv_key}.= $this->_password_localize($this->{_priv_key})}elsif (($this->{_priv_protocol}eq PRIV_PROTOCOL_DRAFT_AESCFB192)|| ($this->{_priv_protocol}eq PRIV_PROTOCOL_DRAFT_AESCFB256)){my$hnnn;if ($this->{_auth_protocol}eq AUTH_PROTOCOL_HMACMD5){$hnnn=Digest::MD5->new()}elsif ($this->{_auth_protocol}eq AUTH_PROTOCOL_HMACSHA){$hnnn=Digest::SHA1->new()}else {return$this->_error('The authProtocol "%s" is unknown',$this->{_auth_protocol})}$this->{_priv_key}.= $hnnn->add($this->{_priv_key})->digest()}my$key_len={PRIV_PROTOCOL_DES,16,PRIV_PROTOCOL_DRAFT_3DESEDE,32,PRIV_PROTOCOL_AESCFB128,16,PRIV_PROTOCOL_DRAFT_AESCFB192,24,PRIV_PROTOCOL_DRAFT_AESCFB256,32 };if (!exists$key_len->{$this->{_priv_protocol}}){return$this->_error('The privProtocol "%s" is unknown',$this->{_priv_protocol})}$this->{_priv_key}=substr$this->{_priv_key},0,$key_len->{$this->{_priv_protocol}};return$this->{_priv_key}}sub _priv_key_validate {my ($this)=@_;my$key_len={PRIV_PROTOCOL_DES,[16,'CBC-DES' ],PRIV_PROTOCOL_DRAFT_3DESEDE,[32,'CBC-3DES-EDE' ],PRIV_PROTOCOL_AESCFB128,[16,'CFB128-AES-128' ],PRIV_PROTOCOL_DRAFT_AESCFB192,[24,'CFB128-AES-192' ],PRIV_PROTOCOL_DRAFT_AESCFB256,[32,'CFB128-AES-256' ]};if (!exists$key_len->{$this->{_priv_protocol}}){return$this->_error('The privProtocol "%s" is unknown',$this->{_priv_protocol})}if (length($this->{_priv_key})!=$key_len->{$this->{_priv_protocol}}->[0]){return$this->_error('The %s privKey length of %d is invalid, expected %d',$key_len->{$this->{_priv_protocol}}->[1],length($this->{_priv_key}),$key_len->{$this->{_priv_protocol}}->[0])}if ($this->{_priv_protocol}eq PRIV_PROTOCOL_DRAFT_3DESEDE){if (substr($this->{_priv_key},0,8)eq substr$this->{_priv_key},8,8){return$this->_error('The CBC-3DES-EDE privKey is invalid (K1 equals K2)')}if (substr($this->{_priv_key},8,8)eq substr$this->{_priv_key},16,8){return$this->_error('The CBC-3DES-EDE privKey is invalid (K2 equals K3)')}if (substr($this->{_priv_key},0,8)eq substr$this->{_priv_key},16,8){return$this->_error('The CBC-3DES-EDE privKey is invalid (K1 equals K3)')}}return TRUE}sub _password_localize {my ($this,$password)=@_;my$digests={AUTH_PROTOCOL_HMACMD5,'Digest::MD5',AUTH_PROTOCOL_HMACSHA,'Digest::SHA1',};if (!exists$digests->{$this->{_auth_protocol}}){return$this->_error('The authProtocol "%s" is unknown',$this->{_auth_protocol})}my$digest=$digests->{$this->{_auth_protocol}}->new;my$d=my$pad=$password x ((2048 / length$password)+ 1);for (my$count=0;$count < 2**20;$count += 2048){$digest->add(substr$d,0,2048,q{});$d .= $pad}$d=$digest->digest;return$digest->add($d .$this->{_engine_id}.$d)->digest()}{my%modules;sub load_module {my ($module)=@_;return$modules{$module}if exists$modules{$module};if (!eval "require $module"){if ($@ =~ /locate (\S+\.pm)/){$modules{$module}=sprintf '(Required module %s not found)',$1}else {$modules{$module}=sprintf '(%s)',$@}}else {$modules{$module}=undef}return$modules{$module}}}1;