package Net::SNMP::Transport::IPv4::TCP;use strict;use Net::SNMP::Transport qw(MSG_SIZE_MAXIMUM DOMAIN_TCPIPV4 TRUE FALSE DEBUG_INFO);use Net::SNMP::Message qw(SEQUENCE);use IO::Socket qw(SOCK_STREAM);our$VERSION=v3.0.0;use base qw(Net::SNMP::Transport::IPv4 Net::SNMP::Transport);sub import {return Net::SNMP::Transport->export_to_level(1,@_)}sub MSG_SIZE_DEFAULT_TCP4 {1460}sub new {my ($this,$error)=shift->SUPER::_new(@_);if (defined$this){if (!defined$this->_reasm_init()){return wantarray ? (undef,$this->error()): undef}}return wantarray ? ($this,$error): $this}sub accept {my ($this)=@_;$this->_error_clear();my$socket=$this->{_socket}->accept();if (!defined$socket){return$this->_perror('Failed to accept the connection')}DEBUG_INFO('opened %s socket [%d]',$this->type(),$socket->fileno());my$new=bless {%{$this}},ref$this;$new->{_socket}=$socket;$new->{_dest_name}=$socket->peername();$new->{_dest_hostname}=$new->sock_address();if (!defined$new->_reasm_init()){return$this->_error($new->error())}return$new}sub send {my$this=shift;$this->_error_clear();if (length($_[0])> $this->{_max_msg_size}){return$this->_error('The message size %d exceeds the maxMsgSize %d',length($_[0]),$this->{_max_msg_size})}if (!defined$this->{_socket}->connected()){return$this->_error(q{Not connected to the remote host '%s'},$this->dest_hostname())}my$bytes=$this->{_socket}->send($_[0],0);return defined($bytes)? $bytes : $this->_perror('Send failure')}sub recv {my$this=shift;$this->_error_clear();if (!defined$this->{_socket}->connected()){$this->_reasm_reset();return$this->_error(q{Not connected to the remote host '%s'},$this->dest_hostname())}my$name;if ($this->{_reasm_buffer}eq q{}){if (!defined$this->{_reasm_object}){return$this->_error('The reassembly object is not defined')}$name=$this->{_socket}->recv($this->{_reasm_buffer},6,0);if ((!defined$name)|| ($!)){$this->_reasm_reset();return$this->_perror('Receive failure')}elsif (!length$this->{_reasm_buffer}){$this->_reasm_reset();return$this->_error(q{The connection was closed by the remote host '%s'},$this->dest_hostname())}$this->{_reasm_object}->append($this->{_reasm_buffer});$this->{_reasm_length}=$this->{_reasm_object}->process(SEQUENCE)|| 0;if ((!$this->{_reasm_length})|| ($this->{_reasm_length}> MSG_SIZE_MAXIMUM)){$this->_reasm_reset();return$this->_error(q{Message framing was lost with the remote host '%s'},$this->dest_hostname())}$this->{_reasm_length}+= $this->{_reasm_object}->index()}my$buf=q{};my$buf_len=length$this->{_reasm_buffer};$name=$this->{_socket}->recv($buf,($this->{_reasm_length}- $buf_len),0);if ((!defined$name)|| ($!)){$this->_reasm_reset();return$this->_perror('Receive failure')}elsif (!length$buf){$this->_reasm_reset();return$this->_error(q{The connection was closed by the remote host '%s'},$this->dest_hostname())}$buf_len += length$buf;$this->{_reasm_buffer}.= $buf;if ($buf_len < $this->{_reasm_length}){DEBUG_INFO('message is incomplete (expect %u bytes, have %u bytes)',$this->{_reasm_length},$buf_len);$_[0]=q{};return$name || $this->{_socket}->connected()}if ($buf_len > $this->{_max_msg_size}){$this->_reasm_reset();return$this->_error('Incoming message size %d exceeded the maxMsgSize %d',$buf_len,$this->{_max_msg_size})}$_[0]=$this->{_reasm_buffer};$this->_reasm_reset();return$name || $this->{_socket}->connected()}sub connectionless {return FALSE}sub domain {return DOMAIN_TCPIPV4}sub type {return 'TCP/IPv4'}sub agent_addr {return shift->sock_address()}sub _protocol_name {return 'tcp'}sub _protocol_type {return SOCK_STREAM}sub _msg_size_default {return MSG_SIZE_DEFAULT_TCP4}sub _reasm_init {my ($this)=@_;my$error;($this->{_reasm_object},$error)=Net::SNMP::Message->new();if (!defined$this->{_reasm_object}){return$this->_error('Failed to create the reassembly object: %s',$error)}$this->_reasm_reset();return TRUE}sub _reasm_reset {my ($this)=@_;if (defined$this->{_reasm_object}){$this->{_reasm_object}->error(undef);$this->{_reasm_object}->clear()}$this->{_reasm_buffer}=q{};$this->{_reasm_length}=0;return TRUE}sub _tdomain {return DOMAIN_TCPIPV4}1;