package Ocsinventory::Agent::Backend::OS::Solaris::Memory;use strict;sub check {my$params=shift;my$common=$params->{common};$common->can_run ("memconf")}sub run {my$model;my$params=shift;my$common=$params->{common};my$logger=$params->{logger};my$capacity;my$description;my$numslots;my$speed=undef;my$type=undef;my$banksize;my$module_count=0;my$empty_slots;my$flag=0;my$flag_mt=0;my$caption;my$sun_class=0;my$OSLevel;my$zone;my$aarch;my$j=0;chomp($OSLevel=`uname -r`);chomp($aarch=`uname -p`);if (!$common->can_run("zonename")|| `zonename` =~ /global/){$zone="global"}else{$zone=""}if ($zone){if ($aarch =~ /sparc/ && $common->can_run("virtinfo")&& `virtinfo -t` =~ /.*LDoms guest.*/){$model="Solaris Ldom"}else{chomp($model=`uname -i`)}}else{$model="Solaris Containers"}if ($model =~ /SUNW,SPARC-Enterprise/){$sun_class=5}if ($model =~ /SUNW,SPARC-Enterprise-T\d/){$sun_class=4}if ($model =~ /SUNW,Netra-T/){$sun_class=2}if ($model =~ /SUNW,Sun-Fire-\d/){$sun_class=1}if ($model =~ /SUNW,Sun-Fire-V/){$sun_class=2}if ($model =~ /SUNW,Sun-Fire-V490/){$sun_class=1}if ($model =~ /SUNW,Sun-Fire-T\d/){$sun_class=3}if ($model =~ /SUNW,SPARCstation/){$sun_class=3}if ($model =~ /SUNW,Ultra-/){$sun_class=3}if ($model =~ /SUNW,Sun-Blade-100/){$sun_class=8}if ($model =~ /SUNW,Sun-Blade-1500/){$sun_class=8}if ($model =~ /SUNW,T\d/){$sun_class=3}if ($model =~ /Solaris Containers/){$sun_class=7}if ($model =~ /Solaris Ldom/){$sun_class=7}if ($model =~ /i86pc/){$sun_class=6}if ($model =~ /sun4v/){$sun_class=3}if($sun_class==0){$logger->debug("sorry, unknown model, could not detect memory configuration")}if($sun_class==1){for(`memconf 2>&1`){if(/^empty \w+:\s(\S+)/){$flag=0;if($1 eq "None"){$empty_slots=0}}if($flag_mt && /^\s*\S+\s+\S+\s+\S+\s+\S+\s+(\S+)/){$flag_mt=0;$description=$1}if ($flag && /^\s*(\S+)\s+(\S+)/){$caption="Board " .$1 ." MemCtl " .$2}if ($flag && /^\s*\S+\s+\S+\s+(\S+)/){$numslots=$1}if ($flag && /^\s*\S+\s+\S+\s+\S+\s+(\d+)/){$banksize=$1}if ($flag && /^\s*\S+\s+\S+\s+\S+\s+\S+\s+\S+\s+(\d+)/){$capacity=$1}if ($flag){for (my$i=1;$i <= ($banksize / $capacity);$i++){$module_count++;$common->addMemory({CAPACITY=>$capacity,DESCRIPTION=>$description,CAPTION=>$caption,SPEED=>$speed,TYPE=>$type,NUMSLOTS=>$numslots })}}if(/^\s+Logical  Logical  Logical/){$flag_mt=1}if(/^-+/){$flag=1}}}if($sun_class==2){for(`memconf 2>&1`){if(/^empty sockets:\s*(\S+)/){$flag=0;substr ($_,0,15)="";$capacity="empty";$numslots=0;for$caption (split){if ($caption eq "None"){$empty_slots=0;last}$empty_slots++;$common->addMemory({CAPACITY=>$capacity,DESCRIPTION=>$description,CAPTION=>$caption,SPEED=>$speed,TYPE=>$type,NUMSLOTS=>$numslots })}}if(/.*Memory Module Groups.*/){$flag=0;$flag_mt=0}if($flag && /^\s*\S+\s+\S+\s+(\S+)/){$caption=$1}if($flag && /^\s*(\S+)/){$numslots=$1}if($flag && /^\s*\S+\s+\S+\s+\S+\s+(\d+)/){$capacity=$1}if($flag){$module_count++;$common->addMemory({CAPACITY=>$capacity,DESCRIPTION=>"DIMM",CAPTION=>"Ram slot ".$numslots,SPEED=>$speed,TYPE=>$type,NUMSLOTS=>$numslots })}if(/^ID       ControllerID/){$flag_mt=1;$description=$1}if($flag_mt && /^-+/){$flag=1}}}if($sun_class==3){for(`memconf 2>&1`){if(/^empty sockets:\s*(\S+)/){substr ($_,0,15)="";$description="";$type="";$capacity="empty";$numslots=0;for$caption (split){if ($caption eq "None"){$empty_slots=0;last}$empty_slots++;$common->addMemory({CAPACITY=>$capacity,DESCRIPTION=>$description,CAPTION=>$caption,SPEED=>$speed,TYPE=>$type,NUMSLOTS=>$numslots })}}if(/^socket\s+(\S+) has a (.+) (\d+)GB (\S+)/){$caption=$1;$description=$2;$type=$4;$numslots=0;$capacity=$3 * 1024;$module_count++;$common->addMemory({CAPACITY=>$capacity,DESCRIPTION=>$description,CAPTION=>$caption,SPEED=>$speed,TYPE=>$type,NUMSLOTS=>$numslots })}if(/^socket\s+(\S+) \(LUN \d+ ID \d+\): (.+) (\d+)MB (\S+) (\S+) DIMM, (\S+)/){$caption=$1;$description="$2 $6";$type="$4 $5";$numslots=0;$capacity=$3;$module_count++;$common->addMemory({CAPACITY=>$capacity,DESCRIPTION=>$description,CAPTION=>$caption,SPEED=>$speed,TYPE=>$type,NUMSLOTS=>$numslots })}}}if($sun_class==4){for(`memconf 2>&1`){if(/^empty sockets:\s*(\S+)/){$flag=0;substr ($_,0,15)="";$capacity="empty";$numslots=0;for$caption (split){if ($caption eq "None"){$empty_slots=0;last}print "Caption: " .$caption ." Description: " .$description ." Bank Number: " .$numslots ." DIMM Capacity: " .$capacity ."MB\n";$empty_slots++;$common->addMemory({CAPACITY=>$capacity,DESCRIPTION=>$description,CAPTION=>$caption,SPEED=>$speed,TYPE=>$type,NUMSLOTS=>$numslots })}}if(/^socket\s+(\S+) has a (.+)\s+(\S+)GB\s+(\S+)$/i){$caption=$1;$description=$2;$type=$4;$numslots=0;$capacity=$3 * 1024;$module_count++;$common->addMemory({CAPACITY=>$capacity,DESCRIPTION=>$description,CAPTION=>$caption,SPEED=>$speed,TYPE=>$type,NUMSLOTS=>$numslots })}}}if ($sun_class==5){for(`memconf 2>&1`){if(/^total memory.*(\S+)/){$flag=0}if($flag_mt && /^\s+\S+\s+\S+\s+\S+\s+(\S+)/){$flag_mt=0;$type=$1}if ($flag && /^\s(\S+)\s+(\S+)/){$numslots="LSB " .$1 ." Group " .$2}if ($flag && /^\s(\S+)\s+(\S+)/){$caption="LSB " .$1 ." Group " .$2}if ($flag && /^\s+\S+\s+\S\s+\S+\s+\S+\s+(\d+)/){$capacity=$1}if ($flag && /^\s+\S+\s+\S\s+(\d+)/){$banksize=$1}if ($flag && $capacity > 1){for (my$i=1;$i <= ($banksize / $capacity);$i++){$common->addMemory({CAPACITY=>$capacity,DESCRIPTION=>$description,CAPTION=>$caption,SPEED=>$speed,TYPE=>$type,NUMSLOTS=>$module_count })}$module_count++}if (/^Sun Microsystems/){$flag_mt=1;$flag=1}}}if($sun_class==6){for(`memconf 2>&1`){if(/^empty memory sockets:\s*(\S+)/){substr ($_,0,22)="";chomp();$capacity="0";$numslots=0;for$caption (split(/, /,$_)){if ($caption eq "None"){$empty_slots=0;last}$empty_slots++;if ($caption =~ /.* (\d+)$/){$numslots=$1}$common->addMemory({CAPACITY=>$capacity,DESCRIPTION=>"empty",CAPTION=>$caption,SPEED=>'n/a',TYPE=>'n/a',NUMSLOTS=>$numslots })}}if(/^(.*DIMM) (\S+):\s+(\d+)MB\s(\S+ DDR\d+)\s*(\w*)?(,?.*)/){$caption="$1 $2";$description="$4 $5$6";$numslots=$2;$capacity=$3;$type=$5;unless ($type){$type="DIMM"};$module_count++;$common->addMemory({CAPACITY=>$capacity,DESCRIPTION=>$description,CAPTION=>$caption,SPEED=>$speed,TYPE=>$type,NUMSLOTS=>$numslots })}if(/^(.*BANK)(\S+):\s+(\d+)MB\s(\S*DDR\d+)\s*(\w+)?(,?.*)/){$caption="$1 $2";$description="$4 $5$6";$numslots=$2;$capacity=$3;$type=$5;$module_count++;$common->addMemory({CAPACITY=>$capacity,DESCRIPTION=>$description,CAPTION=>$caption,SPEED=>$speed,TYPE=>$type,NUMSLOTS=>$numslots })}if(/^(.*DIMM) (\S+):\s+(\d+)MB\s(\S+)\s+(DIMM\w*)(,?.*)/){$caption="$1 $2";$description="$4 $5$6";$numslots=$2;$capacity=$3;$type=$5;$module_count++;$common->addMemory({CAPACITY=>$capacity,DESCRIPTION=>$description,CAPTION=>$caption,SPEED=>$speed,TYPE=>$type,NUMSLOTS=>$numslots })}if(/^(\S+):\s+(\d+)MB\s(.+)\s+(DIMM\w*)(,?.*)/){$caption="$1";$description="$3 $4$5";$numslots=$1;$capacity=$2;$type=$4;$module_count++;$common->addMemory({CAPACITY=>$capacity,DESCRIPTION=>$description,CAPTION=>$caption,SPEED=>$speed,TYPE=>$type,NUMSLOTS=>$numslots })}}}if ($sun_class==7){for (`prctl -n project.max-shm-memory $$ 2>&1`){$description=$1 if /^project.(\S+)$/;$capacity=$1 if /^\s*system+\s*(\d+).*$/;if(($description && $capacity)){$capacity=$capacity * 1024;$numslots=1 ;$description="Memory Allocated";$caption="Memory Share";$common->addMemory({CAPACITY=>$capacity,DESCRIPTION=>$description,CAPTION=>$caption,SPEED=>$speed,TYPE=>$type,NUMSLOTS=>$numslots })}}}if($sun_class==8){for(`memconf 2>&1`){if (/^empty sockets:\s*(.+)/){for$caption (split(/ /,$1)){if ($caption eq "None"){$empty_slots=0;last}$empty_slots++;$common->addMemory({CAPACITY=>"empty",DESCRIPTION=>'',CAPTION=>$caption,SPEED=>'',TYPE=>'',NUMSLOTS=>$numslots })}}if (/^0x(\d+)\s+(\d+)(\S)B\s+(\S+)\s+(.+)/){$caption="$5";$description="";$numslots=0;$capacity=$2 if ($3 eq "M");$capacity=$2 * 1024 if ($3 eq "G");$type="";$module_count++;$common->addMemory({CAPACITY=>$capacity,DESCRIPTION=>$description,CAPTION=>$caption,SPEED=>$speed,TYPE=>$type,NUMSLOTS=>$numslots })}}}}1;