package Ocsinventory::Agent::Common;use strict;no strict 'refs';use warnings;use Encode qw(encode);sub new {my (undef,$params)=@_;my$self={};$self->{logger}=$params->{logger};$self->{config}=$params->{config};$self->{xmltags}={};bless$self}sub addController {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/DESCRIPTION DRIVER NAME MANUFACTURER PCIID PCISLOT TYPE/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{CONTROLLERS}},$content}sub addUsb {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/DESCRIPTION INTERFACE MANUFACTURER SERIAL TYPE/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{USBDEVICES}},$content}sub addInput {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/DESCRIPTION INTERFACE MANUFACTURER SERIAL TYPE/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{INPUTS}},$content}sub addModem {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/DESCRIPTION NAME/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{MODEMS}},$content}sub addModems {my$self=shift;my$logger=$self->{logger};$logger->debug("please rename addModems to addModem()");$self->addModem(@_)}sub addDrive {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/CREATEDATE FREE FILESYSTEM LABEL SERIAL TOTAL TYPE VOLUMN/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{DRIVES}},$content}sub addDrives {my$self=shift;my$logger=$self->{logger};$logger->debug("please rename addDrives to addDrive()");$self->addDrive(@_)}sub addStorages {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/DESCRIPTION DISKSIZE FIRMWARE MANUFACTURER MODEL NAME SERIALNUMBER SCSI_CHID SCSI_COID SCSI_LUN SCSI_UNID TYPE/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{STORAGES}},$content}sub addStorage {my$self=shift;my$logger=$self->{logger};$logger->debug("please rename addStorages to addStorage()");$self->addStorage(@_)}sub addMemory {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/CAPACITY CAPTION DESCRIPTION ERRORCORRECTIONTYPE MANUFACTURER NUMSLOTS SERIALNUMBER SPEED TYPE/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{MEMORIES}},$content}sub addMemories {my$self=shift;my$logger=$self->{logger};$logger->debug("please rename addMemories to addMemory()");$self->addMemory(@_)}sub addPorts{my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/CAPTION DESCRIPTION NAME TYPE/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{PORTS}},$content}sub addPort {my$self=shift;my$logger=$self->{logger};$logger->debug("please rename addPorts to addPort()");$self->addPort(@_)}sub addSlot {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/DESCRIPTION DESIGNATION NAME STATUS/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{SLOTS}},$content}sub addSlots {my$self=shift;my$logger=$self->{logger};$logger->debug("please rename addSlots to addSlot()");$self->addSlot(@_)}sub addSoftware {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/COMMENTS FILESIZE FOLDER FROM INSTALLDATE NAME PUBLISHER VERSION/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{SOFTWARES}},$content}sub addSoftwares {my$self=shift;my$logger=$self->{logger};$logger->debug("please rename addSoftwares to addSoftware()");$self->addSoftware(@_)}sub addMonitor {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/BASE64 CAPTION DESCRIPTION MANUFACTURER SERIAL UUENCODE/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{MONITORS}},$content}sub addMonitors {my$self=shift;my$logger=$self->{logger};$logger->debug("please rename addMonitors to addMonitor()");$self->addMonitor(@_)}sub addVideo {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/CHIPSET DRVVERSION MEMORY NAME PCISLOT PCIID RESOLUTION SPEED UUID VBIOS/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{VIDEOS}},$content}sub addVideos {my$self=shift;my$logger=$self->{logger};$logger->debug("please rename addVideos to addVideo()");$self->addVideo(@_)}sub addSound {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/DESCRIPTION MANUFACTURER NAME/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{SOUNDS}},$content}sub addSounds {my$self=shift;my$logger=$self->{logger};$logger->debug("please rename addSounds to addSound()");$self->addSound(@_)}sub addNetwork {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/BASE BSSID DESCRIPTION DRIVER DUPLEX IPADDRESS IPDHCP IPGATEWAY IPMASK IPSUBNET MACADDR MODE MTU PCISLOT SLAVE SPEED SSID STATUS TYPE VERSION VIRTUALDEV/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{NETWORKS}},$content}sub addNetworks {my$self=shift;my$logger=$self->{logger};$logger->debug("please rename addNetworks to addNetwork()");$self->addNetwork(@_)}sub addRepo {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/BASEURL ENABLED FINGERPRINTS FILENAME MIRROR NAME PACKAGES PRIORITY REVISION SIGNATURE SIZE TAG UPDATED/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{REPOSITORY}},$content}sub addRepos {my$self=shift;my$logger=$self->{logger};$logger->debug("please rename addRepos to addRepo()");$self->addRepo(@_)}sub setHardware {my ($self,$args,$nonDeprecated)=@_;my$xmltags=$self->{xmltags};my$logger=$self->{logger};for my$key (qw/USERID OSVERSION PROCESSORN OSCOMMENTS CHECKSUM PROCESSORT NAME PROCESSORS SWAP ETIME TYPE OSNAME IPADDR WORKGROUP DESCRIPTION MEMORY UUID DNS LASTLOGGEDUSER DATELASTLOGGEDUSER DEFAULTGATEWAY VMSYSTEM/){if (exists$args->{$key}){if ($key eq 'PROCESSORS' &&!$nonDeprecated){$logger->debug("PROCESSORN, PROCESSORS and PROCESSORT shouldn't be set directly anymore. Please use addCPU() method instead.")}if ($key eq 'USERID' &&!$nonDeprecated){$logger->debug("USERID shouldn't be set directly anymore. Please use addUser() method instead.")}$xmltags->{'HARDWARE'}{$key}[0]=$args->{$key}}}}sub setBios {my ($self,$args)=@_;my$xmltags=$self->{xmltags};for my$key (qw/SMODEL SMANUFACTURER SSN BDATE BVERSION BMANUFACTURER MMANUFACTURER MSN MMODEL ASSETTAG TYPE/){if (exists$args->{$key}){$xmltags->{'BIOS'}{$key}[0]=$args->{$key}}}}sub addCPU {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/CORES CPUARCH CPUSTATUS CURRENT_SPEED DATA_WIDTH HPT L2CACHESIZE LOGICAL_CPUS MANUFACTURER NBSOCKET SERIALNUMBER SOCKET SPEED THREADS TYPE VOLTAGE LOGICAL_CPUS/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{CPUS}},$content;my$processorn=int @{$xmltags->{CPUS}};my$processors=$xmltags->{CPUS}[0]{SPEED}[0];my$processort=$xmltags->{CPUS}[0]{TYPE}[0];$self->setHardware ({PROCESSORN=>$processorn,PROCESSORS=>$processors,PROCESSORT=>$processort,},1)}sub addUser {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$login=$args->{LOGIN};return unless$login;for my$user (@{$xmltags->{USERS}}){return if$user->{LOGIN}[0]eq $login}push @{$xmltags->{USERS}},{LOGIN=>[$login]};my$userString=$xmltags->{HARDWARE}->{USERID}[0]|| "";$userString .= '/' if$userString;$userString .= $login;$self->setHardware ({USERID=>$userString,},1)}sub addPrinter {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/DESCRIPTION DRIVER NAME PORT/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{PRINTERS}},$content}sub addPrinters {my$self=shift;my$logger=$self->{logger};$logger->debug("please rename addPrinters to addPrinter()");$self->addPrinter(@_)}sub addBatteries {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/CHEMISTRY DESIGNCAPACITY DESIGNVOLTAGE LOCATION MANUFACTURER MANUFACTUREDATE MAXERROR NAME OEMSPECIFIC SBDSVERSION SERIALNUMBER/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{BATTERIES}},$content}sub addVirtualMachine {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/CORES IPADDR MEMORY NAME UUID STATUS SUBSYSTEM VMTYPE VCPU VMID/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{VIRTUALMACHINES}},$content}sub addProcess {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/COMMANDLINE CPUUSAGE PROCESSMEMORY PROCESSID STARTED TTY USERNAME VIRTUALMEMORY/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{RUNNING_PROCESSES}},$content}sub addCamera {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/MODEL UUID/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}if$args->{$key}}}push @{$xmltags->{RUNNING_PROCESSES}},$content}sub addIpDiscoverEntry {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$ipaddress=$args->{IPADDRESS};my$macaddr=$args->{MACADDR};my$name=$args->{NAME};if (!$xmltags->{IPDISCOVER}{H}){$xmltags->{IPDISCOVER}{H}=[]}push @{$xmltags->{IPDISCOVER}{H}},{I=>[$ipaddress?$ipaddress:""],M=>[$macaddr?$macaddr:""],N=>[$name?$name:"-"],}}sub setAccessLog {my ($self,$args)=@_;for my$key (qw/USERID LOGDATE/){if (exists$args->{$key}){$self->{xmlroot}{'CONTENT'}{'ACCESSLOG'}{$key}[0]=$args->{$key}}}}sub flushXMLTags {my$self=shift;$self->{xmltags}={}}sub getSnmpTable {my ($self,$snmp_table,$baseoid,$snmp_infos)=@_;my$results={};for my$oid (keys %$snmp_table){if ($oid =~ /$baseoid\.\d+\.\d+\.(\S+)/){my$reference=$1;for my$value (keys %$snmp_infos){if ($oid =~ /$snmp_infos->{$value}\.$reference/){$results->{$reference}->{$value}=$snmp_table->{$oid}}}}}return$results}sub setSnmpCommons {my ($self,$args)=@_;my$xmltags=$self->{xmltags};for my$key (qw/IPADDR MACADDR SNMPDEVICEID NAME DESCRIPTION CONTACT LOCATION UPTIME DOMAIN TYPE/){if (exists$args->{$key}){$xmltags->{COMMON}[0]{$key}[0]=$args->{$key}}}}sub setSnmpPrinter {my ($self,$args)=@_;my$xmltags=$self->{xmltags};for my$key (qw/NAME SERIALNUMBER COUNTER STATUS ERRORSTATE/){if (exists$args->{$key}){$xmltags->{PRINTERS}[0]{$key}[0]=$args->{$key}}}}sub setSnmpSwitchInfos {my ($self,$args)=@_;my$xmltags=$self->{xmltags};for my$key (qw/TYPE/){if (exists$args->{$key}){$xmltags->{SWITCHINFOS}[0]{$key}[0]=$args->{$key}}}}sub setSnmpFirewalls {my ($self,$args)=@_;my$xmltags=$self->{xmltags};for my$key (qw/SERIALNUMBER SYSTEM/){if (exists$args->{$key}){$xmltags->{FIREWALLS}[0]{$key}[0]=$args->{$key}}}}sub setSnmpLoadBalancer {my ($self,$args)=@_;my$xmltags=$self->{xmltags};for my$key (qw/SERIALNUMBER SYSTEM MANUFACTURER TYPE/){if (exists$args->{$key}){$xmltags->{LOADBALANCERS}[0]{$key}[0]=$args->{$key}}}}sub setSnmpBlade {my ($self,$args)=@_;my$xmltags=$self->{xmltags};for my$key (qw/SERIALNUMBER SYSTEM/){if (exists$args->{$key}){$xmltags->{BLADES}[0]{$key}[0]=$args->{$key}}}}sub setSnmpComputer {my ($self,$args)=@_;my$xmltags=$self->{xmltags};for my$key (qw/SYSTEM/){if (exists$args->{$key}){$xmltags->{COMPUTERS}[0]{$key}[0]=$args->{$key}}}}sub addSnmpPrinterCartridge {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/DESCRIPTION TYPE LEVEL MAXCAPACITY COLOR/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}}}push @{$xmltags->{CARTRIDGES}},$content}sub addSnmpPrinterTray {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/NAME DESCRIPTION LEVEL MAXCAPACITY/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}}}push @{$xmltags->{TRAYS}},$content}sub addSnmpNetwork {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/DESCRIPTION MACADDR DEVICEMACADDR SLOT STATUS SPEED TYPE DEVICEADDRESS DEVICENAME DEVICEPORT DEVICETYPE TYPEMIB IPADDR IPMASK IPGATEWAY IPSUBNET IPDHCP DRIVER VIRTUALDEV/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}}}push @{$xmltags->{NETWORKS}},$content}sub addSnmpBackPlane {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/DESCRIPTION FIRMWARE MANUFACTURER REFERENCE SERIALNUMBER TYPE/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}}}push @{$xmltags->{BACKPLANE}},$content}sub addSnmpCard {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/DESCRIPTION REFERENCE FIRMWARE SOFTWARE REVISION SERIALNUMBER MANUFACTURER TYPE/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}}}push @{$xmltags->{CARDS}},$content}sub addSnmpFan {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/DESCRIPTION REFERENCE REVISION SERIALNUMBER MANUFACTURER TYPE/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}}}push @{$xmltags->{FANS}},$content}sub addSnmpPowerSupply {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/MANUFACTURER REFERENCE TYPE SERIALNUMBER DESCRIPTION REVISION/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}}}push @{$xmltags->{POWERSUPPLIES}},$content}sub addSnmpSwitch {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/MANUFACTURER REFERENCE TYPE SOFTVERSION FIRMVERSION SERIALNUMBER REVISION DESCRIPTION/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}}}push @{$xmltags->{SWITCHS}},$content}sub addSnmpLocalPrinter {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/NAME/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}}}push @{$xmltags->{LOCALPRINTERS}},$content}sub addSnmpInput {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/DESCRIPTION TYPE/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}}}push @{$xmltags->{INPUTS}},$content}sub addSnmpCPU {my ($self,$args)=@_;my$xmltags=$self->{xmltags};my$content={};for my$key (qw/MANUFACTURER TYPE SPEED/){if (exists$args->{$key}){$content->{$key}[0]=$args->{$key}}}push @{$xmltags->{CPUS}},$content}sub padSnmpMacAddress {my ($self,$mac)=@_;my@splitedAddr=split(':',$mac);for (@splitedAddr){unless ($_ =~ /\w{2}/){$_=sprintf("%02s",$_)}}$mac=join (':',@splitedAddr);return$mac}sub cleanXml {my ($self,$content)=@_;my$logger=$self->{logger};my$clean_content=encode('UTF-8',$content,Encode::FB_DEFAULT | Encode::LEAVE_SRC | Encode::FB_XMLCREF);$logger->debug("cleanXml changed content")if ($content ne $clean_content);return$clean_content."\n"}sub readXml {my ($self,$xml,$forcearray)=@_;my$logger=$self->{logger};my$content=XML::Simple::XMLin($xml,ForceArray=>[@{$forcearray}]);for my$key (keys %$content){if (grep(/^$key$/,@{$forcearray})){$self->parseXmlArray($content->{$key},$forcearray)}else {if (ref ($content->{$key})=~ /^HASH$/ &&!keys %{$content->{$key}}){$content->{$key}=''}else {encode('UTF-8',$content->{$key},Encode::FB_DEFAULT)}}}return$content}sub parseXmlArray {my ($self,$array,$forcearray)=@_;for my$hash (@{$array}){for my$key (keys %$hash){if (grep (/^$key$/,@$forcearray)){$self->parseXmlArray($hash->{$key},$forcearray)}else {if (ref ($hash->{$key})=~ /^HASH$/ &&!keys %{$hash->{$key}}){$hash->{$key}=''}else {encode('UTF-8',$hash->{$key},Encode::FB_DEFAULT)}}}}}sub convertVersion {my ($self,$version,$length)=@_;$version =~ s/\.//g;my$ver_length=length ($version);if ($ver_length > $length){$version=substr$version,0,$length}elsif ($ver_length < $length){$version=substr($version .(0 x $length),0,$length)}return$version}sub get_sysprofile_devices_names {my ($self,$type)=@_;return(undef)unless -r '/usr/sbin/system_profiler';my$output=`system_profiler $type`;my$name;my$names=[];for(split /\n/,$output){next if m/^\s*$/ || m/^\w/;if(m/^\s{4}\w/){$name=$_;$name =~ s/^\s+//;$name =~ s/:.*$//;push(@$names,$name)}}return$names}sub getDmidecodeInfos {my@dmidecode=`dmidecode`;my ($info,$block,$type);for my$line (@dmidecode){chomp$line;if ($line =~ /DMI type (\d+)/){if ($block){push (@{$info->{$type}},$block);undef$block}$type=$1;next}next unless defined$type;next unless$line =~ /^\s+ ([^:]+) : \s (.*\S)/x;next if $2 eq 'N/A' || $2 eq 'Not Specified' || $2 eq 'Not Present' || $2 eq 'Unknown' || $2 eq '<BAD INDEX>' || $2 eq '<OUT OF SPEC>' || $2 eq '<OUT OF SPEC><OUT OF SPEC>';$block->{$1}=$2}if ($block){push(@{$info->{$type}},$block)}return if keys %{$info}< 2;return$info}sub can_run {my$self=shift;my$binary=shift;my$logger=$self->{logger};my$calling_namespace=caller(0);chomp(my$binpath=`which $binary 2>/dev/null`);return unless -x $binpath;$self->{logger}->debug(" - $binary found");1}sub can_load {my$self=shift;my$module=shift;my$logger=$self->{logger};my$calling_namespace=caller(0);eval "package $calling_namespace; use $module;";return if $@;$self->{logger}->debug(" - $module loaded");1}sub can_read {my$self=shift;my$file=shift;my$logger=$self->{logger};return unless -r $file;$self->{logger}->debug(" - $file can be read");1}sub runcmd {my$self=shift;my$cmd=shift;my$logger=$self->{logger};return unless$cmd;return `$cmd`}sub get_path{my$self=shift;my$binary=shift;my$path;my@bin_directories=qw { /usr/local/sbin/ /sbin/ /usr/sbin/ /bin/ /usr/bin/ /usr/local/bin/ /etc/ocsinventory-client/};print "\n=> retrieving $binary...\n" if$::debug;for (@bin_directories){$path=$_.$binary,last if -x $_.$binary}if ($path){print "=> $binary is at $path\n\n" if$::debug}else {print "$binary not found (Maybe it is not installed ?) - Some functionnalities may lack !!\n\n"}return$path}sub already_in_array {my$self=shift;my$lookfor=shift;my@array=@_;for (@array){if ($lookfor eq $_){return 1 }}return 0}1;