package Ocsinventory::Agent::Modules::Snmp;use strict;no strict 'refs';use warnings;use XML::Simple;use Digest::MD5;sub new {my$name="snmp";my (undef,$context)=@_;my$self={};$self->{logger}=new Ocsinventory::Logger ({config=>$context->{config}});$self->{logger}->{header}="[$name]";$self->{common}=$context->{common};$self->{context}=$context;$self->{structure}={name=>$name,start_handler=>$name."_start_handler",prolog_writer=>undef,prolog_reader=>$name."_prolog_reader",inventory_handler=>undef,end_handler=>$name."_end_handler",};$self->{number_scan}=0;$self->{snmp_oid_run}=$name."_oid_run";$self->{snmp_oid_xml}=$name."_oid_xml";$self->{func_oid}={};$self->{snmp_dir}=[];$self->{snmp_vardir}=["$self->{context}->{installpath}/snmp/mibs/local/","$self->{context}->{installpath}/snmp/mibs/remote/"];my$spec_dir_snmp="Ocsinventory/Agent/Modules/Snmp/";$self->{spec_dir_snmp}=$spec_dir_snmp;$self->{spec_module_snmp}="Ocsinventory::Agent::Modules::Snmp::";for my$dir (@INC){my$res_dir=$dir."/".$spec_dir_snmp;if (-d $res_dir){push(@{$self->{snmp_dir}},$res_dir)}}$self->{inventory}={};bless$self}sub snmp_start_handler {my$self=shift;my$logger=$self->{logger};my$common=$self->{context}->{common};my$config=$self->{context}->{config};$logger->debug("Calling snmp_start_handler");if ($config->{stdout}|| $config->{local}){$self->{disabled}=1;$logger->info("Agent is running in local mode...disabling module")}unless ($common->can_load('Net::SNMP')){$self->{disabled}=1;$logger->error("Net::SNMP perl module is missing !!");$logger->error("Humm my prerequisites are not OK...disabling module :( :(")}}sub snmp_prolog_reader {my ($self,$prolog)=@_;my$logger=$self->{logger};my$network=$self->{context}->{network};my$snmp_vardir=$self->{snmp_vardir};my$option;$logger->debug("Calling snmp_prolog_reader");$prolog=XML::Simple::XMLin($prolog,ForceArray=>['OPTION','PARAM']);for$option (@{$prolog->{OPTION}}){if ($option->{NAME}=~/snmp/i){$self->{doscans}=1 ;for (@{$option->{PARAM}}){if ($_->{'TYPE'}eq 'DEVICE'){push @{$self->{netdevices}},{IPADDR=>$_->{IPADDR},MACADDR=>$_->{MACADDR},}}if ($_->{'TYPE'}eq 'COMMUNITY'){push @{$self->{communities}},{VERSION=>$_->{VERSION},NAME=>$_->{NAME},USERNAME=>$_->{USERNAME},AUTHPROTO=>$_->{AUTHPROTO},AUTHPASSWD=>$_->{AUTHPASSWD},PRIVPROTO=>$_->{PRIVPROTO},PRIVPASSWD=>$_->{PRIVPASSWD}}}if ($_->{'TYPE'}eq 'NETWORK'){push @{$self->{nets_to_scan}},$_->{SUBNET}}mkdir($self->{context}->{installpath}."/snmp")unless -d $self->{context}->{installpath}."/snmp";mkdir($self->{context}->{installpath}."/snmp/mibs")unless -d $self->{context}->{installpath}."/snmp/mibs";for my$dir (@{$snmp_vardir}){mkdir($dir)unless -d $dir}}}}}sub snmp_end_handler {my$self=shift;my$logger=$self->{logger};my$common=$self->{context}->{common};my$network=$self->{context}->{network};$logger->debug("Calling snmp_end_handler");return unless$self->{doscans};$common->flushXMLTags();my$config=$self->{context}->{config};my$communities=$self->{communities};if (!defined ($communities)){$logger->debug("We have no Community from server, we use default public community");$communities=[{VERSION=>"2c",NAME=>"public"}]}my ($name,$comm,$error,$system_oid);my$snmp_sysname="1.3.6.1.2.1.1.5.0";my$snmp_sysdescr="1.3.6.1.2.1.1.1.0";my$snmp_syslocation="1.3.6.1.2.1.1.6.0";my$snmp_sysuptime="1.3.6.1.2.1.1.3.0";my$snmp_sysobjectid="1.3.6.1.2.1.1.2.0";my$snmp_syscontact="1.3.6.1.2.1.1.4.0";my$snmp_macaddr="1.3.6.1.2.1.2.2.1.6.";my$snmp_ifdescr="1.3.6.1.2.1.2.2.1.2.";my$snmp_iftype="1.3.6.1.2.1.2.2.1.3";my$snmp_inventory=$self->{inventory};$snmp_inventory->{xmlroot}->{QUERY}=['SNMP'];$snmp_inventory->{xmlroot}->{DEVICEID}=[$self->{context}->{config}->{deviceid}];$logger->debug("Snmp: Scanning network");my$nets_to_scan=$self->{nets_to_scan};for my$net_to_scan (@$nets_to_scan){$self->snmp_ip_scan($net_to_scan)}$logger->debug("Snmp: Ending Scanning network");my$ip=$self->{netdevices};for my$device (@$ip){my$session=undef;my$full_oid=undef;my$devicedata=$common->{xmltags};$logger->debug("Scanning $device->{IPADDR} device");LIST_SNMP: foreach$comm (@$communities){if ($comm->{VERSION}eq "3"){($session,$error)=Net::SNMP->session(-retries=>2,-timeout=>3,-version=>'snmpv'.$comm->{VERSION},-hostname=>$device->{IPADDR},-translate=>[-nosuchinstance=>0,-nosuchobject=>0],-username=>$comm->{USERNAME},-authpassword=>$comm->{AUTHPASSWD},-authprotocol=>$comm->{AUTHPROTO},-privpassword=>$comm->{PRIVPASSWD},-privprotocol=>$comm->{PRIVPROTO},);$self->{username}=$comm->{USERNAME};$self->{authpassword}=$comm->{AUTHPASSWD};$self->{authprotocol}=$comm->{AUTHPROTO};$self->{privpassword}=$comm->{PRIVPASSWD};$self->{privprotocol}=$comm->{PRIVPROTO}}else {($session,$error)=Net::SNMP->session(-retries=>1,-timeout=>3,-version=>'snmpv'.$comm->{VERSION},-hostname=>$device->{IPADDR},-community=>$comm->{NAME},-translate=>[-nosuchinstance=>0,-nosuchobject=>0],)};unless (defined($session)){$logger->error("Snmp ERROR: $error")}else {$self->{snmp_session}=$session;$self->{snmp_community}=$comm->{NAME};$self->{snmp_version}=$comm->{VERSION};$full_oid=$session->get_request(-varbindlist=>[$snmp_sysobjectid]);last LIST_SNMP if (defined$full_oid);$session->close;$self->{snmp_session}=undef}}if (defined$full_oid){$full_oid=$full_oid->{$snmp_sysobjectid};$session->max_msg_size(8192);my ($constr_oid,$device_name,$description,$location,$contact,$uptime,$domain,$macaddr);$self->{number_scan}++;my$result;$result=$session->get_request(-varbindlist=>[$snmp_sysname]);if (defined ($result->{$snmp_sysname})&& length($result->{$snmp_sysname})> 0){$device_name=$result->{$snmp_sysname}}else {$device_name="Not Defined"}$result=$session->get_request(-varbindlist=>[$snmp_sysobjectid]);$full_oid=$result->{$snmp_sysobjectid};$result=$session->get_request(-varbindlist=>[$snmp_sysdescr]);$description=$result->{$snmp_sysdescr};$result=$session->get_request(-varbindlist=>[$snmp_syslocation]);$location=$result->{$snmp_syslocation};$result=$session->get_request(-varbindlist=>[$snmp_sysuptime]);$uptime=$result->{$snmp_sysuptime};$result=$session->get_request(-varbindlist=>[$snmp_syscontact]);$contact=$result->{$snmp_syscontact};my$index=$snmp_iftype;$result=$session->get_next_request(-varbindlist=>[$index]);$macaddr=undef;my$ref_iftype=3;while (!defined($macaddr)&& defined($result)&& $ref_iftype==3){for$index (keys %{$result}){if ($index =~ /1\.3\.6\.1\.2\.1\.2\.2\.1\.(\S+)\.(\S+)/){$ref_iftype=$1;my$ref_mac=$2;if ($result->{$index}==6){my$res_mac=$session->get_request(-varbindlist=>[$snmp_macaddr.$ref_mac]);if (defined ($res_mac)&& defined ($res_mac->{$snmp_macaddr.$ref_mac})&& $res_mac->{$snmp_macaddr.$ref_mac}ne ''){$macaddr=" ".$res_mac->{$snmp_macaddr.$ref_mac}}else {$result=$session->get_next_request(-varbindlist=>[$index])}}else {$result=$session->get_next_request(-varbindlist=>[$index])}}else {$result=undef}}}if (defined($macaddr)&& $macaddr =~ /^ 0x(\w{2})(\w{2})(\w{2})(\w{2})(\w{2})(\w{2})$/){$macaddr="$1:$2:$3:$4:$5:$6"}elsif (!defined($macaddr)|| $macaddr eq "endOfMibView"){if (defined ($device->{MACADDR})){$macaddr=$device->{MACADDR}}else {$macaddr=$device_name}}if (defined ($macaddr)){if ($full_oid =~ /1\.3\.6\.1\.4\.1\.(\d+)/){$system_oid=$1}my$md5=Digest::MD5->new;$md5->add($macaddr,$system_oid);my$snmpdeviceid=$md5->hexdigest;$common->setSnmpCommons({IPADDR=>$device->{IPADDR},MACADDR=>$macaddr,SNMPDEVICEID=>$snmpdeviceid,NAME=>$device_name,DESCRIPTION=>$description,CONTACT=>$contact,LOCATION=>$location,UPTIME=>$uptime,WORKGROUP=>$domain,});if ($self->{snmp_oid_run}($self,$system_oid)==1){$self->{snmp_oid_run}($self,"Default")}push @{$snmp_inventory->{xmlroot}->{CONTENT}->{DEVICE}},$devicedata}}else {$logger->debug("Failure in scanning Device $device->{IPADDR}: no snmp communication")}if (defined$session){$session->close}$self->{snmp_session}=undef;$common->flushXMLTags()}$logger->info("No more SNMP device to scan");my$content=XMLout($snmp_inventory->{xmlroot},RootName=>'REQUEST',XMLDecl=>'<?xml version="1.0" encoding="UTF-8"?>',SuppressEmpty=>undef);my$clean_content=$common->cleanXml($content);$network->sendXML({message=>$clean_content});$logger->debug("End snmp_end_handler :)")}sub snmp_ip_scan {my ($self,$net_to_scan)=@_;my$logger=$self->{logger};my$common=$self->{common};if ($common->can_load('Net::Netmask')){my$block=Net::Netmask->new($net_to_scan);my$size=$block->size()-2;my$index=1;if ($common->can_run('nmap')&& $common->can_load('Nmap::Parser')){$logger->debug("Scannig $net_to_scan with nmap");my$nmaparser=Nmap::Parser->new;$nmaparser->parsescan("nmap","-sP",$net_to_scan);for my$host ($nmaparser->all_hosts("up")){my$res=$host->addr;$logger->debug("Found $res");push(@{$self->{netdevices}},{IPADDR=>$res })unless$self->search_netdevice($res)}}elsif ($common->can_load('Net::Ping')){$logger->debug("Scanning $net_to_scan with ping");my$ping=Net::Ping->new("icmp",1);while ($index <= $size){my$res=$block->nth($index);if ($ping->ping($res)){$logger->debug("Found $res");push(@{$self->{netdevices}},{IPADDR=>$res })unless$self->search_netdevice($res)}$index++}$ping->close()}else {$logger->debug("No scan possible")}}else {$logger->debug("Net::Netmask not present: no scan possible")}}sub snmp_oid_run {my ($self,$system_oid)=@_;my$logger=$self->{logger};my$session=$self->{snmp_session};my$spec_module_snmp=$self->{spec_module_snmp};my$return_pm=0;unless (defined ($self->{func_oid}{$system_oid})){my$spec_dir_snmp=$self->{spec_dir_snmp};$self->{func_oid}{$system_oid}={};$self->{func_oid}{$system_oid}{active}=0;$self->{func_oid}{$system_oid}{oid_value}="1.3.6.1.2.1.1.2.0";$self->{func_oid}{$system_oid}{oid_name}="Undefined";for my$dir (@{$self->{snmp_dir}}){if (-r $dir.$system_oid.".pm"){my$module_found=$spec_module_snmp.$system_oid;eval "use $module_found";if ($@){$logger->debug ("Failed to load $module_found: $@")}else {my$package=$module_found."::";$self->{func_oid}{$system_oid}{snmp_run}=$package->{'snmp_run'};if (defined ($package->{'snmp_info'})){my$return_info=&{$package->{'snmp_info'}};if (defined$return_info->{oid_value}){$self->{func_oid}{$system_oid}{oid_value}=$return_info->{oid_value}}if (defined$return_info->{oid_name}){$self->{func_oid}{$system_oid}{oid_name}=$return_info->{oid_name}}}$self->{func_oid}{$system_oid}{active}=1;$self->{func_oid}{$system_oid}{last_exec}=0}}}}if ($self->{func_oid}{$system_oid}{active}==1 && $self->{func_oid}{$system_oid}{last_exec}< $self->{number_scan}){my$oid_scan=$self->{func_oid}{$system_oid}{oid_value};my$result=$session->get_request(-varbindlist=>[$oid_scan ]);$self->{func_oid}{$system_oid}{last_exec}=$self->{number_scan};if (defined ($result)&& length ($result->{$oid_scan})!=0){$logger->debug("Launching $system_oid\n");&{$self->{func_oid}{$system_oid}{snmp_run}}($session,$self)}else {$return_pm=1}}my$return_xml=snmp_oid_xml($self,$system_oid);if ($return_pm==1){return(1)}return($return_xml)}sub snmp_oid_xml {my ($self,$system_oid)=@_;my$logger=$self->{logger};my$spec_module_snmp=$self->{spec_module_snmp};my$snmp_vardir=$self->{snmp_vardir};if (!defined ($self->{xml_oid}{$system_oid})){$self->{xml_oid}{$system_oid}={};$self->{xml_oid}{$system_oid}{active}=0;for my$dir (@{$self->{snmp_vardir}}){if ($self->{xml_oid}{$system_oid}{active}==0){if (-r $dir.$system_oid.".xml"){if ($self->{xml_oid}{$system_oid}{xml_data}=XML::Simple::XMLin($dir.$system_oid.".xml",ForceArray=>1)){$logger->debug("Load module xml $system_oid");$self->{xml_oid}{$system_oid}{active}=1;$self->{xml_oid}{$system_oid}{last_exec}=0;if (defined($self->{xml_oid}{$system_oid}{PARAMETERS}[0]{NAME}[0])){$self->{xml_oid}{$system_oid}{oid_name}=$self->{xml_oid}{$system_oid}{PARAMETERS}[0]{NAME}[0]}}else {$logger->debug ("Failed to load xml $system_oid: $@");$self->{xml_oid}{$system_oid}{active}=0}}}}}if ($self->{xml_oid}{$system_oid}{active}==1 && $self->{xml_oid}{$system_oid}{last_exec}< $self->{number_scan}){$logger->debug ("Begin xml on $system_oid");$self->{xml_oid}{$system_oid}{last_exec}=$self->{number_scan};if (xml_scan_v1($self,$system_oid,$self->{xml_oid}{$system_oid}{xml_data})==1){$self->{xml_oid}{$system_oid}{active}=0;return 1}return 0}return 1}sub xml_scan_v1 {my ($self,$system_oid,$xml)=@_;my$xmltags=$self->{context}->{common}->{xmltags};my$logger=$self->{logger};return 1 if (xml_parameters_v1($self,$system_oid,$xml)==1);if (!defined ($xmltags)){$xmltags={}}$logger->debug("Begin scanning v1 on $system_oid");my$filters=[];if (defined ($xml->{LOOPS})){return 1 if (xml_loops_v1($self,$xml->{LOOPS},$xmltags,$filters)==1)}if (defined ($xml->{DATA})){return 1 if (xml_data_v1($self,$xml->{DATA}[0],$xmltags,$filters,0)==1)}return 0}sub xml_parameters_v1 {my ($self,$system_oid,$xml)=@_;my$logger=$self->{logger};$logger->debug("Validating xml parameters");return 1 if (!defined($xml->{PARAMETERS}));return 0 if (!defined($xml->{PARAMETERS}[0]{EXECUTE}));$logger->debug("Begin looking other scan");for my$type_exec ("RUN","XML"){if (defined($xml->{PARAMETERS}[0]{EXECUTE}[0]{$type_exec})){my$liste_exec=$xml->{PARAMETERS}[0]{EXECUTE}[0]{$type_exec};my$lower_type_exec=lc($type_exec);for my$exec_perl (@{$liste_exec}){my$a_exec="snmp_oid_".$lower_type_exec;$self->{$a_exec}($self,$exec_perl)}}}return 0}sub xml_loops_v1 {my ($self,$xml_loops,$result_table,$filters)=@_;my$session=$self->{snmp_session};my$logger=$self->{logger};ALL_LOOPS: foreach my$uniq_loops (@{$xml_loops}){if (!defined ($uniq_loops->{VALUE})||!defined($uniq_loops->{INDEX})||!defined($uniq_loops->{NAME_INDEX})){$logger->debug("Error in xml File: VALUE, INDEX or NAME_INDEX not defined");return 1 }my$data_value=$uniq_loops->{VALUE}[0];my$index_value=$uniq_loops->{INDEX}[0];for my$filter (@{$filters}){$data_value=~s/$filter->{NAME}/$filter->{VALUE}/g;$index_value=~s/$filter->{NAME}/$filter->{VALUE}/g}my$index_equipement=$session->get_entries(-columns=>[$data_value ]);next ALL_LOOPS if (!defined ($index_equipement));my$nbr_data=0;for my$uniq_index_equipement (keys %{$index_equipement}){if (defined ($uniq_loops->{FILTER})&&!$index_equipement->{$uniq_index_equipement}=~ /$uniq_loops->{FILTER}[0]/){delete$index_equipement->{$uniq_index_equipement}}elsif ($uniq_index_equipement =~ /$index_value/){push(@{$filters},{VALUE=>$1,NAME=>$uniq_loops->{NAME_INDEX}[0]});return 1 if (xml_data_v1($self,$uniq_loops->{DATA}[0],$result_table,$filters,$nbr_data++)==1);pop(@{$filters})}}}return 0}sub xml_data_v1 {my ($self,$xml_table,$result_table,$filters,$pos_table)=@_;my$logger=$self->{logger};for my$table (keys %{$xml_table}){if ($table eq "DATA"){for my$subtable (@{$xml_table->{DATA}}){if (!defined$result_table->{$subtable}[0]){$result_table->{$subtable}[0]={}}return 1 if (xml_data_v1($self,$xml_table->{$subtable},$filters,$result_table->[0]{$subtable}[0],0)==1)}}elsif ($table eq "LOOPS"){return 1 if (xml_loops_v1($self,$xml_table->{LOOPS},$xml_table,$filters)==1)}else {for my$line (keys %{$xml_table->{$table}[0]}){if ($line eq "LOOPS"){if (!defined ($result_table->{$table}[$pos_table])){$result_table->{$table}[$pos_table]={}}return 1 if (xml_loops_v1($self,$xml_table->{$table}[0]{LOOPS},$result_table->{$table}[$pos_table],$filters)==1)}else {my$result=xml_line_v1($self,$xml_table->{$table}[0]{$line}[0],$filters);if (defined ($result)){$result_table->{$table}[$pos_table]{$line}[0]=$result}}}}}return 0}sub xml_line_v1 {my ($self,$xml_line,$filters)=@_;my$session=$self->{snmp_session};return undef if (!defined ($xml_line));if (defined ($xml_line->{SET})){return($xml_line->{SET}[0])}return undef if (!defined ($xml_line->{VALUE}));my$data_value=$xml_line->{VALUE}[0];for my$filter (@{$filters}){$data_value=~s/$filter->{NAME}/$filter->{VALUE}/g}my$info_equipment=$session->get_request(-varbindlist=>[$data_value]);return undef if (!defined ($info_equipment));$info_equipment=$info_equipment->{$data_value};return undef if (!defined ($info_equipment)|| $info_equipment eq "");return undef if (defined ($xml_line->{FILTER})&&!($info_equipment =~ /$xml_line->{FILTER}[0]/));return$info_equipment if (!defined ($xml_line->{REPLACE}));for my$replace (@{$xml_line->{REPLACE}}){return undef if (!defined($replace->{STRING})||!defined ($replace->{BY}));$info_equipment=~s/$replace->{STRING}[0]/$replace->{BY}[0]/g}return$info_equipment}sub search_netdevice {my ($self,$ip)=@_ ;for (@{$self->{netdevices}}){if ($ip =~ /^$_->{IPADDR}$/){return 1}}}1;