package Ocsinventory::Agent::XML::Inventory;use strict;use warnings;use XML::Simple;use Digest::MD5 qw(md5_base64);use Config;use Ocsinventory::Agent::Backend;sub new {my (undef,$params)=@_;my$self={};$self->{accountinfo}=$params->{context}->{accountinfo};$self->{accountconfig}=$params->{context}->{accountconfig};$self->{backend}=$params->{backend};$self->{common}=$params->{context}->{common};my$logger=$self->{logger}=$params->{context}->{logger};$self->{config}=$params->{context}->{config};if (!($self->{config}{deviceid})){$logger->fault ('deviceid unititalised!')}$self->{xmlroot}{QUERY}=['INVENTORY'];$self->{xmlroot}{DEVICEID}=[$self->{config}->{deviceid}];$self->{isInitialised}=undef;bless$self}sub initialise {my ($self)=@_;return if$self->{isInitialised};$self->{backend}->feedInventory ({inventory=>$self});$self->{isInitialised}=1}sub getContent {my ($self,$args)=@_;my$logger=$self->{logger};my$common=$self->{common};if ($self->{isInitialised}){$self->processChecksum();my$macaddr=$self->{xmlroot}->{CONTENT}->{NETWORKS}->[0]->{MACADDR}->[0];my$ssn=$self->{xmlroot}->{CONTENT}->{BIOS}->{SSN}->[0];my$name=$self->{xmlroot}->{CONTENT}->{HARDWARE}->{NAME}->[0];my$missing;$missing .= "MAC-address " unless$macaddr;$missing .= "SSN " unless$ssn;$missing .= "HOSTNAME " unless$name;if ($missing){$logger->debug('Missing value(s): '.$missing.'. I will send this inventory to the server BUT important value(s) to identify the computer are missing')}$self->{accountinfo}->setAccountInfo($self);my$content=XMLout($self->{xmlroot},RootName=>'REQUEST',XMLDecl=>'<?xml version="1.0" encoding="UTF-8"?>',SuppressEmpty=>undef);my$clean_content=$common->cleanXml($content);$common->flushXMLTags();return$clean_content}}sub printXML {my ($self,$args)=@_;if ($self->{isInitialised}){print$self->getContent()}}sub writeXML {my ($self,$args)=@_;my$logger=$self->{logger};if ($self->{config}{local}=~ /^$/){$logger->fault ('local path unititalised!')}if ($self->{isInitialised}){my$localfile=$self->{config}{local}."/".$self->{config}{deviceid}.'.ocs';$localfile =~ s!(//){1,}!/!;if (open OUT,">$localfile"){print OUT$self->getContent();close OUT or warn;$logger->info("Inventory saved in $localfile")}else {warn "Can't open `$localfile': $!"}}}sub processChecksum {my$self=shift;my$logger=$self->{logger};my$common=$self->{common};my%mask=('HARDWARE'=>1,'BIOS'=>2,'MEMORIES'=>4,'SLOTS'=>8,'REGISTRY'=>16,'CONTROLLERS'=>32,'MONITORS'=>64,'PORTS'=>128,'STORAGES'=>256,'DRIVES'=>512,'INPUT'=>1024,'MODEMS'=>2048,'NETWORKS'=>4096,'PRINTERS'=>8192,'SOUNDS'=>16384,'VIDEOS'=>32768,'SOFTWARES'=>65536,'VIRTUALMACHINES'=>131072,'CPUS'=>262144,'BATTERIES'=>1048576,);if (!$self->{config}->{vardir}){$logger->fault ("vardir uninitialised!")}my$checksum=0;if (!$self->{config}{local}&& $self->{config}->{last_statefile}){if (-f $self->{config}->{last_statefile}){$self->{last_state_content}=XML::Simple::XMLin($self->{config}->{last_statefile},SuppressEmpty=>undef,ForceArray=>1)}else {$logger->debug ('last_state file: `'.$self->{config}->{last_statefile}."' doesn't exist (yet).")}}for my$section (keys%mask){my$hash=md5_base64(XML::Simple::XMLout($self->{xmlroot}{'CONTENT'}{$section}));if (!$self->{last_state_content}->{$section}[0]|| $self->{last_state_content}->{$section}[0]ne $hash){$logger->debug ("Section $section has changed since last inventory");$checksum |= $mask{$section};$self->{last_state_content}->{$section}[0]=$hash}}$common->setHardware({CHECKSUM=>$checksum})}sub saveLastState {my ($self,$args)=@_;my$logger=$self->{logger};if (!defined($self->{last_state_content})){$self->processChecksum()}if (!defined ($self->{config}->{last_statefile})){$logger->debug ("Can't save the last_state file. File path is not initialised.");return}if (open LAST_STATE,">".$self->{config}->{last_statefile}){print LAST_STATE my$string=XML::Simple::XMLout($self->{last_state_content},RootName=>'LAST_STATE');;close LAST_STATE or warn}else {$logger->debug ("Cannot save the checksum values in ".$self->{config}->{last_statefile}.":$!")}}sub addSection {my ($self,$args)=@_;my$logger=$self->{logger};my$multi=$args->{multi};my$tagname=$args->{tagname};for (keys %{$self->{xmlroot}{CONTENT}}){if ($tagname eq $_){$logger->debug("Tag name `$tagname` already exists - Don't add it");return 0}}if ($multi){$self->{xmlroot}{CONTENT}{$tagname}=[]}else {$self->{xmlroot}{CONTENT}{$tagname}={}}return 1}sub feedSection{my ($self,$args)=@_;my$tagname=$args->{tagname};my$values=$args->{data};my$logger=$self->{logger};my$found=0;for (keys %{$self->{xmlroot}{CONTENT}}){$found=1 if$tagname eq $_}if (!$found){$logger->debug("Tag name `$tagname` doesn't exist - Cannot feed it");return 0}if ($self->{xmlroot}{CONTENT}{$tagname}=~ /ARRAY/){push @{$self->{xmlroot}{CONTENT}{$tagname}},$args->{data}}else {$self->{xmlroot}{CONTENT}{$tagname}=$values}return 1}1;