package Proc::Daemon;use strict;use POSIX();$Proc::Daemon::VERSION='0.23';sub new {my ($class,%args)=@_;my$self=\%args;bless($self,$class);$self->{memory}={};return$self}sub Init {my Proc::Daemon$self=shift;my$settings_ref=shift;unless (ref($self)&& eval{$self->isa('Proc::Daemon')}){$self=ref($self)eq 'HASH' ? Proc::Daemon->new(%$self): Proc::Daemon->new()}elsif (ref($settings_ref)eq 'HASH'){map {$self->{$_ }=$$settings_ref{$_ }}keys %$settings_ref}my$FH_MEMORY;unless (open($FH_MEMORY,"+>",undef)|| $self->{pid_file}){die "Can not <open> anonymous temporary pidfile ('$!'), therefore you must add 'pid_file' as an Init() argument, e.g. to: '/tmp/proc_daemon_pids'"}my%dont_close_fd;if (defined$self->{dont_close_fd}){die "The argument 'dont_close_fd' must be arrayref!" if ref($self->{dont_close_fd})ne 'ARRAY';for (@{$self->{dont_close_fd}}){die "All entries in 'dont_close_fd' must be numeric ('$_')!" if $_ =~ /\D/;$dont_close_fd{$_ }=1}}if (defined$self->{dont_close_fh}){die "The argument 'dont_close_fh' must be arrayref!" if ref($self->{dont_close_fh})ne 'ARRAY';for (@{$self->{dont_close_fh}}){if (defined (my$fn=fileno $_)){$dont_close_fd{$fn }=1}}}my@exec_command=ref($self->{exec_command})eq 'ARRAY' ? @{$self->{exec_command}}: ($self->{exec_command});$#exec_command=0 if $#exec_command < 0;for my$exec_command (@exec_command){$self->adjust_settings();my$pid=Fork();if (defined$pid && $pid==0){die "Can't <chdir> to $self->{work_dir}: $!" unless chdir$self->{work_dir};$self->{_orig_umask}=umask;umask($self->{file_umask});die "Cannot detach from controlling terminal" if POSIX::setsid()< 0;$pid=Fork();if (defined$pid && $pid==0){my$hc_fd;close$FH_MEMORY;for (0 .. OpenMax()){unless ($dont_close_fd{$_ }){if ($_==0){close STDIN}elsif ($_==1){close STDOUT}elsif ($_==2){close STDERR}else {$hc_fd=$_ if POSIX::close($_)}}}POSIX::setgid($self->{setgid})if defined$self->{setgid};POSIX::setuid($self->{setuid})if defined$self->{setuid};open(STDIN,$self->{child_STDIN}|| "</dev/null")unless$dont_close_fd{0 };open(STDOUT,$self->{child_STDOUT}|| "+>/dev/null")unless$dont_close_fd{1 };open(STDERR,$self->{child_STDERR}|| "+>/dev/null")unless$dont_close_fd{2 };if ($hc_fd){my@fh;for (3 .. $hc_fd){open$fh[$_ ],"</dev/null"}}umask$self->{_orig_umask};if ($exec_command){exec ($exec_command)or die "couldn't exec $exec_command: $!";exit}return$pid}$pid ||= '';if ($FH_MEMORY){print$FH_MEMORY "$pid\n";close$FH_MEMORY}if ($self->{pid_file}){open(my$FH_PIDFILE,"+>",$self->{pid_file})|| die "Can not open pidfile (pid_file => '$self->{pid_file}'): $!";print$FH_PIDFILE $pid;close$FH_PIDFILE}POSIX::_exit(0)}waitpid($pid,0)}exit 0 unless defined wantarray;my@pid;if ($FH_MEMORY){seek($FH_MEMORY,0,0);@pid=map {chomp $_;$_ eq '' ? undef : $_}<$FH_MEMORY>;$_=(/^(\d+)$/)[0]foreach@pid;close$FH_MEMORY}elsif ($self->{memory}{pid_file}){for (keys %{$self->{memory}{pid_file}}){open($FH_MEMORY,"<",$_)|| die "Can not open pid_file '<$_': $!";push(@pid,<$FH_MEMORY>);close$FH_MEMORY}}return (wantarray ? @pid : $pid[0])}*init=\&Init;sub adjust_settings {my Proc::Daemon$self=shift;$self->{work_dir}||= '/';$self->fix_filename('child_STDIN',1)if$self->{child_STDIN};$self->fix_filename('child_STDOUT',1)if$self->{child_STDOUT};$self->fix_filename('child_STDERR',1)if$self->{child_STDERR};if ($self->{pid_file}){die "Pidfile (pid_file => '$self->{pid_file}') can not be only a number. I must be able to distinguish it from a PID number in &get_pid('...')." if$self->{pid_file}=~ /^\d+$/;$self->fix_filename('pid_file')}$self->{file_umask}||= 066;return}sub fix_filename {my Proc::Daemon$self=shift;my$key=shift;my$var=$self->{$key };my$mode=(shift)? ($var =~ s/^([\+\<\>\-\|]+)// ? $1 : ($key eq 'child_STDIN' ? '<' : '+>')): '';if ($var =~ s/^\.\/// || $var !~ /\//){$var=$self->{work_dir}=~ /\/$/ ? $self->{work_dir}.$var : $self->{work_dir}.'/' .$var}if ($self->{memory}{$key }{$var }){$var =~ s/([^\/]+)$//;my@i=split(/\./,$1);my$j=$#i ? $#i - 1 : 0;$self->{memory}{"$key\_num" }||= 0;$i[$j ]=~ s/_$self->{memory}{ "$key\_num" }$//;$self->{memory}{"$key\_num" }++;$i[$j ].= '_' .$self->{memory}{"$key\_num" };$var .= join('.',@i)}$self->{memory}{$key }{$var }=1;$self->{$key }=$mode .$var;return}sub Fork {my$pid;my$loop=0;FORK: {if (defined($pid=fork)){return$pid}if ($loop < 6 && ($!==POSIX::EAGAIN()|| $!==POSIX::ENOMEM())){$loop++;sleep 5;redo FORK}}warn "Can't fork: $!";return undef}sub OpenMax {my$openmax=POSIX::sysconf(&POSIX::_SC_OPEN_MAX);return (!defined($openmax)|| $openmax < 0)? (shift || 64): $openmax}sub Status {my Proc::Daemon$self=shift;my$pid=shift;($pid,undef)=$self->get_pid($pid);return 0 if!$pid;return (kill(0,$pid)? $pid : 0)}sub Kill_Daemon {my Proc::Daemon$self=shift;my$pid=shift;my$signal=shift || 'KILL';my$pidfile;($pid,$pidfile)=$self->get_pid($pid);return 0 if!$pid;my$killed=kill($signal,$pid);if ($killed && $pidfile){if (open(my$FH_PIDFILE,"+>",$pidfile)){print$FH_PIDFILE '0';close$FH_PIDFILE}else {warn "Can not open pidfile (pid_file => '$pidfile'): $!"}}return$killed}sub get_pid {my Proc::Daemon$self=shift;my$string=shift || '';my ($pid,$pidfile);if ($string){if ($string =~ /^(\d+)$/){$pid=$1}elsif (open(my$FH_MEMORY,"<",$string)){$pid=<$FH_MEMORY>;close$FH_MEMORY;die "I found no valid PID ('$pid') in the pidfile: '$string'" if$pid =~ /\D/s;$pid=($pid =~ /^(\d+)$/)[0];$pidfile=$string}else {$pid=$self->get_pid_by_proc_table_attr('cmndline',$string)}}if (!$pid){if ($self->{pid_file}&& open(my$FH_MEMORY,"<",$self->{pid_file})){$pid=<$FH_MEMORY>;close$FH_MEMORY;if ($pid && $pid =~ /^(\d+)$/){$pid=$1;$pidfile=$self->{pid_file}}else {$pid=undef}}if (!$pid && $self->{exec_command}){$pid=$self->get_pid_by_proc_table_attr('cmndline',$self->{exec_command})}}return ($pid,$pidfile)}sub get_pid_by_proc_table_attr {my Proc::Daemon$self=shift;my ($command,$match)=@_;my$pid;eval {require Proc::ProcessTable;my$table=Proc::ProcessTable->new()->table;for (@$table){next unless $_->$command =~ /^$match\s*$/;$pid=$_->pid;last}};warn "- Problem in get_pid_by_proc_table_attr( '$command', '$match' ):\n  $@  You may not use a command line entry to get the PID of your process.\n  This function requires Proc::ProcessTable (http://search.cpan.org/~durist/Proc-ProcessTable/) to work.\n" if $@;return$pid}1;