use strict;use warnings;use Carp;package Software::LicenseUtils;$Software::LicenseUtils::VERSION='0.103014';use File::Spec;use IO::Dir;use Module::Load;my$_v=qr/(?:v(?:er(?:sion|\.))?(?: |\.)?)/i;my@phrases=("under the same (?:terms|license) as perl $_v?6"=>[],'under the same (?:terms|license) as (?:the )?perl'=>'Perl_5','affero g'=>'AGPL_3',"GNU (?:general )?public license,? $_v?([123])"=>sub {"GPL_$_[0]"},'GNU (?:general )?public license'=>[map {"GPL_$_"}(1..3)],"GNU (?:lesser|library) (?:general )?public license,? $_v?([23])\\D"=>sub {$_[0]==2 ? 'LGPL_2_1' : $_[0]==3 ? 'LGPL_3_0' : ()},'GNU (?:lesser|library) (?:general )?public license'=>[qw(LGPL_2_1 LGPL_3_0) ],'(?:the )?2[-\s]clause (?:Free)?BSD'=>'FreeBSD','BSD license'=>'BSD','FreeBSD license'=>'FreeBSD',"Artistic license $_v?(\\d)"=>sub {"Artistic_$_[0]_0"},'Artistic license'=>[map {"Artistic_$_\_0"}(1..2)],"LGPL,? $_v?(\\d)"=>sub {$_[0]==2 ? 'LGPL_2_1' : $_[0]==3 ? 'LGPL_3_0' : ()},'LGPL'=>[qw(LGPL_2_1 LGPL_3_0) ],"GPL,? $_v?(\\d)"=>sub {"GPL_$_[0]"},'GPL'=>[map {"GPL_$_"}(1..3)],'FreeBSD'=>'FreeBSD','BSD'=>'BSD','Artistic'=>[map {"Artistic_$_\_0"}(1..2)],'MIT'=>'MIT','has dedicated the work to the Commons'=>'CC0_1_0','waiving all of his or her rights to the work worldwide under copyright law'=>'CC0_1_0',);my%meta_keys=();my%meta1_keys=();my%meta2_keys=();my%spdx_expression=();for my$lib (map {"$_/Software/License"}@INC){next unless -d $lib;for my$file (IO::Dir->new($lib)->read){next unless$file =~ m{\.pm$};eval {(my$mod=$file)=~ s{\.pm$}{};my$class="Software::License::$mod";load$class;$meta_keys{$class->meta_name }{$mod}=undef;$meta1_keys{$class->meta_name }{$mod}=undef;$meta_keys{$class->meta2_name }{$mod}=undef;$meta2_keys{$class->meta2_name }{$mod}=undef;if (defined$class->spdx_expression){$spdx_expression{$class->spdx_expression }{$class}=undef}my$name=$class->name;unshift@phrases,qr/\Q$name\E/,[$mod];if ((my$name_without_space=$name)=~ s/\s+\(.+?\)//){unshift@phrases,qr/\Q$name_without_space\E/,[$mod]}}}}sub guess_license_from_pod {my ($class,$pm_text)=@_;die "can't call guess_license_* in scalar context" unless wantarray;return unless$pm_text =~ /
    (
      =head \d \s+
      (?:licen[cs]e|licensing|copyright|legal)\b
    )
  /ixmsg;my$header=$1;if ($pm_text =~ m/
      \G
      (
        .*?
      )
      (=head\\d.*|=cut.*|)
      \z
    /ixms){my$license_text="$header$1";for (my$i=0;$i < @phrases;$i += 2){my ($pattern,$license)=@phrases[$i .. $i+1 ];$pattern =~ s{\s+}{\\s+}g unless ref$pattern eq 'Regexp';if ($license_text =~ /\b$pattern\b/i){my$match=$1;my@result=(ref$license||'')eq 'CODE' ? $license->($match): (ref$license||'')eq 'ARRAY' ? @$license : $license;return unless@result;return map {"Software::License::$_"}sort@result}}}return}sub guess_license_from_meta {my ($class,$meta_text)=@_;die "can't call guess_license_* in scalar context" unless wantarray;my ($license_text)=$meta_text =~ m{\b["']?license["']?\s*:\s*["']?([a-z_0-9]+)["']?}gm;return unless$license_text and my$license=$meta_keys{$license_text };return map {"Software::License::$_"}sort keys %$license}{no warnings 'once';*guess_license_from_meta_yml=\&guess_license_from_meta}sub guess_license_from_meta_key {my ($self,$key,$v)=@_;my$src=(!defined$v)? \%meta_keys : $v eq '1' ? \%meta1_keys : $v eq '2' ? \%meta2_keys : Carp::croak("illegal META version: $v");return unless$src->{$key};return map {"Software::License::$_"}sort keys %{$src->{$key}}}my%short_name=('GPL-1'=>'Software::License::GPL_1','GPL-2'=>'Software::License::GPL_2','GPL-3'=>'Software::License::GPL_3','LGPL-2'=>'Software::License::LGPL_2','LGPL-2.1'=>'Software::License::LGPL_2_1','LGPL-3'=>'Software::License::LGPL_3_0','LGPL-3.0'=>'Software::License::LGPL_3_0','Artistic'=>'Software::License::Artistic_1_0','Artistic-1'=>'Software::License::Artistic_1_0','Artistic-2'=>'Software::License::Artistic_2_0',);sub new_from_short_name {my ($class,$arg)=@_;Carp::croak "no license short name specified" unless defined$arg->{short_name};my$short=delete$arg->{short_name};Carp::croak "Unknow license with short name $short" unless$short_name{$short};my$lic_file=my$lic_class=$short_name{$short};$lic_file =~ s!::!/!g;require "$lic_file.pm";return$lic_class->new($arg)}sub new_from_spdx_expression {my ($class,$arg)=@_;Carp::croak "no license spdx name specified" unless defined$arg->{spdx_expression};my$spdx=delete$arg->{spdx_expression};Carp::croak "Unknow license with spdx name $spdx" unless$spdx_expression{$spdx};my ($lic_file)=my ($lic_class)=keys %{$spdx_expression{$spdx}};$lic_file =~ s!::!/!g;require "$lic_file.pm";return$lic_class->new($arg)}1;