package Test2::Tools::Mock;use strict;use warnings;use Carp qw/croak/;use Scalar::Util qw/blessed reftype weaken/;use Test2::Util qw/try/;use Test2::Util::Sub qw/gen_accessor gen_reader gen_writer/;use Test2::Mock();use base 'Exporter';our$VERSION='0.000125';our@CARP_NOT=(__PACKAGE__,'Test2::Mock');our@EXPORT=qw/mock mocked/;our@EXPORT_OK=qw{mock_obj mock_class mock_do mock_build mock_accessor mock_accessors mock_getter mock_getters mock_setter mock_setters mock_building};my%HANDLERS;my%MOCKS;my@BUILD;sub add_handler {my$class=shift;my ($for,$code)=@_;croak "Must specify a package for the mock handler" unless$for;croak "Handlers must be code referneces (got: $code)" unless$code && ref($code)eq 'CODE';push @{$HANDLERS{$for}}=>$code}sub mock_building {return unless@BUILD;return$BUILD[-1]}sub mocked {my$proto=shift;my$class=blessed($proto)|| $proto;my$set=$MOCKS{$class}|| return;pop @$set while @$set &&!defined($set->[-1]);delete$MOCKS{$class}unless @$set;return @$set}sub _delegate {my ($args)=@_;my$do=__PACKAGE__->can('mock_do');my$obj=__PACKAGE__->can('mock_obj');my$class=__PACKAGE__->can('mock_class');my$build=__PACKAGE__->can('mock_build');return$obj unless @$args;my ($proto,$arg1)=@$args;return$obj if ref($proto)&&!blessed($proto);if (blessed($proto)){return$class unless$proto->isa('Test2::Mock');return$build if$arg1 && ref($arg1)&& reftype($arg1)eq 'CODE'}return$class if$proto =~ m/(?:::|')/;return$class if$proto =~ m/^_*[A-Z]/;return$do if Test2::Mock->can($proto);if (my$sub=__PACKAGE__->can("mock_$proto")){shift @$args;return$sub}return undef}sub mock {croak "undef is not a valid first argument to mock()" if @_ &&!defined($_[0]);my$sub=_delegate(\@_);croak "'$_[0]' does not look like a package name, and is not a valid control method" unless$sub;$sub->(@_)}sub mock_build {my ($control,$sub)=@_;croak "mock_build requires a Test2::Mock object as its first argument" unless$control && blessed($control)&& $control->isa('Test2::Mock');croak "mock_build requires a coderef as its second argument" unless$sub && ref($sub)&& reftype($sub)eq 'CODE';push@BUILD=>$control;my ($ok,$err)=&try($sub);pop@BUILD;die$err unless$ok}sub mock_do {my ($meth,@args)=@_;croak "Not currently building a mock" unless@BUILD;my$build=$BUILD[-1];croak "'$meth' is not a valid action for mock_do()" if$meth =~ m/^_/ ||!$build->can($meth);$build->$meth(@args)}sub mock_obj {my ($proto)=@_;if ($proto && ref($proto)&& reftype($proto)ne 'CODE'){shift @_}else {$proto={}}my$class=_generate_class();my$control;if (@_==1 && reftype($_[0])eq 'CODE'){my$orig=shift @_;$control=mock_class($class,sub {my$c=mock_building;$c->block_load(1);$c->purge_on_destroy(1);$c->autoload(1);$orig->(@_)},)}else {$control=mock_class($class,block_load=>1,purge_on_destroy=>1,autoload=>1,@_,)}my$new=bless($proto,$control->class);$new->{'~~MOCK~CONTROL~~'}=$control;return$new}sub _generate_class {my$prefix=__PACKAGE__;for (1 .. 100){my$postfix=join '',map {chr(rand(26)+ 65)}1 .. 32;my$class=$prefix .'::__TEMP__::' .$postfix;my$file=$class;$file =~ s{::}{/}g;$file .= '.pm';next if$INC{$file};my$stash=do {no strict 'refs';\%{"${class}\::"}};next if keys %$stash;return$class}croak "Could not generate a unique class name after 100 attempts"}sub mock_class {my$proto=shift;my$class=blessed($proto)|| $proto;my@args=@_;my$void=!defined(wantarray);my$callback=sub {my ($parent)=reverse mocked($class);my$control;if (@args==1 && ref($args[0])&& reftype($args[0])eq 'CODE'){$control=Test2::Mock->new(class=>$class);mock_build($control,@args)}else {$control=Test2::Mock->new(class=>$class,@args)}if ($parent){$control->{parent}=$parent;weaken($parent->{child}=$control)}$MOCKS{$class}||= [];push @{$MOCKS{$class}}=>$control;weaken($MOCKS{$class}->[-1]);return$control};return$callback->()unless$void;my$level=0;my$caller;while (my@call=caller($level++)){next if$call[0]eq __PACKAGE__;$caller=\@call;last}my$handled;for my$handler (@{$HANDLERS{$caller->[0]}}){$handled++ if$handler->(class=>$class,caller=>$caller,builder=>$callback,args=>\@args,)}croak "mock_class should not be called in a void context without a registered handler" unless$handled}sub mock_accessors {return map {($_=>gen_accessor($_))}@_}sub mock_accessor {my ($field)=@_;return gen_accessor($field)}sub mock_getters {my ($prefix,@list)=@_;return map {("$prefix$_"=>gen_reader($_))}@list}sub mock_getter {my ($field)=@_;return gen_reader($field)}sub mock_setters {my ($prefix,@list)=@_;return map {("$prefix$_"=>gen_writer($_))}@list}sub mock_setter {my ($field)=@_;return gen_writer($field)}1;